	component DE10AG_QSYS is
		port (
			core_current1_export          : in    std_logic_vector(15 downto 0) := (others => 'X'); -- export
			core_current2_export          : in    std_logic_vector(15 downto 0) := (others => 'X'); -- export
			core_voltage1_export          : in    std_logic_vector(15 downto 0) := (others => 'X'); -- export
			core_voltage2_export          : in    std_logic_vector(15 downto 0) := (others => 'X'); -- export
			fan_speed1_export             : in    std_logic_vector(15 downto 0) := (others => 'X'); -- export
			fan_speed2_export             : in    std_logic_vector(15 downto 0) := (others => 'X'); -- export
			pin_status_export             : in    std_logic_vector(15 downto 0) := (others => 'X'); -- export
			power_in_current_export       : in    std_logic_vector(15 downto 0) := (others => 'X'); -- export
			power_in_voltage_export       : in    std_logic_vector(15 downto 0) := (others => 'X'); -- export
			temperature_board1_export     : in    std_logic_vector(15 downto 0) := (others => 'X'); -- export
			temperature_board2_export     : in    std_logic_vector(15 downto 0) := (others => 'X'); -- export
			temperature_e_tile_export     : in    std_logic_vector(15 downto 0) := (others => 'X'); -- export
			temperature_fpga_export       : in    std_logic_vector(15 downto 0) := (others => 'X'); -- export
			temperature_p_tile_export     : in    std_logic_vector(15 downto 0) := (others => 'X'); -- export
			temperature_sdm_export        : in    std_logic_vector(15 downto 0) := (others => 'X'); -- export
			clk_clk                       : in    std_logic                     := 'X';             -- clk
			pio_led_export                : out   std_logic_vector(3 downto 0);                     -- export
			pio_button_export             : in    std_logic_vector(1 downto 0)  := (others => 'X'); -- export
			pio_sw_export                 : in    std_logic_vector(1 downto 0)  := (others => 'X'); -- export
			reset_n_reset_n               : in    std_logic                     := 'X';             -- reset_n
			si5340a_i2c_export_scl_pad_io : inout std_logic                     := 'X';             -- scl_pad_io
			si5340a_i2c_export_sda_pad_io : inout std_logic                     := 'X';             -- sda_pad_io
			si5340a_oe_n_export           : out   std_logic;                                        -- export
			si5340a_rst_n_export          : out   std_logic                                         -- export
		);
	end component DE10AG_QSYS;

	u0 : component DE10AG_QSYS
		port map (
			core_current1_export          => CONNECTED_TO_core_current1_export,          --      core_current1.export
			core_current2_export          => CONNECTED_TO_core_current2_export,          --      core_current2.export
			core_voltage1_export          => CONNECTED_TO_core_voltage1_export,          --      core_voltage1.export
			core_voltage2_export          => CONNECTED_TO_core_voltage2_export,          --      core_voltage2.export
			fan_speed1_export             => CONNECTED_TO_fan_speed1_export,             --         fan_speed1.export
			fan_speed2_export             => CONNECTED_TO_fan_speed2_export,             --         fan_speed2.export
			pin_status_export             => CONNECTED_TO_pin_status_export,             --         pin_status.export
			power_in_current_export       => CONNECTED_TO_power_in_current_export,       --   power_in_current.export
			power_in_voltage_export       => CONNECTED_TO_power_in_voltage_export,       --   power_in_voltage.export
			temperature_board1_export     => CONNECTED_TO_temperature_board1_export,     -- temperature_board1.export
			temperature_board2_export     => CONNECTED_TO_temperature_board2_export,     -- temperature_board2.export
			temperature_e_tile_export     => CONNECTED_TO_temperature_e_tile_export,     -- temperature_e_tile.export
			temperature_fpga_export       => CONNECTED_TO_temperature_fpga_export,       --   temperature_fpga.export
			temperature_p_tile_export     => CONNECTED_TO_temperature_p_tile_export,     -- temperature_p_tile.export
			temperature_sdm_export        => CONNECTED_TO_temperature_sdm_export,        --    temperature_sdm.export
			clk_clk                       => CONNECTED_TO_clk_clk,                       --                clk.clk
			pio_led_export                => CONNECTED_TO_pio_led_export,                --            pio_led.export
			pio_button_export             => CONNECTED_TO_pio_button_export,             --         pio_button.export
			pio_sw_export                 => CONNECTED_TO_pio_sw_export,                 --             pio_sw.export
			reset_n_reset_n               => CONNECTED_TO_reset_n_reset_n,               --            reset_n.reset_n
			si5340a_i2c_export_scl_pad_io => CONNECTED_TO_si5340a_i2c_export_scl_pad_io, -- si5340a_i2c_export.scl_pad_io
			si5340a_i2c_export_sda_pad_io => CONNECTED_TO_si5340a_i2c_export_sda_pad_io, --                   .sda_pad_io
			si5340a_oe_n_export           => CONNECTED_TO_si5340a_oe_n_export,           --       si5340a_oe_n.export
			si5340a_rst_n_export          => CONNECTED_TO_si5340a_rst_n_export           --      si5340a_rst_n.export
		);

