// (C) 2001-2021 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.



// Your use of Altera Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Altera Program License Subscription 
// Agreement, Altera MegaCore Function License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Altera and sold by 
// Altera or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


// $Id: //acds/rel/21.1/ip/merlin/altera_merlin_router/altera_merlin_router.sv.terp#1 $
// $Revision: #1 $
// $Date: 2021/01/28 $

// -------------------------------------------------------
// Merlin Router
//
// Asserts the appropriate one-hot encoded channel based on 
// the address.
//
// Also sets the binary-encoded destination id.
// -------------------------------------------------------

`timescale 1 ns / 1 ns

// ------------------------------------------
// Generation parameters:
//    decoder_type            0 (address decoder)
//    default_channel         2
//    default_destid          22
//    default_rd_channel      -1
//    default_wr_channel      -1
//    has_default_slave       0
//    memory_aliasing_decode  0
//    output_name             DE10AG_QSYS_altera_merlin_router_1920_55m4hqi
//    pkt_addr_h              45
//    pkt_addr_l              36
//    pkt_dest_id_h           74
//    pkt_dest_id_l           70
//    pkt_protection_h        78
//    pkt_protection_l        76
//    pkt_trans_read          49
//    pkt_trans_write         48
//    slaves_info             21:00000000000000000000010:0x0:0x8:read:1:0:0:1,10:10000000000000000000000:0x10:0x20:read:1:0:0:1,22:00000000000000000000100:0x20:0x40:both:1:0:0:1,18:00000000000000000000001:0x40:0x60:both:1:0:0:1,1:01000000000000000000000:0x60:0x70:read:1:0:0:1,3:00100000000000000000000:0x70:0x80:read:1:0:0:1,13:00010000000000000000000:0x80:0x90:read:1:0:0:1,11:00001000000000000000000:0x90:0xa0:read:1:0:0:1,14:00000100000000000000000:0xa0:0xb0:read:1:0:0:1,6:00000010000000000000000:0xb0:0xc0:read:1:0:0:1,12:00000001000000000000000:0xc0:0xd0:read:1:0:0:1,9:00000000100000000000000:0xd0:0xe0:read:1:0:0:1,5:00000000010000000000000:0xe0:0xf0:read:1:0:0:1,4:00000000001000000000000:0xf0:0x100:read:1:0:0:1,0:00000000000100000000000:0x100:0x110:read:1:0:0:1,2:00000000000010000000000:0x110:0x120:read:1:0:0:1,7:00000000000001000000000:0x120:0x130:read:1:0:0:1,8:00000000000000100000000:0x130:0x140:read:1:0:0:1,20:00000000000000010000000:0x140:0x150:both:1:0:0:1,19:00000000000000001000000:0x150:0x160:both:1:0:0:1,16:00000000000000000100000:0x160:0x170:read:1:0:0:1,17:00000000000000000010000:0x170:0x180:read:1:0:0:1,15:00000000000000000001000:0x180:0x190:both:1:0:0:1
//    st_channel_w            23
//    st_data_w               97
// ------------------------------------------

module DE10AG_QSYS_altera_merlin_router_1920_55m4hqi_default_decode
  #(
     parameter DEFAULT_CHANNEL = 2,
               DEFAULT_WR_CHANNEL = -1,
               DEFAULT_RD_CHANNEL = -1,
               DEFAULT_DESTID = 22 
   )
  (output [74 - 70 : 0] default_destination_id,
   output [23-1 : 0] default_wr_channel,
   output [23-1 : 0] default_rd_channel,
   output [23-1 : 0] default_src_channel
  );

  assign default_destination_id = 
    DEFAULT_DESTID[74 - 70 : 0];

  generate
    if (DEFAULT_CHANNEL == -1) begin : no_default_channel_assignment
      assign default_src_channel = '0;
    end
    else begin : default_channel_assignment
      assign default_src_channel = 23'b1 << DEFAULT_CHANNEL;
    end
  endgenerate

  generate
    if (DEFAULT_RD_CHANNEL == -1) begin : no_default_rw_channel_assignment
      assign default_wr_channel = '0;
      assign default_rd_channel = '0;
    end
    else begin : default_rw_channel_assignment
      assign default_wr_channel = 23'b1 << DEFAULT_WR_CHANNEL;
      assign default_rd_channel = 23'b1 << DEFAULT_RD_CHANNEL;
    end
  endgenerate

endmodule


module DE10AG_QSYS_altera_merlin_router_1920_55m4hqi
(
    // -------------------
    // Clock & Reset
    // -------------------
    input clk,
    input reset,

    // -------------------
    // Command Sink (Input)
    // -------------------
    input                       sink_valid,
    input  [97-1 : 0]    sink_data,
    input                       sink_startofpacket,
    input                       sink_endofpacket,
    output                      sink_ready,

    // -------------------
    // Command Source (Output)
    // -------------------
    output                          src_valid,
    output reg [97-1    : 0] src_data,
    output reg [23-1 : 0] src_channel,
    output                          src_startofpacket,
    output                          src_endofpacket,
    input                           src_ready
);

    // -------------------------------------------------------
    // Local parameters and variables
    // -------------------------------------------------------
    localparam PKT_ADDR_H = 45;
    localparam PKT_ADDR_L = 36;
    localparam PKT_DEST_ID_H = 74;
    localparam PKT_DEST_ID_L = 70;
    localparam PKT_PROTECTION_H = 78;
    localparam PKT_PROTECTION_L = 76;
    localparam ST_DATA_W = 97;
    localparam ST_CHANNEL_W = 23;
    localparam DECODER_TYPE = 0;

    localparam PKT_TRANS_WRITE = 48;
    localparam PKT_TRANS_READ  = 49;

    localparam PKT_ADDR_W = PKT_ADDR_H-PKT_ADDR_L + 1;
    localparam PKT_DEST_ID_W = PKT_DEST_ID_H-PKT_DEST_ID_L + 1;



    // -------------------------------------------------------
    // Figure out the number of bits to mask off for each slave span
    // during address decoding
    // -------------------------------------------------------
    // -------------------------------------------------------
    // Work out which address bits are significant based on the
    // address range of the slaves. If the required width is too
    // large or too small, we use the address field width instead.
    // -------------------------------------------------------
    localparam ADDR_RANGE = 64'h190;
    localparam RANGE_ADDR_WIDTH = log2ceil(ADDR_RANGE);
    localparam OPTIMIZED_ADDR_H = (RANGE_ADDR_WIDTH > PKT_ADDR_W) ||
                                  (RANGE_ADDR_WIDTH == 0) ?
                                        PKT_ADDR_H :
                                        PKT_ADDR_L + RANGE_ADDR_WIDTH - 1;

    localparam REAL_ADDRESS_RANGE = OPTIMIZED_ADDR_H - PKT_ADDR_L;

      reg [PKT_ADDR_W-1 : 0] address;
      always @* begin
        address = {PKT_ADDR_W{1'b0}};
        address [REAL_ADDRESS_RANGE:0] = sink_data[OPTIMIZED_ADDR_H : PKT_ADDR_L];
      end   

    // -------------------------------------------------------
    // Pass almost everything through, untouched
    // -------------------------------------------------------
    assign sink_ready        = src_ready;
    assign src_valid         = sink_valid;
    assign src_startofpacket = sink_startofpacket;
    assign src_endofpacket   = sink_endofpacket;
    wire [PKT_DEST_ID_W-1:0] default_destid;
    wire [23-1 : 0] default_src_channel;




    // -------------------------------------------------------
    // Write and read transaction signals
    // -------------------------------------------------------
    wire read_transaction;
    assign read_transaction  = sink_data[PKT_TRANS_READ];


    DE10AG_QSYS_altera_merlin_router_1920_55m4hqi_default_decode the_default_decode(
      .default_destination_id (default_destid),
      .default_wr_channel   (),
      .default_rd_channel   (),
      .default_src_channel  (default_src_channel)
    );

    always @* begin
        src_data    = sink_data;
        src_channel = default_src_channel;
        src_data[PKT_DEST_ID_H:PKT_DEST_ID_L] = default_destid;

        // --------------------------------------------------
        // Address Decoder
        // Sets the channel and destination ID based on the address
        // --------------------------------------------------

        // slave 0: [0x0, 0x8) : sel [8:3]
        if ( {address[8:3],{3 {1'b0}}} == 9'h0  && read_transaction  ) begin
            src_channel = 23'b00000000000000000000010;
            src_data[PKT_DEST_ID_H:PKT_DEST_ID_L] = 21;
        end

        // slave 1: [0x10, 0x20) : sel [8:4]
        if ( {address[8:4],{4 {1'b0}}} == 9'h10  && read_transaction  ) begin
            src_channel = 23'b10000000000000000000000;
            src_data[PKT_DEST_ID_H:PKT_DEST_ID_L] = 10;
        end

        // slave 2: [0x20, 0x40) : sel [8:5]
        if ( {address[8:5],{5 {1'b0}}} == 9'h20   ) begin
            src_channel = 23'b00000000000000000000100;
            src_data[PKT_DEST_ID_H:PKT_DEST_ID_L] = 22;
        end

        // slave 3: [0x40, 0x60) : sel [8:5]
        if ( {address[8:5],{5 {1'b0}}} == 9'h40   ) begin
            src_channel = 23'b00000000000000000000001;
            src_data[PKT_DEST_ID_H:PKT_DEST_ID_L] = 18;
        end

        // slave 4: [0x60, 0x70) : sel [8:4]
        if ( {address[8:4],{4 {1'b0}}} == 9'h60  && read_transaction  ) begin
            src_channel = 23'b01000000000000000000000;
            src_data[PKT_DEST_ID_H:PKT_DEST_ID_L] = 1;
        end

        // slave 5: [0x70, 0x80) : sel [8:4]
        if ( {address[8:4],{4 {1'b0}}} == 9'h70  && read_transaction  ) begin
            src_channel = 23'b00100000000000000000000;
            src_data[PKT_DEST_ID_H:PKT_DEST_ID_L] = 3;
        end

        // slave 6: [0x80, 0x90) : sel [8:4]
        if ( {address[8:4],{4 {1'b0}}} == 9'h80  && read_transaction  ) begin
            src_channel = 23'b00010000000000000000000;
            src_data[PKT_DEST_ID_H:PKT_DEST_ID_L] = 13;
        end

        // slave 7: [0x90, 0xa0) : sel [8:4]
        if ( {address[8:4],{4 {1'b0}}} == 9'h90  && read_transaction  ) begin
            src_channel = 23'b00001000000000000000000;
            src_data[PKT_DEST_ID_H:PKT_DEST_ID_L] = 11;
        end

        // slave 8: [0xa0, 0xb0) : sel [8:4]
        if ( {address[8:4],{4 {1'b0}}} == 9'ha0  && read_transaction  ) begin
            src_channel = 23'b00000100000000000000000;
            src_data[PKT_DEST_ID_H:PKT_DEST_ID_L] = 14;
        end

        // slave 9: [0xb0, 0xc0) : sel [8:4]
        if ( {address[8:4],{4 {1'b0}}} == 9'hb0  && read_transaction  ) begin
            src_channel = 23'b00000010000000000000000;
            src_data[PKT_DEST_ID_H:PKT_DEST_ID_L] = 6;
        end

        // slave 10: [0xc0, 0xd0) : sel [8:4]
        if ( {address[8:4],{4 {1'b0}}} == 9'hc0  && read_transaction  ) begin
            src_channel = 23'b00000001000000000000000;
            src_data[PKT_DEST_ID_H:PKT_DEST_ID_L] = 12;
        end

        // slave 11: [0xd0, 0xe0) : sel [8:4]
        if ( {address[8:4],{4 {1'b0}}} == 9'hd0  && read_transaction  ) begin
            src_channel = 23'b00000000100000000000000;
            src_data[PKT_DEST_ID_H:PKT_DEST_ID_L] = 9;
        end

        // slave 12: [0xe0, 0xf0) : sel [8:4]
        if ( {address[8:4],{4 {1'b0}}} == 9'he0  && read_transaction  ) begin
            src_channel = 23'b00000000010000000000000;
            src_data[PKT_DEST_ID_H:PKT_DEST_ID_L] = 5;
        end

        // slave 13: [0xf0, 0x100) : sel [8:4]
        if ( {address[8:4],{4 {1'b0}}} == 9'hf0  && read_transaction  ) begin
            src_channel = 23'b00000000001000000000000;
            src_data[PKT_DEST_ID_H:PKT_DEST_ID_L] = 4;
        end

        // slave 14: [0x100, 0x110) : sel [8:4]
        if ( {address[8:4],{4 {1'b0}}} == 9'h100  && read_transaction  ) begin
            src_channel = 23'b00000000000100000000000;
            src_data[PKT_DEST_ID_H:PKT_DEST_ID_L] = 0;
        end

        // slave 15: [0x110, 0x120) : sel [8:4]
        if ( {address[8:4],{4 {1'b0}}} == 9'h110  && read_transaction  ) begin
            src_channel = 23'b00000000000010000000000;
            src_data[PKT_DEST_ID_H:PKT_DEST_ID_L] = 2;
        end

        // slave 16: [0x120, 0x130) : sel [8:4]
        if ( {address[8:4],{4 {1'b0}}} == 9'h120  && read_transaction  ) begin
            src_channel = 23'b00000000000001000000000;
            src_data[PKT_DEST_ID_H:PKT_DEST_ID_L] = 7;
        end

        // slave 17: [0x130, 0x140) : sel [8:4]
        if ( {address[8:4],{4 {1'b0}}} == 9'h130  && read_transaction  ) begin
            src_channel = 23'b00000000000000100000000;
            src_data[PKT_DEST_ID_H:PKT_DEST_ID_L] = 8;
        end

        // slave 18: [0x140, 0x150) : sel [8:4]
        if ( {address[8:4],{4 {1'b0}}} == 9'h140   ) begin
            src_channel = 23'b00000000000000010000000;
            src_data[PKT_DEST_ID_H:PKT_DEST_ID_L] = 20;
        end

        // slave 19: [0x150, 0x160) : sel [8:4]
        if ( {address[8:4],{4 {1'b0}}} == 9'h150   ) begin
            src_channel = 23'b00000000000000001000000;
            src_data[PKT_DEST_ID_H:PKT_DEST_ID_L] = 19;
        end

        // slave 20: [0x160, 0x170) : sel [8:4]
        if ( {address[8:4],{4 {1'b0}}} == 9'h160  && read_transaction  ) begin
            src_channel = 23'b00000000000000000100000;
            src_data[PKT_DEST_ID_H:PKT_DEST_ID_L] = 16;
        end

        // slave 21: [0x170, 0x180) : sel [8:4]
        if ( {address[8:4],{4 {1'b0}}} == 9'h170  && read_transaction  ) begin
            src_channel = 23'b00000000000000000010000;
            src_data[PKT_DEST_ID_H:PKT_DEST_ID_L] = 17;
        end

        // slave 22: [0x180, 0x190) : sel [8:4]
        if ( {address[8:4],{4 {1'b0}}} == 9'h180   ) begin
            src_channel = 23'b00000000000000000001000;
            src_data[PKT_DEST_ID_H:PKT_DEST_ID_L] = 15;
        end
    end


    // --------------------------------------------------
    // Ceil(log2()) function
    // It's the 21st century. Consider using $clog2().
    // --------------------------------------------------
    function integer log2ceil;
        input reg[65:0] val;
        reg [65:0] i;

        begin
            i = 1;
            log2ceil = 0;

            while (i < val) begin
                log2ceil = log2ceil + 1;
                i = i << 1;
            end
        end
    endfunction

endmodule


