// pcie_ed_BAR_INTERPRETER.v

// Generated using ACDS version 21.1 169

`timescale 1 ps / 1 ps
module pcie_ed_BAR_INTERPRETER (
		input  wire         Clk_i,                       //         clk.clk
		input  wire         Rstn_i,                      //       reset.reset_n
		input  wire [23:0]  bri_s_address_i,             //   bri_slave.address
		input  wire [63:0]  bri_s_byteenable_i,          //            .byteenable
		input  wire         bri_s_read_i,                //            .read
		output wire [511:0] bri_s_readdata_o,            //            .readdata
		output wire         bri_s_readdatavalid_o,       //            .readdatavalid
		input  wire         bri_s_write_i,               //            .write
		input  wire [511:0] bri_s_writedata_i,           //            .writedata
		input  wire [3:0]   bri_s_burstcount_i,          //            .burstcount
		output wire         bri_s_waitrequest_o,         //            .waitrequest
		output wire [1:0]   bri_s_response_o,            //            .response
		output wire         bri_s_writeresponse_valid_o, //            .writeresponsevalid
		output wire [27:0]  bri_m_address_o,             //  bri_master.address
		output wire         bri_m_read_o,                //            .read
		input  wire [511:0] bri_m_readdata_i,            //            .readdata
		input  wire         bri_m_readdatavalid_i,       //            .readdatavalid
		output wire         bri_m_write_o,               //            .write
		output wire [511:0] bri_m_writedata_o,           //            .writedata
		input  wire         bri_m_waitrequest_i,         //            .waitrequest
		output wire [63:0]  bri_m_byteenable_o,          //            .byteenable
		input  wire [1:0]   bri_m_response_i,            //            .response
		output wire [3:0]   bri_m_burstcount_o,          //            .burstcount
		input  wire [2:0]   bri_s_bar_i,                 // bri_conduit.barnum
		input  wire [1:0]   bri_s_pfnum_i                //            .pfnum
	);

	intel_pcie_bri_hwtcl #(
		.PFNUM_WIDTH    (2),
		.BAM_ADDR_WIDTH (24),
		.BRI_DATA_WIDTH (512)
	) bar_interpreter (
		.Clk_i                       (Clk_i),                       //   input,    width = 1,         clk.clk
		.Rstn_i                      (Rstn_i),                      //   input,    width = 1,       reset.reset_n
		.bri_s_address_i             (bri_s_address_i),             //   input,   width = 24,   bri_slave.address
		.bri_s_byteenable_i          (bri_s_byteenable_i),          //   input,   width = 64,            .byteenable
		.bri_s_read_i                (bri_s_read_i),                //   input,    width = 1,            .read
		.bri_s_readdata_o            (bri_s_readdata_o),            //  output,  width = 512,            .readdata
		.bri_s_readdatavalid_o       (bri_s_readdatavalid_o),       //  output,    width = 1,            .readdatavalid
		.bri_s_write_i               (bri_s_write_i),               //   input,    width = 1,            .write
		.bri_s_writedata_i           (bri_s_writedata_i),           //   input,  width = 512,            .writedata
		.bri_s_burstcount_i          (bri_s_burstcount_i),          //   input,    width = 4,            .burstcount
		.bri_s_waitrequest_o         (bri_s_waitrequest_o),         //  output,    width = 1,            .waitrequest
		.bri_s_response_o            (bri_s_response_o),            //  output,    width = 2,            .response
		.bri_s_writeresponse_valid_o (bri_s_writeresponse_valid_o), //  output,    width = 1,            .writeresponsevalid
		.bri_m_address_o             (bri_m_address_o),             //  output,   width = 28,  bri_master.address
		.bri_m_read_o                (bri_m_read_o),                //  output,    width = 1,            .read
		.bri_m_readdata_i            (bri_m_readdata_i),            //   input,  width = 512,            .readdata
		.bri_m_readdatavalid_i       (bri_m_readdatavalid_i),       //   input,    width = 1,            .readdatavalid
		.bri_m_write_o               (bri_m_write_o),               //  output,    width = 1,            .write
		.bri_m_writedata_o           (bri_m_writedata_o),           //  output,  width = 512,            .writedata
		.bri_m_waitrequest_i         (bri_m_waitrequest_i),         //   input,    width = 1,            .waitrequest
		.bri_m_byteenable_o          (bri_m_byteenable_o),          //  output,   width = 64,            .byteenable
		.bri_m_response_i            (bri_m_response_i),            //   input,    width = 2,            .response
		.bri_m_burstcount_o          (bri_m_burstcount_o),          //  output,    width = 4,            .burstcount
		.bri_s_bar_i                 (bri_s_bar_i),                 //   input,    width = 3, bri_conduit.barnum
		.bri_s_pfnum_i               (bri_s_pfnum_i)                //   input,    width = 2,            .pfnum
	);

endmodule
