// pcie_ed_DMA_CONTROLLER.v

// Generated using ACDS version 21.1 169

`timescale 1 ps / 1 ps
module pcie_ed_DMA_CONTROLLER (
		input  wire         Clk_i,                      //            clk.clk
		input  wire         Rstn_i,                     //          reset.reset_n
		input  wire [11:0]  dma_s_address_i,            //      dma_slave.address
		input  wire         dma_s_read_i,               //               .read
		output wire [511:0] dma_s_readdata_o,           //               .readdata
		output wire         dma_s_readdatavalid_o,      //               .readdatavalid
		input  wire         dma_s_write_i,              //               .write
		input  wire [511:0] dma_s_writedata_i,          //               .writedata
		output wire         dma_s_waitrequest_o,        //               .waitrequest
		input  wire [63:0]  dma_s_byteenable_i,         //               .byteenable
		output wire [1:0]   dma_s_response_o,           //               .response
		input  wire [3:0]   dma_s_burstcount_i,         //               .burstcount
		input  wire [11:0]  msix_table_address_i,       // dma_msix_slave.address
		input  wire         msix_table_read_i,          //               .read
		output wire [511:0] msix_table_readdata_o,      //               .readdata
		output wire         msix_table_readdatavalid_o, //               .readdatavalid
		input  wire         msix_table_write_i,         //               .write
		input  wire [511:0] msix_table_writedata_i,     //               .writedata
		output wire         msix_table_waitrequest_o,   //               .waitrequest
		input  wire [63:0]  msix_table_byteenable_i,    //               .byteenable
		input  wire [3:0]   msix_table_burstcount_i,    //               .burstcount
		input  wire [1:0]   dma_wrdm_pfnum_i,           //   wrdm_conduit.pfnum
		input  wire         dma_wrdm_desc_ready_i,      //      wrdm_desc.ready
		output wire         dma_wrdm_desc_valid_o,      //               .valid
		output wire [173:0] dma_wrdm_desc_data_o,       //               .data
		input  wire         dma_wrdm_prio_ready_i,      //      wrdm_prio.ready
		output wire         dma_wrdm_prio_valid_o,      //               .valid
		output wire [173:0] dma_wrdm_prio_data_o,       //               .data
		input  wire         dma_wrdm_tx_valid_i,        //        wrdm_tx.valid
		input  wire [31:0]  dma_wrdm_tx_data_i,         //               .data
		input  wire [1:0]   dma_rddm_pfnum_i,           //   rddm_conduit.pfnum
		input  wire         dma_rddm_desc_ready_i,      //      rddm_desc.ready
		output wire         dma_rddm_desc_valid_o,      //               .valid
		output wire [173:0] dma_rddm_desc_data_o,       //               .data
		input  wire         dma_rddm_prio_ready_i,      //      rddm_prio.ready
		output wire         dma_rddm_prio_valid_o,      //               .valid
		output wire [173:0] dma_rddm_prio_data_o,       //               .data
		input  wire         dma_rddm_tx_valid_i,        //        rddm_tx.valid
		input  wire [31:0]  dma_rddm_tx_data_i          //               .data
	);

	intel_pcie_dma_hwtcl #(
		.VFNUM_WIDTH     (11),
		.PFNUM_WIDTH     (2),
		.DESC_DATA_WIDTH (160)
	) dma_controller (
		.Clk_i                      (Clk_i),                      //   input,    width = 1,            clk.clk
		.Rstn_i                     (Rstn_i),                     //   input,    width = 1,          reset.reset_n
		.dma_s_address_i            (dma_s_address_i),            //   input,   width = 12,      dma_slave.address
		.dma_s_read_i               (dma_s_read_i),               //   input,    width = 1,               .read
		.dma_s_readdata_o           (dma_s_readdata_o),           //  output,  width = 512,               .readdata
		.dma_s_readdatavalid_o      (dma_s_readdatavalid_o),      //  output,    width = 1,               .readdatavalid
		.dma_s_write_i              (dma_s_write_i),              //   input,    width = 1,               .write
		.dma_s_writedata_i          (dma_s_writedata_i),          //   input,  width = 512,               .writedata
		.dma_s_waitrequest_o        (dma_s_waitrequest_o),        //  output,    width = 1,               .waitrequest
		.dma_s_byteenable_i         (dma_s_byteenable_i),         //   input,   width = 64,               .byteenable
		.dma_s_response_o           (dma_s_response_o),           //  output,    width = 2,               .response
		.dma_s_burstcount_i         (dma_s_burstcount_i),         //   input,    width = 4,               .burstcount
		.msix_table_address_i       (msix_table_address_i),       //   input,   width = 12, dma_msix_slave.address
		.msix_table_read_i          (msix_table_read_i),          //   input,    width = 1,               .read
		.msix_table_readdata_o      (msix_table_readdata_o),      //  output,  width = 512,               .readdata
		.msix_table_readdatavalid_o (msix_table_readdatavalid_o), //  output,    width = 1,               .readdatavalid
		.msix_table_write_i         (msix_table_write_i),         //   input,    width = 1,               .write
		.msix_table_writedata_i     (msix_table_writedata_i),     //   input,  width = 512,               .writedata
		.msix_table_waitrequest_o   (msix_table_waitrequest_o),   //  output,    width = 1,               .waitrequest
		.msix_table_byteenable_i    (msix_table_byteenable_i),    //   input,   width = 64,               .byteenable
		.msix_table_burstcount_i    (msix_table_burstcount_i),    //   input,    width = 4,               .burstcount
		.dma_wrdm_pfnum_i           (dma_wrdm_pfnum_i),           //   input,    width = 2,   wrdm_conduit.pfnum
		.dma_wrdm_desc_ready_i      (dma_wrdm_desc_ready_i),      //   input,    width = 1,      wrdm_desc.ready
		.dma_wrdm_desc_valid_o      (dma_wrdm_desc_valid_o),      //  output,    width = 1,               .valid
		.dma_wrdm_desc_data_o       (dma_wrdm_desc_data_o),       //  output,  width = 174,               .data
		.dma_wrdm_prio_ready_i      (dma_wrdm_prio_ready_i),      //   input,    width = 1,      wrdm_prio.ready
		.dma_wrdm_prio_valid_o      (dma_wrdm_prio_valid_o),      //  output,    width = 1,               .valid
		.dma_wrdm_prio_data_o       (dma_wrdm_prio_data_o),       //  output,  width = 174,               .data
		.dma_wrdm_tx_valid_i        (dma_wrdm_tx_valid_i),        //   input,    width = 1,        wrdm_tx.valid
		.dma_wrdm_tx_data_i         (dma_wrdm_tx_data_i),         //   input,   width = 32,               .data
		.dma_rddm_pfnum_i           (dma_rddm_pfnum_i),           //   input,    width = 2,   rddm_conduit.pfnum
		.dma_rddm_desc_ready_i      (dma_rddm_desc_ready_i),      //   input,    width = 1,      rddm_desc.ready
		.dma_rddm_desc_valid_o      (dma_rddm_desc_valid_o),      //  output,    width = 1,               .valid
		.dma_rddm_desc_data_o       (dma_rddm_desc_data_o),       //  output,  width = 174,               .data
		.dma_rddm_prio_ready_i      (dma_rddm_prio_ready_i),      //   input,    width = 1,      rddm_prio.ready
		.dma_rddm_prio_valid_o      (dma_rddm_prio_valid_o),      //  output,    width = 1,               .valid
		.dma_rddm_prio_data_o       (dma_rddm_prio_data_o),       //  output,  width = 174,               .data
		.dma_rddm_tx_valid_i        (dma_rddm_tx_valid_i),        //   input,    width = 1,        rddm_tx.valid
		.dma_rddm_tx_data_i         (dma_rddm_tx_data_i)          //   input,   width = 32,               .data
	);

endmodule
