// (C) 2001-2021 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


// (C) 2001-2020 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


//-----------------------------------------------------------------------------------
// This confidential and proprietary software may be used only as authorized by
// a licensing agreement from Intel
// copyright notice must be reproduced on all authorized copies.
//-----------------------------------------------------------------------------------
// Copyright (C) 2017 Intel Corporation. All rights reserved.  Intel products are
// protected under numerous U.S. and foreign patents, maskwork rights, copyrights and
// other intellectual property laws.
//-----------------------------------------------------------------------------------
//  Project Name:  wharf_rock gen4x8 256 bits @ 500MHZ to 512 bits @ 250 MHz adapter
//  Module Name :  intel_pcie_whr_gen4x8_cii_if
//  Author      :  sdsawant
//  Date        :  Wed Sep 28 16:52:43 2019
//  Description :
//-----------------------------------------------------------------------------------

module  intel_pcie_whr_gen4x8_cii_if
 #(
     parameter intended_device_family = "Stratix 10"
  )
  (
   input               clk500,
   input               rst_clk500_n,
   input               clk250,
   input               rst_clk250_n,
   input               cii_req_i,
   input               cii_hdr_poisoned_i,
   input  logic [3:0]  cii_hdr_first_be_i,
   input  logic [2:0]  cii_func_num_i,
   input  logic        cii_wr_i,
   input  logic [9:0]  cii_addr_i,
   input  logic [31:0] cii_dout_i,
   input  logic        cii_wr_vf_active_i,
   input  logic [10:0] cii_vf_num_i,
   input  logic        cii_override_en_i,
   input  logic [31:0] cii_override_din_i,
   input  logic        cii_halt_i,
   output logic        cii_req_o,
   output logic        cii_hdr_poisoned_o,
   output logic [3:0]  cii_hdr_first_be_o,
   output logic [2:0]  cii_func_num_o,
   output logic        cii_wr_o,
   output logic [9:0]  cii_addr_o,
   output logic [31:0] cii_dout_o,
   output logic        cii_wr_vf_active_o,
   output logic [10:0] cii_vf_num_o,
   output logic        cii_override_en_o,
   output logic [31:0] cii_override_din_o,
   output logic        cii_halt_o
  );

//********************************************************************
// SYNCHRONIZATION OF HIP -> APP SIGNALS
//********************************************************************
  //******************************************************************************
  // DEFINE VARIABLES
  //******************************************************************************
   logic        cii_req_sync;
   logic        load;
   logic        cii_req_q, cii_req_qq;
   logic        cii_hdr_poisoned_q;
   logic [3:0]  cii_hdr_first_be_q;
   logic [2:0]  cii_func_num_q;
   logic        cii_wr_q;
   logic [9:0]  cii_addr_q;
   logic [31:0] cii_dout_q;
   logic        cii_wr_vf_active_q;
   logic [10:0] cii_vf_num_q;

  always @(posedge clk500) begin //negedge rst_clk250_n or 
    if (rst_clk500_n == 0) begin
      cii_req_q          <= 1'b0;
      cii_req_qq         <= 1'b0;
    end
    else begin
      cii_req_q          <= cii_req_i;
      cii_req_qq         <= cii_req_q;
    end
  end

  always @(posedge clk500) begin //negedge rst_clk500_n or 
      cii_hdr_poisoned_q <= cii_hdr_poisoned_i;
      cii_hdr_first_be_q <= cii_hdr_first_be_i;
      cii_func_num_q     <= cii_func_num_i;
      cii_wr_q           <= cii_wr_i;
      cii_addr_q         <= cii_addr_i;
      cii_dout_q         <= cii_dout_i;
      cii_wr_vf_active_q <= cii_wr_vf_active_i;
      cii_vf_num_q       <= cii_vf_num_i;
  end

   intel_pcie_whr_gen4x8_sync_bit #(.DWIDTH(1), .RESET_VAL(0))
           req_sync (.clk(clk250), .rst_n(rst_clk250_n), .din(cii_req_q), .dout(cii_req_sync));

  assign load = (cii_req_sync != cii_req_o);

  always @(posedge clk250) begin //negedge rst_clk250_n or 
    if (rst_clk250_n == 0) begin
      cii_req_o <= '0;
    end
    else begin
      cii_req_o <= cii_req_sync;
    end
  end

  always @(posedge clk250) begin
    if (load == 1 & cii_req_sync == 1) begin
      cii_hdr_poisoned_o <= cii_hdr_poisoned_q;
      cii_hdr_first_be_o <= cii_hdr_first_be_q;
      cii_func_num_o     <= cii_func_num_q;
      cii_wr_o           <= cii_wr_q;
      cii_addr_o         <= cii_addr_q;
      cii_dout_o         <= cii_dout_q;
      cii_wr_vf_active_o <= cii_wr_vf_active_q;
      cii_vf_num_o       <= cii_vf_num_q;
    end
    else if (load == 1 & cii_req_sync == 0) begin
      cii_hdr_poisoned_o <= '0;
      cii_hdr_first_be_o <= '0;
      cii_func_num_o     <= '0;
      cii_wr_o           <= '0;
      cii_addr_o         <= '0;
      cii_dout_o         <= '0;
      cii_wr_vf_active_o <= '0;
      cii_vf_num_o       <= '0;
    end
  end
//********************************************************************
// SYNCHRONIZATION OF APP -> HIP SIGNALS
//********************************************************************
  //******************************************************************************
  // DEFINE VARIABLES
  //******************************************************************************

  typedef struct packed {
    logic        cii_halt;
    logic        cii_override_en;
    logic [31:0] cii_override_din;
  } cii_halt_data_t;

  logic cii_halt_data_fifo_rdreq, cii_halt_data_fifo_rdreq_q, cii_halt_data_fifo_empty, rdreq, start, rd_pfull;
  cii_halt_data_t cii_halt_data_in, cii_halt_data_out; 
  logic [3:0] cii_halt_data_rd_numdata;

  logic        cii_override_en_q;    /* synthesis preserve_syn_only */
  logic [31:0] cii_override_din_q;   /* synthesis preserve_syn_only */
  logic        cii_halt_q;           /* synthesis preserve_syn_only */
  logic        cii_halt_r, cii_halt_rr, cii_halt_rrr, cii_halt_rrrr, cii_halt_t; /* synthesis preserve_syn_only */
  logic        cii_override_en_r, cii_override_en_rr, cii_override_en_t; /* synthesis preserve_syn_only */
  logic [31:0] cii_override_din_r, cii_override_din_rr, cii_override_din_t; /* synthesis preserve_syn_only */
  logic        halt_is_zero;

  always @(posedge clk250) begin //negedge rst_clk250_n or
    cii_override_din_q <= cii_override_din_i;
  end

  always @(posedge clk250) begin //negedge rst_clk250_n or 
    if (rst_clk250_n == 1'b0) begin
      cii_override_en_q  <= cii_override_en_i;
      cii_halt_q         <= '0;
    end
    else begin
      cii_override_en_q  <= cii_override_en_i;
      cii_halt_q         <= cii_halt_i;
    end
  end

  assign cii_halt_data_in = {cii_halt_q, cii_override_en_q, cii_override_din_q};

//********************************************************************
// STORAGE
//********************************************************************
    intel_pcie_whr_gen4x8_dcfifo
    #(
      .DWIDTH ($bits(cii_halt_data_in)),
      .AWIDTH (3),
      .intended_device_family(intended_device_family)
     ) cii_halt_data_fifo
    (
     .wr_rst_n(rst_clk250_n),                         // Write Domain Active low Reset
     .wr_clk(clk250),                                 // Write Domain Clock
     .wr_en(1'b1),                                    // Write Data Enable
     .wr_data(cii_halt_data_in),                           // Write Data In
     .rd_rst_n(rst_clk500_n),                         // Read Domain Active low Reset
     .rd_clk(clk500),                                 // Read Domain Clock
     .rd_en(cii_halt_data_fifo_rdreq),                          // Read Data Enable
     .r_pempty(3'd2),                                 // FIFO partially empty threshold
     .r_pfull(3'd3),                                  // FIFO partially full threshold
     .rd_data(cii_halt_data_out),                          // Read Data Out
     .rd_numdata(),                     // Number of Data available in Read clock
     .wr_numdata(),                                   // Number of Data available in Write clock
     .wr_empty(),                                     // FIFO Empty
     .wr_pempty(),                                    // FIFO Partial Empty
     .wr_full(),                                      // FIFO Full
     .wr_pfull(),                                     // FIFO Parial Full
     .rd_empty(cii_halt_data_fifo_empty),                       // FIFO Empty
     .rd_pempty(),                                    // FIFO Partial Empty
     .rd_full(),                                      // FIFO Full
     .rd_pfull(rd_pfull)                                      // FIFO Partial Full
     );

//********************************************************************
// READ CLOCK DOMAIN
//********************************************************************
   assign cii_halt_data_fifo_rdreq = start ? rdreq : 1'b0 ;

  always @ (posedge clk500) begin //negedge rst_clk500_n or 
    if (rst_clk500_n == 0) begin
      cii_halt_r                 <= '0;
      cii_override_en_r          <= '0;
      start                      <= '0;
      rdreq                      <= '0;
      cii_halt_data_fifo_rdreq_q <= '0;
      cii_halt_rr                <= '0;
      cii_halt_rrr               <= '0;
      cii_halt_rrrr              <= '0;
      cii_override_en_rr         <= '0;
    end
    else begin
      if(rd_pfull)
        start <= 1'b1;
      rdreq   <= ~rdreq;
      cii_halt_data_fifo_rdreq_q <= cii_halt_data_fifo_rdreq;
      if (cii_halt_data_fifo_rdreq_q) begin
        cii_halt_r          <= cii_halt_data_out.cii_halt;
        cii_override_en_r   <= cii_halt_data_out.cii_override_en;
      end
      cii_halt_rr        <= cii_halt_r;
      cii_halt_rrr       <= cii_halt_rr;
      cii_halt_rrrr      <= cii_halt_rrr;
      cii_override_en_rr <= cii_override_en_r;
    end
  end

  always @ (posedge clk500) begin //negedge rst_clk500_n or
    if (cii_halt_data_fifo_rdreq_q) begin
      cii_override_din_r   <= cii_halt_data_out.cii_override_din;
    end
    cii_override_din_rr   <= cii_override_din_r;

    if(cii_halt_r & ~cii_halt_rr & ~cii_halt_rrr & cii_halt_rrrr) begin
      cii_override_din_t <= cii_override_din_rr;
    end
    cii_override_din_o   <= cii_override_din_t;
  end

  always @ (posedge clk500) begin //negedge rst_clk500_n or 
    if (rst_clk500_n == 0) begin
      cii_halt_t          <= 1'b0;
      cii_override_en_t   <= 1'b0;
    end
    else begin
     if((~cii_halt_rr & ~cii_halt_rrr) | (~cii_halt_r & ~cii_halt_rrr & ~cii_halt_rrrr) | (~cii_halt_r & ~cii_halt_rr & ~cii_halt_rrrr)) begin
      cii_halt_t         <= 1'b0;
     end
     else begin
      cii_halt_t         <= 1'b1;
     end
    
     if(cii_halt_r & ~cii_halt_rr & ~cii_halt_rrr & cii_halt_rrrr) begin
      cii_override_en_t <= cii_override_en_rr;
     end
     else begin
      cii_override_en_t <= 1'b0;
     end
    end
  end
  
    always @ (posedge clk500) begin //negedge rst_clk500_n or 
      if (rst_clk500_n == 0) begin
        cii_halt_o          <= 1'b1;
        cii_override_en_o   <= 1'b0;
        halt_is_zero        <= 1'b0;
      end
      else begin
        if(cii_req_q & ~cii_req_qq & ~cii_halt_t) begin
          cii_halt_o    <= 1'b0;
          halt_is_zero  <= 1'b1;
          cii_override_en_o  <= 1'b0;
        end
        else if(cii_req_q & ~cii_req_qq & cii_halt_t) begin
          cii_halt_o         <= 1'b1;
          halt_is_zero       <= 1'b0;
          cii_override_en_o  <= cii_override_en_t;
        end
        else if(~cii_req_q & ~cii_req_qq) begin
          cii_halt_o         <= 1'b1;
          cii_override_en_o  <= 1'b0;
        end
        else if(cii_req_q & cii_req_qq & halt_is_zero) begin
          cii_halt_o         <= 1'b1;
          cii_override_en_o  <= 1'b0;
        end
        else if(cii_req_q & cii_req_qq & ~halt_is_zero) begin
          cii_halt_o         <= cii_halt_t;
          cii_override_en_o  <= cii_override_en_t;
        end
      end
  end
 endmodule
