// (C) 2001-2021 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


// (C) 2001-2020 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


//ptile_pcie_soft_glue
module ptile_pcie_soft_glue # (
parameter       hssi_ctp_topology                       =       "pcie_x16"      ,
parameter 	hssi_ctp_sim_mode                       =   "fast_sim_mode",
parameter		core16_total_pf_count_width_hwtcl		=		1				,
parameter		core16_total_vf_count_width_hwtcl		=		0				,
parameter		core16_total_pf_count_hwtcl 			=		1				,
parameter		core16_total_vf_count_hwtcl 			=		1				,
parameter		core8_total_pf_count_width_hwtcl		=		1				,
parameter		core8_total_vf_count_width_hwtcl		=		0				,
parameter		core8_total_pf_count_hwtcl 				=		1				,
parameter		core8_total_vf_count_hwtcl 				=		1				,
parameter	    core8_refclk_init_active_hwtcl          =       1               ,
parameter       pld_clrpcs_hwtcl                        =       0               ,
parameter       xcvr_reconfig_hwtcl                     = 0,
parameter       core16_hip_reconfig_hwtcl               = 0,
parameter       core8_hip_reconfig_hwtcl                = 0,
parameter       core4_0_hip_reconfig_hwtcl              = 0,
parameter       core4_1_hip_reconfig_hwtcl              = 0,
parameter       core16_enable_cpl_timeout_hwtcl         = 0,
parameter       core8_enable_cpl_timeout_hwtcl          = 0,
parameter       core4_0_enable_cpl_timeout_hwtcl        = 0,
parameter       core4_1_enable_cpl_timeout_hwtcl        = 0,
parameter       hssi_ctp_u_wrpcie_top_u_core16_virtual_rp_ep_mode   = "ep",
parameter       hssi_ctp_u_wrpcie_top_u_core4_0_virtual_rp_ep_mode  = "ep",
parameter       hssi_ctp_u_wrpcie_top_u_core4_1_virtual_rp_ep_mode  = "ep",
parameter       hssi_ctp_u_wrpcie_top_u_core8_virtual_rp_ep_mode    = "ep"
) (
//clk
input 												    coreclkout_hip,
//rst
input                             adapter_clk,
input                             p0_soft_adapter_reset,
input                             p1_soft_adapter_reset,
input                             p2_soft_adapter_reset,
input                             p3_soft_adapter_reset,
input                             pin_perst_n,
input                             core_pll_lock,
input wire	ninit_done,
/////////////////rst_ctrl///////////////////
///from HIP


// //p0
// input       p0_pld_core_rst_n,        //reset from HIP
// input       p0_user_mode_to_pld,
// input       p0_pld_in_use,            //When asserted, indicates that the HIP PLD adaptor is alive
// input       p0_pld_link_req_rst_n,    //ndicates that HIP is going to do warm reset or hot reset
// output      p0_pld_warm_rst_rdy,
// output      p0_pld_ready,               //When asserted, indicates that the PLD is ready for operation and is providing a stable clock to the pld_clk input

// //p1 reset interface
// input       p1_pld_core_rst_n,
// input       p1_user_mode_to_pld,
// input       p1_pld_in_use,
// input       p1_pld_link_req_rst_n,
// output      p1_pld_warm_rst_rdy,
// output      p1_pld_ready,
// //p2 reset interface
// input       p2_pld_core_rst_n,
// input       p2_user_mode_to_pld,
// input       p2_pld_in_use,
// input       p2_pld_link_req_rst_n,
// output      p2_pld_warm_rst_rdy,
// output      p2_pld_ready,
// //p3 reset interface
// input       p3_pld_core_rst_n
// input       p3_user_mode_to_pld,
// input       p3_pld_in_use,
// input       p3_pld_link_req_rst_n,
// output      p3_pld_warm_rst_rdy,
// output      p3_pld_ready,
//reset interfaces
//APP ports
pcie_core_rst_interface app_pcie0_rst_port,
pcie_core_rst_interface app_pcie1_rst_port,
pcie_core_rst_interface app_pcie2_rst_port,
pcie_core_rst_interface app_pcie3_rst_port,
//PLD ports
pcie_core_rst_interface pld_pcie0_rst_port,
pcie_core_rst_interface pld_pcie1_rst_port,
pcie_core_rst_interface pld_pcie2_rst_port,
pcie_core_rst_interface pld_pcie3_rst_port,
//MAIB/AIB reset signals per channel 
//PLD ports
aib_ch_interface pld_aib_ch0,
aib_ch_interface pld_aib_ch1,
aib_ch_interface pld_aib_ch2,
aib_ch_interface pld_aib_ch3,
aib_ch_interface pld_aib_ch4,
aib_ch_interface pld_aib_ch5,
aib_ch_interface pld_aib_ch6,
aib_ch_interface pld_aib_ch7,
aib_ch_interface pld_aib_ch8,
aib_ch_interface pld_aib_ch9,
aib_ch_interface pld_aib_ch10,
aib_ch_interface pld_aib_ch11,
aib_ch_interface pld_aib_ch12,
aib_ch_interface pld_aib_ch13,
aib_ch_interface pld_aib_ch14,
aib_ch_interface pld_aib_ch15,
aib_ch_interface pld_aib_ch16,
aib_ch_interface pld_aib_ch17,
aib_ch_interface pld_aib_ch18,
aib_ch_interface pld_aib_ch19,
aib_ch_interface pld_aib_ch20,
aib_ch_interface pld_aib_ch21,
aib_ch_interface pld_aib_ch22,
aib_ch_interface pld_aib_ch23,

////to soft logic
output 	[3:0] 	p0_reset_tree,
output 	[3:0] 	p1_reset_tree,
output 	[3:0] 	p2_reset_tree,
output 	[3:0] 	p3_reset_tree,
output  [3:0]   reset_status_n,
/////////////////deskew ////////////////////
//from atom
input													p0_tx_dsk_mon_err_status,
input	[14:0]											p0_rx_dsk_marker,
input													p0_tx_dsk_eval_done,
input													p0_tx_dsk_done,
input	[2:0]											p0_tx_dsk_status,
output	[13:0]											p0_tx_dsk_marker,
// //p1 dsk ports
input													p1_tx_dsk_mon_err_status,
input													p1_tx_dsk_done,
input													p1_tx_dsk_eval_done,
input	[7:0]											p1_rx_dsk_marker,
output	[6:0]											p1_tx_dsk_marker,
input	[2:0]											p1_tx_dsk_status,
// //p2 dsk ports
input													p2_tx_dsk_mon_err_status,
input	[4:0]											p2_rx_dsk_marker,
input													p2_tx_dsk_eval_done,
input	[2:0]											p2_tx_dsk_status,
input													p2_tx_dsk_done,
output	[4:0]											p2_tx_dsk_marker,
// //p3 dsk ports
input													p3_tx_dsk_mon_err_status,
input	[4:0]											p3_rx_dsk_marker,
output	[4:0]											p3_tx_dsk_marker,
input													p3_tx_dsk_eval_done,
input	[2:0]											p3_tx_dsk_status,
input													p3_tx_dsk_done,


///////////////completion_to///////////////////
// //from Atom
user_avmm_interface   pld_pcie0_completion_timeout_avmm_ports,
user_avmm_interface   pld_pcie1_completion_timeout_avmm_ports,
user_avmm_interface   pld_pcie2_completion_timeout_avmm_ports,
user_avmm_interface   pld_pcie3_completion_timeout_avmm_ports,	
///to user
user_avmm_interface   app_pcie0_completion_timeout_avmm_ports,
user_avmm_interface   app_pcie1_completion_timeout_avmm_ports,
user_avmm_interface   app_pcie2_completion_timeout_avmm_ports,
user_avmm_interface   app_pcie3_completion_timeout_avmm_ports,



//////////error_convert////////////////
//////from user//
input	[core16_total_pf_count_width_hwtcl-1:0]			pld_p0_app_err_func_num_i,
input													pld_p0_app_err_valid_i,
input	[127:0]											pld_p0_app_err_hdr_i,				//add soft logic to convert hdr+prfx to 5 cycles of 32bit
input   [31:0]											pld_p0_app_err_tlp_prfx_i,
input	[12:0]											pld_p0_app_err_info_i,
//p1 err_ ports
input													pld_p1_app_err_valid_i,
input	[12:0]											pld_p1_app_err_info_i,
input	[127:0]											pld_p1_app_err_hdr_i,				//add soft logic to convert hdr+prfx to 5 cycles of 32bit
input   [31:0]											pld_p1_app_err_tlp_prfx_i,
input	[core8_total_pf_count_width_hwtcl-1:0]			pld_p1_app_err_func_num_i,
//p2 err_ ports
input													pld_p2_app_err_valid_i,
input	[12:0]											pld_p2_app_err_info_i,
input	[127:0]											pld_p2_app_err_hdr_i,				//add soft logic to convert hdr+prfx to 5 cycles of 32bit
input   [31:0]											pld_p2_app_err_tlp_prfx_i,
//p3 err_ ports
input	[12:0]											pld_p3_app_err_info_i,
input	[127:0]											pld_p3_app_err_hdr_i,				//add soft logic to convert hdr+prfx to 5 cycles of 32bit
input   [31:0]											pld_p3_app_err_tlp_prfx_i,
input													pld_p3_app_err_valid_i,
//////////////
////to Atom///
output	[core16_total_pf_count_width_hwtcl-1:0]			hip_p0_app_err_func_num_o,
output													hip_p0_app_err_valid_o,
output	[31:0]											hip_p0_app_err_hdr_o,				//add soft logic to convert hdr+prfx to 5 cycles of 32bit
output	[12:0]											hip_p0_app_err_info_o,
// //p1 err_ ports
output													hip_p1_app_err_valid_o,
output	[12:0]											hip_p1_app_err_info_o,
output	[31:0]											hip_p1_app_err_hdr_o,				//add soft logic to convert hdr+prfx to 5 cycles of 32bit
output	[core8_total_pf_count_width_hwtcl-1:0]			hip_p1_app_err_func_num_o,
// //p2 err_ ports
output													hip_p2_app_err_valid_o,
output	[12:0]											hip_p2_app_err_info_o,
output	[31:0]											hip_p2_app_err_hdr_o,				//add soft logic to convert hdr+prfx to 5 cycles of 32bit
// //p3 err_ ports
output	[12:0]											hip_p3_app_err_info_o,
output	[31:0]											hip_p3_app_err_hdr_o,				//add soft logic to convert hdr+prfx to 5 cycles of 32bit
output													hip_p3_app_err_valid_o,


//user avmm interface
//PLD ports
user_avmm_interface   pld_pcie0_user_avmm_ports,
user_avmm_interface   pld_pcie1_user_avmm_ports,
user_avmm_interface   pld_pcie2_user_avmm_ports,
user_avmm_interface   pld_pcie3_user_avmm_ports,
//APP ports
user_avmm_interface   app_pcie0_user_avmm_ports,
user_avmm_interface   app_pcie1_user_avmm_ports,
user_avmm_interface   app_pcie2_user_avmm_ports,
user_avmm_interface   app_pcie3_user_avmm_ports,
//PHY user avmm interface between HIP & PLD
//modport pld_user_avmm_ports
user_avmm_interface    pld_phy0_user_avmm_ports,
user_avmm_interface    pld_phy1_user_avmm_ports,
user_avmm_interface    pld_phy2_user_avmm_ports,
user_avmm_interface    pld_phy3_user_avmm_ports,
user_avmm_interface    pld_phy4_user_avmm_ports,
//PHY user avmm interface to APP
//modport app_user_avmm_ports
user_avmm_interface   app_phy_user_avmm_ports,



//ECC

//rst_ctrl
//prs soft logic
input	p0_prs_sl_event_valid_i,
input	[2:0]	p0_prs_sl_event_func_i,
input	[1:0]	p0_prs_sl_event_i,
output	p0_prs_sl_event_valid_o,
output	[2:0]	p0_prs_sl_event_func_o,
output	[1:0]	p0_prs_sl_event_o,
input	p1_prs_sl_event_valid_i,
input	[2:0]	p1_prs_sl_event_func_i,
input	[1:0]	p1_prs_sl_event_i,
output	p1_prs_sl_event_valid_o,
output	[2:0]	p1_prs_sl_event_func_o,
output	[1:0]	p1_prs_sl_event_o,
//Multi Pin_perst (One from WHR tile and one from GPIO) 
input aibaux_async_0_i,          
output aibaux_async_0_o,          
input p0_pld_clrpcs_n_i, //   (for x16, x8, x4 mode)
input p1_pld_clrpcs_n_i, //   (for x8, x4 mode) in Type D it is tied OFF to 1 in avst top wrapper
input p2_pld_clrpcs_n_i, //   (for x4 mode)
input p3_pld_clrpcs_n_i, //   (for x4 mode)
input p1_pld_clrphy_n_i, // clrphy signal (clears phy, pcs & PCIe controller) in Config Type D
output p0_pld_clrpcs_n_o,
output p1_pld_clrpcs_n_o,
output p2_pld_clrpcs_n_o,
output p3_pld_clrpcs_n_o

);

logic     p0_hip_rcfg_avmm_src_alive_w, p1_hip_rcfg_avmm_src_alive_w, p2_hip_rcfg_avmm_src_alive_w, p3_hip_rcfg_avmm_src_alive_w;
logic     p0_cplto_avmm_src_alive_w, p1_cplto_avmm_src_alive_w, p2_cplto_avmm_src_alive_w, p3_cplto_avmm_src_alive_w;
logic     xcvr_avmm_src_alive_w;

// logic   [7:0]       int_xcvr_reconfig_readdata;
// logic               int_xcvr_reconfig_readdatavalid;
// logic               int_xcvr_reconfig_writedone;
// logic               int_xcvr_reconfig_write;
// logic               int_xcvr_reconfig_read;
// logic   [20:0]      int_xcvr_reconfig_address;
// logic   [7:0]       int_xcvr_reconfig_writedata;
//make the internal ports an internal interface
user_avmm_interface int_phy_user_avmm_if ();

		//deskew
		//ECC
		//completion_TO
		//rst_ctrl
		//error_convert
//prs glue logic
prs_soft_logic p0_prs_soft_logic (
		.clk	(adapter_clk),
		.rst_n	(p0_soft_adapter_reset),
		.prs_event_valid_i	(p0_prs_sl_event_valid_i),
		.prs_event_func_i	(p0_prs_sl_event_func_i),
		.prs_event_i		(p0_prs_sl_event_i),
		.prs_event_valid_o	(p0_prs_sl_event_valid_o),
		.prs_event_func_o	(p0_prs_sl_event_func_o),
		.prs_event_o		(p0_prs_sl_event_o)
);
prs_soft_logic p1_prs_soft_logic (
		.clk	(adapter_clk),
		.rst_n	(p1_soft_adapter_reset),
		.prs_event_valid_i	(p1_prs_sl_event_valid_i),
		.prs_event_func_i	(p1_prs_sl_event_func_i),
		.prs_event_i		(p1_prs_sl_event_i),
		.prs_event_valid_o	(p1_prs_sl_event_valid_o),
		.prs_event_func_o	(p1_prs_sl_event_func_o),
		.prs_event_o		(p1_prs_sl_event_o)
);
//rst_ctrl
  reset_ctrl  #(
                .hssi_ctp_topology      (hssi_ctp_topology),
		        .hssi_ctp_sim_mode	(hssi_ctp_sim_mode),
                .core8_refclk_init_active_hwtcl (core8_refclk_init_active_hwtcl),
                .pld_clrpcs_hwtcl               (pld_clrpcs_hwtcl),
                .xcvr_reconfig_hwtcl               (xcvr_reconfig_hwtcl),
                .core16_hip_reconfig_hwtcl         (core16_hip_reconfig_hwtcl),
                .core8_hip_reconfig_hwtcl          (core8_hip_reconfig_hwtcl),
                .core4_0_hip_reconfig_hwtcl        (core4_0_hip_reconfig_hwtcl),
                .core4_1_hip_reconfig_hwtcl        (core4_1_hip_reconfig_hwtcl),
                .core16_enable_cpl_timeout_hwtcl   (core16_enable_cpl_timeout_hwtcl),
                .core8_enable_cpl_timeout_hwtcl    (core8_enable_cpl_timeout_hwtcl),
                .core4_0_enable_cpl_timeout_hwtcl  (core4_0_enable_cpl_timeout_hwtcl),
                .core4_1_enable_cpl_timeout_hwtcl  (core4_1_enable_cpl_timeout_hwtcl),
                .hssi_ctp_u_wrpcie_top_u_core16_virtual_rp_ep_mode  (hssi_ctp_u_wrpcie_top_u_core16_virtual_rp_ep_mode),
                .hssi_ctp_u_wrpcie_top_u_core4_0_virtual_rp_ep_mode (hssi_ctp_u_wrpcie_top_u_core4_0_virtual_rp_ep_mode),
                .hssi_ctp_u_wrpcie_top_u_core4_1_virtual_rp_ep_mode (hssi_ctp_u_wrpcie_top_u_core4_1_virtual_rp_ep_mode),
                .hssi_ctp_u_wrpcie_top_u_core8_virtual_rp_ep_mode   (hssi_ctp_u_wrpcie_top_u_core8_virtual_rp_ep_mode)

        )rst_ctrl (/*AUTOINST*/
                   // Interfaces
                   .p0_rst_ports        (pld_pcie0_rst_port),
                   .p1_rst_ports        (pld_pcie1_rst_port),
                   .p2_rst_ports        (pld_pcie2_rst_port),
                   .p3_rst_ports        (pld_pcie3_rst_port),
                   .p0_app_rst_ports        (app_pcie0_rst_port),
                   .p1_app_rst_ports        (app_pcie1_rst_port),
                   .p2_app_rst_ports        (app_pcie2_rst_port),
                   .p3_app_rst_ports        (app_pcie3_rst_port),
                   .pld_aib_ch0         (pld_aib_ch0),
                   .pld_aib_ch1         (pld_aib_ch1),
                   .pld_aib_ch2         (pld_aib_ch2),
                   .pld_aib_ch3         (pld_aib_ch3),
                   .pld_aib_ch4         (pld_aib_ch4),
                   .pld_aib_ch5         (pld_aib_ch5),
                   .pld_aib_ch6         (pld_aib_ch6),
                   .pld_aib_ch7         (pld_aib_ch7),
                   .pld_aib_ch8         (pld_aib_ch8),
                   .pld_aib_ch9         (pld_aib_ch9),
                   .pld_aib_ch10        (pld_aib_ch10),
                   .pld_aib_ch11        (pld_aib_ch11),
                   .pld_aib_ch12        (pld_aib_ch12),
                   .pld_aib_ch13        (pld_aib_ch13),
                   .pld_aib_ch14        (pld_aib_ch14),
                   .pld_aib_ch15        (pld_aib_ch15),
                   .pld_aib_ch16        (pld_aib_ch16),
                   .pld_aib_ch17        (pld_aib_ch17),
                   .pld_aib_ch18        (pld_aib_ch18),
                   .pld_aib_ch19        (pld_aib_ch19),
                   .pld_aib_ch20        (pld_aib_ch20),
                   .pld_aib_ch21        (pld_aib_ch21),
                   .pld_aib_ch22        (pld_aib_ch22),
                   .pld_aib_ch23        (pld_aib_ch23),
                   // Outputs
                   .upi_pld_warm_rst_rdy_o(),
                   .upi_pld_ready_o     (),
                   .upi_reset_tree_o    (),
                   .upi_maib_sync_rst_n_o (),
                   .upi_app_link_req_rst_o (),
                   .p0_reset_tree       (p0_reset_tree[3:0]),
                   .p1_reset_tree       (p1_reset_tree[3:0]),
                   .p2_reset_tree       (p2_reset_tree[3:0]),
                   .p3_reset_tree       (p3_reset_tree[3:0]),
                   .reset_status_n      (reset_status_n),
                   .p0_hip_rcfg_avmm_src_alive_o (p0_hip_rcfg_avmm_src_alive_w),
                   .p1_hip_rcfg_avmm_src_alive_o (p1_hip_rcfg_avmm_src_alive_w),
                   .p2_hip_rcfg_avmm_src_alive_o (p2_hip_rcfg_avmm_src_alive_w),
                   .p3_hip_rcfg_avmm_src_alive_o (p3_hip_rcfg_avmm_src_alive_w),
                   .xcvr_avmm_src_alive_o        (xcvr_avmm_src_alive_w),
                   .p0_cplto_avmm_src_alive_o    (p0_cplto_avmm_src_alive_w),
                   .p1_cplto_avmm_src_alive_o    (p1_cplto_avmm_src_alive_w),
                   .p2_cplto_avmm_src_alive_o    (p2_cplto_avmm_src_alive_w),
                   .p3_cplto_avmm_src_alive_o    (p3_cplto_avmm_src_alive_w),
                   // Inputs
                   .pin_perst_n_i       (pin_perst_n),
                   .coreclkout_hip      (coreclkout_hip),
                   .core_pll_lock       (core_pll_lock),
                   .ninit_done	        (ninit_done),
                   .p0_hip_rcfg_avmm_clk (app_pcie0_user_avmm_ports.app_user_avmm_clk),
                   .p1_hip_rcfg_avmm_clk (app_pcie1_user_avmm_ports.app_user_avmm_clk),
                   .p2_hip_rcfg_avmm_clk (app_pcie2_user_avmm_ports.app_user_avmm_clk),
                   .p3_hip_rcfg_avmm_clk (app_pcie3_user_avmm_ports.app_user_avmm_clk),
                   .xcvr_avmm_clk        (app_phy_user_avmm_ports.app_user_avmm_clk),
                   .p0_cpl_to_avmm_clk   (app_pcie0_completion_timeout_avmm_ports.app_user_avmm_clk),
                   .p1_cpl_to_avmm_clk   (app_pcie1_completion_timeout_avmm_ports.app_user_avmm_clk),
                   .p2_cpl_to_avmm_clk   (app_pcie2_completion_timeout_avmm_ports.app_user_avmm_clk),
                   .p3_cpl_to_avmm_clk   (app_pcie3_completion_timeout_avmm_ports.app_user_avmm_clk),
                   //UPI
                   .upi_pld_core_rst_n_i(1'b1),
                   .upi_user_mode_to_pld_i(1'b0),
                   .upi_pld_in_use_i    (1'b0),
                   .upi_pld_link_req_rst_n_i(1'b1),
                   .upi_pll_locked_i    (1'b0),
                   .upi_app_warm_rst_rdy_i (1'b1),
                   .upi_mc_ready_i      (1'b0),
                   //pld_clrpcs to rst PCS and controller 
                    .fw_pio_i           (aibaux_async_0_i), 
                    .fw_pio_o           (aibaux_async_0_o), 
                    .p0_pld_clrpcs_n_i  (p0_pld_clrpcs_n_i), 
                    .p1_pld_clrpcs_n_i  (p1_pld_clrpcs_n_i), 
                    .p2_pld_clrpcs_n_i  (p2_pld_clrpcs_n_i), 
                    .p3_pld_clrpcs_n_i  (p3_pld_clrpcs_n_i), 
                    .p1_pld_clrphy_n_i  (p1_pld_clrphy_n_i), 
                    .p0_pld_clrpcs_n_o  (p0_pld_clrpcs_n_o),
                    .p1_pld_clrpcs_n_o  (p1_pld_clrpcs_n_o),
                    .p2_pld_clrpcs_n_o  (p2_pld_clrpcs_n_o),
                    .p3_pld_clrpcs_n_o  (p3_pld_clrpcs_n_o)

                   );
//avmm arb
phy_user_avmm_arb phy_arb (//
                           // interfaces
                          .pld_phy0_user_avmm_ports(pld_phy0_user_avmm_ports),
                          .pld_phy1_user_avmm_ports(pld_phy1_user_avmm_ports),
                          .pld_phy2_user_avmm_ports(pld_phy2_user_avmm_ports),
                          .pld_phy3_user_avmm_ports(pld_phy3_user_avmm_ports),
                          .pld_phy4_user_avmm_ports(pld_phy4_user_avmm_ports),
                          .hip_int_phy_user_avmm_ports (int_phy_user_avmm_if.hip_user_avmm_ports));
//USER AVMM adapter
ptile_pcie_user_avmm_adapter int_phy_user_avmm_adpt(//
                                         // Interfaces
                                     .pld_user_avmm_ports(int_phy_user_avmm_if.pld_user_avmm_ports),
                                     .app_user_avmm_ports(app_phy_user_avmm_ports),
                                     .rst_n(xcvr_avmm_src_alive_w));

ptile_pcie_user_avmm_adapter pcie0_user_avmm_adpt(
                                         // Interfaces
                                     .pld_user_avmm_ports(pld_pcie0_user_avmm_ports),
                                     .app_user_avmm_ports(app_pcie0_user_avmm_ports),
                                     .rst_n(p0_hip_rcfg_avmm_src_alive_w));

ptile_pcie_user_avmm_adapter pcie1_user_avmm_adpt(//
                                         // Interfaces
                                     .pld_user_avmm_ports(pld_pcie1_user_avmm_ports),
                                     .app_user_avmm_ports(app_pcie1_user_avmm_ports),
                                     .rst_n(p1_hip_rcfg_avmm_src_alive_w));
ptile_pcie_user_avmm_adapter pcie2_user_avmm_adpt(//
                                         // Interfaces
                                     .pld_user_avmm_ports(pld_pcie2_user_avmm_ports),
                                     .app_user_avmm_ports(app_pcie2_user_avmm_ports),
                                     .rst_n(p2_hip_rcfg_avmm_src_alive_w));

ptile_pcie_user_avmm_adapter pcie3_user_avmm_adpt(//
                                         // Interfaces
                                     .pld_user_avmm_ports(pld_pcie3_user_avmm_ports),
                                     .app_user_avmm_ports(app_pcie3_user_avmm_ports),
                                     .rst_n(p3_hip_rcfg_avmm_src_alive_w));

//completion timeout
ptile_pcie_user_avmm_adapter pcie0_cpl_to_avmm_adpt(//
                                         // Interfaces
                                     .pld_user_avmm_ports(pld_pcie0_completion_timeout_avmm_ports),
                                     .app_user_avmm_ports(app_pcie0_completion_timeout_avmm_ports),
                                     .rst_n(p0_cplto_avmm_src_alive_w));

ptile_pcie_user_avmm_adapter pcie1_cpl_to_avmm_adpt(//
                                         // Interfaces
                                     .pld_user_avmm_ports(pld_pcie1_completion_timeout_avmm_ports),
                                     .app_user_avmm_ports(app_pcie1_completion_timeout_avmm_ports),
                                     .rst_n(p1_cplto_avmm_src_alive_w));

ptile_pcie_user_avmm_adapter pcie2_cpl_to_avmm_adpt(//
                                         // Interfaces
                                     .pld_user_avmm_ports(pld_pcie2_completion_timeout_avmm_ports),
                                     .app_user_avmm_ports(app_pcie2_completion_timeout_avmm_ports),
                                     .rst_n(p2_cplto_avmm_src_alive_w));

ptile_pcie_user_avmm_adapter pcie3_cpl_to_avmm_adpt(//
                                         // Interfaces
                                     .pld_user_avmm_ports(pld_pcie3_completion_timeout_avmm_ports),
                                     .app_user_avmm_ports(app_pcie3_completion_timeout_avmm_ports),
                                     .rst_n(p3_cplto_avmm_src_alive_w));
endmodule // ptile_pcie_soft_glue
