// (C) 2001-2021 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


// (C) 2001-2020 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


// (C) 2001-2020 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.



module reset_ctrl  # (
parameter   hssi_ctp_topology  = "pcie_x16",
parameter 	hssi_ctp_sim_mode                       =   "fast_sim_mode",

parameter	core8_refclk_init_active_hwtcl  = 1,
parameter pld_clrpcs_hwtcl = 0,

parameter xcvr_reconfig_hwtcl               = 0,
parameter core16_hip_reconfig_hwtcl         = 0,
parameter core8_hip_reconfig_hwtcl          = 0,
parameter core4_0_hip_reconfig_hwtcl        = 0,
parameter core4_1_hip_reconfig_hwtcl        = 0,
parameter core16_enable_cpl_timeout_hwtcl   = 0,
parameter core8_enable_cpl_timeout_hwtcl    = 0,
parameter core4_0_enable_cpl_timeout_hwtcl  = 0,
parameter core4_1_enable_cpl_timeout_hwtcl  = 0,

parameter hssi_ctp_u_wrpcie_top_u_core16_virtual_rp_ep_mode   = "ep",
parameter hssi_ctp_u_wrpcie_top_u_core4_0_virtual_rp_ep_mode  = "ep",
parameter hssi_ctp_u_wrpcie_top_u_core4_1_virtual_rp_ep_mode  = "ep",
parameter hssi_ctp_u_wrpcie_top_u_core8_virtual_rp_ep_mode    = "ep"

  )
(
//from/to HIP
input   logic     pin_perst_n_i,
input 	logic 		coreclkout_hip,   
input   logic     core_pll_lock,
input   wire	ninit_done,   //init_done signal connect to reset release IP.

// AVMM clocks
input   wire       p0_hip_rcfg_avmm_clk,
input   wire       p1_hip_rcfg_avmm_clk,
input   wire       p2_hip_rcfg_avmm_clk,
input   wire       p3_hip_rcfg_avmm_clk,
input   wire       xcvr_avmm_clk,
input   wire       p0_cpl_to_avmm_clk,
input   wire       p1_cpl_to_avmm_clk,
input   wire       p2_cpl_to_avmm_clk,
input   wire       p3_cpl_to_avmm_clk,

// ninit_done reset synch outputs in AVMM clk 
output  wire       p0_hip_rcfg_avmm_src_alive_o,
output  wire       p1_hip_rcfg_avmm_src_alive_o,
output  wire       p2_hip_rcfg_avmm_src_alive_o,
output  wire       p3_hip_rcfg_avmm_src_alive_o,
output  wire       xcvr_avmm_src_alive_o,
output  wire       p0_cplto_avmm_src_alive_o,
output  wire       p1_cplto_avmm_src_alive_o,
output  wire       p2_cplto_avmm_src_alive_o,
output  wire       p3_cplto_avmm_src_alive_o,

//UPI ports
input   logic       upi_pld_core_rst_n_i,        //reset from HIP
input   logic       upi_user_mode_to_pld_i,
input   logic       upi_pld_in_use_i,            //When asserted, indicates that the HIP PLD adaptor is alive
input   logic       upi_pld_link_req_rst_n_i,    //ndicates that HIP is going to do warm reset or hot reset
output  logic       upi_pld_warm_rst_rdy_o,
output  logic       upi_pld_ready_o,               //When asserted, indicates that the PLD is ready for operation and is providing a stable clock to the pld_clk input
input   logic       upi_pll_locked_i,       //soft ip pll is locked
input   logic       upi_mc_ready_i,         //memory controller ready
output  logic [3:0] upi_reset_tree_o,
output  logic       upi_maib_sync_rst_n_o,  //reset to maib and whr_interface reset
input   logic       upi_app_warm_rst_rdy_i, //upi warm reset ready from app
output  logic       upi_app_link_req_rst_o,   //upi link req reset to app
interface p0_rst_ports,
interface p1_rst_ports,
interface p2_rst_ports,
interface p3_rst_ports,
interface p0_app_rst_ports,
interface p1_app_rst_ports,
interface p2_app_rst_ports,
interface p3_app_rst_ports,


//p0
// input       p0_pld_core_rst_n,        //reset from HIP
// input       p0_user_mode_to_pld,
// input       p0_pld_in_use,            //When asserted, indicates that the HIP PLD adaptor is alive
// input       p0_pld_link_req_rst_n,    //ndicates that HIP is going to do warm reset or hot reset
// output      p0_pld_warm_rst_rdy,
// output      p0_pld_ready,               //When asserted, indicates that the PLD is ready for operation and is providing a stable clock to the pld_clk input

// //p1 reset interface
// input       p1_pld_core_rst_n,
// input       p1_user_mode_to_pld,
// input       p1_pld_in_use,
// input       p1_pld_link_req_rst_n,
// output      p1_pld_warm_rst_rdy,
// output      p1_pld_ready,
// //p2 reset interface
// input       p2_pld_core_rst_n,
// input       p2_user_mode_to_pld,
// input       p2_pld_in_use,
// input       p2_pld_link_req_rst_n,
// output      p2_pld_warm_rst_rdy,
// output      p2_pld_ready,
// //p3 reset interface
// input       p3_pld_core_rst_n
// input       p3_user_mode_to_pld,
// input       p3_pld_in_use,
// input       p3_pld_link_req_rst_n,
// output      p3_pld_warm_rst_rdy,
// output      p3_pld_ready,
//output to soft IP
output  logic [3:0] p0_reset_tree,
output  logic [3:0] p1_reset_tree,
output  logic [3:0] p2_reset_tree,
output  logic [3:0] p3_reset_tree,

output  logic [3:0] reset_status_n,

//MAIB/AIB reset signals per channel 
interface pld_aib_ch0,
interface pld_aib_ch1,
interface pld_aib_ch2,
interface pld_aib_ch3,
interface pld_aib_ch4,
interface pld_aib_ch5,
interface pld_aib_ch6,
interface pld_aib_ch7,
interface pld_aib_ch8,
interface pld_aib_ch9,
interface pld_aib_ch10,
interface pld_aib_ch11,
interface pld_aib_ch12,
interface pld_aib_ch13,
interface pld_aib_ch14,
interface pld_aib_ch15,
interface pld_aib_ch16,
interface pld_aib_ch17,
interface pld_aib_ch18,
interface pld_aib_ch19,
interface pld_aib_ch20,
interface pld_aib_ch21,
interface pld_aib_ch22,
interface pld_aib_ch23,

//*********************************************pld_clrpcs to rst PCS and controller ***********************************
// ******** Config Type A/B/C/D (WHR HAS 1p5 Appendix C – Bifurcated Endpoint support for Independent Warm Resets)
input logic fw_pio_i,    //Firmware input to SRC 
output logic fw_pio_o,    //Output from SRC to Firmware 

input p0_pld_clrpcs_n_i, //   (for x16, x8, x4 mode)
input p1_pld_clrpcs_n_i, //   (for x8, x4 mode) in Type D it is tied OFF to 1 in avst top wrapper
input p2_pld_clrpcs_n_i, //   (for x4 mode)
input p3_pld_clrpcs_n_i, //   (for x4 mode)
input p1_pld_clrphy_n_i, // clrphy signal (clears phy, pcs & PCIe controller) in Config Type D

output p0_pld_clrpcs_n_o,
output p1_pld_clrpcs_n_o,
output p2_pld_clrpcs_n_o,
output p3_pld_clrpcs_n_o


);

localparam    CORE0_ENABLED       =   hssi_ctp_topology == "pcie_x16" || hssi_ctp_topology == "pcie_x8x8" || hssi_ctp_topology == "pcie_x4x4x4x4";
localparam    CORE1_ENABLED       =   hssi_ctp_topology == "pcie_x8x8" || hssi_ctp_topology == "pcie_x4x4x4x4";
localparam    CORE2_ENABLED       =   hssi_ctp_topology == "pcie_x4x4x4x4";
localparam    CORE3_ENABLED       =   hssi_ctp_topology == "pcie_x4x4x4x4";
localparam    UPI_ENABLED         =   hssi_ctp_topology == "upi_x20";

localparam    INIT_RESET_ENTRY	=   4'b0000;
localparam    RELEASE_AIB_RST   =   4'b0001;
localparam    REQ_LOCK          =   4'b0011;
localparam    PLD_RDY           =   4'b0010;
localparam    PLD_IN_USE        =   4'b0110;
localparam    WARM_RST_ENTRY      =   4'b0111;
localparam    WARM_RST_REQ        =   4'b0101;
localparam    WARM_RST_RDY        =   4'b0100; 
localparam    WARM_RST            =   4'b1100;
localparam    RELEASE_WARM_RDY    =   4'b1110;
localparam    RESET_AIB           =   4'b1111;

//FSM state bits for hot reset
localparam    IN_USE_BIT              =   0;
localparam    HOT_RST_REQ_BIT         =   1;
localparam    HOT_RST_RDY_BIT         =   2;
localparam    HOT_RST_BIT             =   3;
localparam    HOT_RDY_RELEASE_BIT     =   4;
//FSM states for hot reset for each link
localparam    P0_IDLE                =   5'b00000;
localparam    P0_IN_USE              =   5'b00001;
localparam    P0_HOT_RST_REQ         =   5'b00010;
localparam    P0_HOT_RST_RDY         =   5'b00100;
localparam    P0_HOT_RST             =   5'b01000;
localparam    P0_HOT_RDY_RELEASE     =   5'b10000;

//FSM states for hot reset for each link
localparam    P1_IDLE                =   5'b00000;
localparam    P1_IN_USE              =   5'b00001;
localparam    P1_HOT_RST_REQ         =   5'b00010;
localparam    P1_HOT_RST_RDY         =   5'b00100;
localparam    P1_HOT_RST             =   5'b01000;
localparam    P1_HOT_RDY_RELEASE     =   5'b10000;

//FSM states for hot reset for each link
localparam    P2_IDLE                =   5'b00000;
localparam    P2_IN_USE              =   5'b00001;
localparam    P2_HOT_RST_REQ         =   5'b00010;
localparam    P2_HOT_RST_RDY         =   5'b00100;
localparam    P2_HOT_RST             =   5'b01000;
localparam    P2_HOT_RDY_RELEASE     =   5'b10000;

//FSM states for hot reset for each link
localparam    P3_IDLE                =   5'b00000;
localparam    P3_IN_USE              =   5'b00001;
localparam    P3_HOT_RST_REQ         =   5'b00010;
localparam    P3_HOT_RST_RDY         =   5'b00100;
localparam    P3_HOT_RST             =   5'b01000;
localparam    P3_HOT_RDY_RELEASE     =   5'b10000;

//FSM states for upi link
localparam    UPI_IDLE                =   5'b00000;
localparam    UPI_IN_USE              =   5'b00001;
localparam    UPI_HOT_RST_REQ         =   5'b00010;
localparam    UPI_HOT_RST_RDY         =   5'b00100;
localparam    UPI_HOT_RST             =   5'b01000;
localparam    UPI_HOT_RDY_RELEASE     =   5'b10000;

localparam    N_CYCLE_TO_REQ_LOCK     =   4;
localparam    N_CYCLE_TO_RST_RDY      =   4;
localparam    N_CYCLE_TO_RELEASE_RDY  =   4;
logic           p0_user_mode_to_pld_r, p1_user_mode_to_pld_r, p2_user_mode_to_pld_r, p3_user_mode_to_pld_r, upi_user_mode_to_pld_r;
logic           p0_pld_in_use_r, p1_pld_in_use_r, p2_pld_in_use_r, p3_pld_in_use_r, upi_pld_in_use_r;
logic           p0_pld_ready_r, p1_pld_ready_r, p2_pld_ready_r, p3_pld_ready_r, upi_pld_ready_r;
logic           p0_pld_link_req_rst_n_r, p1_pld_link_req_rst_n_r, p2_pld_link_req_rst_n_r, p3_pld_link_req_rst_n_r, upi_pld_link_req_rst_n_r;
wire      upi_pld_link_req_rst_r_sync;
logic           p0_pld_warm_rst_rdy_r, p1_pld_warm_rst_rdy_r, p2_pld_warm_rst_rdy_r, p3_pld_warm_rst_rdy_r, upi_pld_warm_rst_rdy_r;
logic           p0_pld_core_rst_n_r, p1_pld_core_rst_n_r, p2_pld_core_rst_n_r, p3_pld_core_rst_n_r, upi_pld_core_rst_n_r;
logic           is_user_mode, is_pld_in_use, all_pld_core_rst_released, all_link_req_rst_released, all_pld_core_rst_n, all_link_req_rst_n;
logic           is_user_mode_r, is_pld_in_use_r, all_pld_core_rst_released_r, all_link_req_rst_released_r;
logic       all_link_req_rst_n_r, all_pld_core_rst_n_r;
logic   [3:0]   cur_state;
logic   [3:0]   next_state;
logic   [4:0] p0_hot_rst_cur_state, p1_hot_rst_cur_state, p2_hot_rst_cur_state, p3_hot_rst_cur_state;
logic   [4:0]   p0_hot_rst_next_state, p1_hot_rst_next_state, p2_hot_rst_next_state, p3_hot_rst_next_state;
logic   [4:0]   n_cycle_count_to_lock_req, n_cycle_count_to_rst_rdy, p0_n_cycle_count_to_hot_rst_rdy, p1_n_cycle_count_to_hot_rst_rdy, p2_n_cycle_count_to_hot_rst_rdy, p3_n_cycle_count_to_hot_rst_rdy, p1_n_cycle_count_to_hot_rstrdy_release, p0_n_cycle_count_to_hot_rstrdy_release, p2_n_cycle_count_to_hot_rstrdy_release, p3_n_cycle_count_to_hot_rstrdy_release;
logic           pld_adapter_tx_pld_rst_n, pld_adapter_rx_pld_rst_n;
logic       pld_adapter_rx_pld_rst_n_r, pld_adapter_tx_pld_rst_n_r, pld_adapter_rx_pld_rst_n_2r, pld_adapter_tx_pld_rst_n_2r, pld_adapter_tx_pld_rst_n_3r, pld_adapter_rx_pld_rst_n_3r, pld_adapter_tx_pld_rst_n_4r, pld_adapter_rx_pld_rst_n_4r, pld_adapter_tx_pld_rst_n_5r, pld_adapter_rx_pld_rst_n_5r, pld_adapter_tx_pld_rst_n_6r, pld_adapter_rx_pld_rst_n_6r = 1'b0;
logic           pld_rx_dll_lock_req, pld_tx_dll_lock_req;
logic       pld_rx_dll_lock_req_r, pld_tx_dll_lock_req_r, pld_rx_dll_lock_req_2r, pld_tx_dll_lock_req_2r, pld_rx_dll_lock_req_3r, pld_tx_dll_lock_req_3r, pld_rx_dll_lock_req_4r, pld_tx_dll_lock_req_4r, pld_rx_dll_lock_req_5r, pld_tx_dll_lock_req_5r, pld_rx_dll_lock_req_6r, pld_tx_dll_lock_req_6r = 1'b0;
logic           pld_fabric_tx_transfer_en_ch_0_5_r, pld_fabric_tx_transfer_en_ch_6_11_r, pld_fabric_tx_transfer_en_ch_12_17_r, pld_fabric_tx_transfer_en_ch_18_23_r, pld_hssi_rx_transfer_en_ch_0_5_r, pld_hssi_rx_transfer_en_ch_6_11_r, pld_hssi_rx_transfer_en_ch_12_17_r, pld_hssi_rx_transfer_en_ch_18_23_r, pld_hssi_osc_transfer_en_ch_0_5_r, pld_hssi_osc_transfer_en_ch_6_11_r, pld_hssi_osc_transfer_en_ch_12_17_r, pld_hssi_osc_transfer_en_ch_18_23_r;
logic           pld_fabric_tx_transfer_en_2r, pld_hssi_rx_transfer_en_2r, pld_hssi_osc_transfer_en_2r;
logic           p0_reset_status_s, p1_reset_status_s, p2_reset_status_s, p3_reset_status_s, upi_reset_status_s;
logic           core_pll_lock_r;
logic           core_pll_lock_ir;
logic           upi_pll_locked_r, upi_mc_ready_r;
logic           p0_app_warm_rst_rdy_r, p1_app_warm_rst_rdy_r, p2_app_warm_rst_rdy_r, p3_app_warm_rst_rdy_r, upi_app_warm_rst_rdy_r;
logic       all_app_warm_rst_rdy;
logic           p0_pld_alive, p1_pld_alive, p2_pld_alive, p3_pld_alive, upi_pld_alive;
logic       p0_pld_alive_r, p1_pld_alive_r, p2_pld_alive_r, p3_pld_alive_r, upi_pld_alive_r;
(*maxfan = 64*) logic  [31:0]   src_alive_r /*synthesis preserve*/;
logic [11:0]    src_alive_r_d; /*synthesis preserve*/
logic           in_warm_rst_r;
logic           in_warm_rst;
reg [23:0] pld_adapter_tx_pld_rst_n_r_ch, pld_adapter_tx_pld_rst_n_r_ch_reg /* synthesis preserve */; 
reg [23:0] pld_adapter_rx_pld_rst_n_r_ch, pld_adapter_rx_pld_rst_n_r_ch_reg /* synthesis preserve */;
reg [23:0] pld_rx_dll_lock_req_r_ch, pld_rx_dll_lock_req_r_ch_reg /* synthesis preserve */;
reg [23:0] pld_tx_dll_lock_req_r_ch, pld_tx_dll_lock_req_r_ch_reg /* synthesis preserve */;
logic pin_perst_n_s;

logic pld_aib_ch0_pld_fabric_tx_transfer_en_q, pld_aib_ch1_pld_fabric_tx_transfer_en_q, pld_aib_ch2_pld_fabric_tx_transfer_en_q,
      pld_aib_ch3_pld_fabric_tx_transfer_en_q, pld_aib_ch4_pld_fabric_tx_transfer_en_q, pld_aib_ch5_pld_fabric_tx_transfer_en_q,
      pld_aib_ch6_pld_fabric_tx_transfer_en_q, pld_aib_ch7_pld_fabric_tx_transfer_en_q, pld_aib_ch8_pld_fabric_tx_transfer_en_q,
      pld_aib_ch9_pld_fabric_tx_transfer_en_q, pld_aib_ch10_pld_fabric_tx_transfer_en_q, pld_aib_ch11_pld_fabric_tx_transfer_en_q,
      pld_aib_ch12_pld_fabric_tx_transfer_en_q, pld_aib_ch13_pld_fabric_tx_transfer_en_q, pld_aib_ch14_pld_fabric_tx_transfer_en_q,
      pld_aib_ch15_pld_fabric_tx_transfer_en_q, pld_aib_ch16_pld_fabric_tx_transfer_en_q, pld_aib_ch17_pld_fabric_tx_transfer_en_q,
      pld_aib_ch18_pld_fabric_tx_transfer_en_q, pld_aib_ch19_pld_fabric_tx_transfer_en_q, pld_aib_ch20_pld_fabric_tx_transfer_en_q,
      pld_aib_ch21_pld_fabric_tx_transfer_en_q, pld_aib_ch22_pld_fabric_tx_transfer_en_q, pld_aib_ch23_pld_fabric_tx_transfer_en_q;
logic pld_aib_ch0_pld_hssi_rx_transfer_en_q, pld_aib_ch1_pld_hssi_rx_transfer_en_q, pld_aib_ch2_pld_hssi_rx_transfer_en_q,
      pld_aib_ch3_pld_hssi_rx_transfer_en_q, pld_aib_ch4_pld_hssi_rx_transfer_en_q, pld_aib_ch5_pld_hssi_rx_transfer_en_q,
      pld_aib_ch6_pld_hssi_rx_transfer_en_q, pld_aib_ch7_pld_hssi_rx_transfer_en_q, pld_aib_ch8_pld_hssi_rx_transfer_en_q,
      pld_aib_ch9_pld_hssi_rx_transfer_en_q, pld_aib_ch10_pld_hssi_rx_transfer_en_q, pld_aib_ch11_pld_hssi_rx_transfer_en_q,
      pld_aib_ch12_pld_hssi_rx_transfer_en_q, pld_aib_ch13_pld_hssi_rx_transfer_en_q, pld_aib_ch14_pld_hssi_rx_transfer_en_q,
      pld_aib_ch15_pld_hssi_rx_transfer_en_q, pld_aib_ch16_pld_hssi_rx_transfer_en_q, pld_aib_ch17_pld_hssi_rx_transfer_en_q,
      pld_aib_ch18_pld_hssi_rx_transfer_en_q, pld_aib_ch19_pld_hssi_rx_transfer_en_q, pld_aib_ch20_pld_hssi_rx_transfer_en_q,
      pld_aib_ch21_pld_hssi_rx_transfer_en_q, pld_aib_ch22_pld_hssi_rx_transfer_en_q, pld_aib_ch23_pld_hssi_rx_transfer_en_q;
logic pld_aib_ch0_pld_hssi_osc_transfer_en_q, pld_aib_ch1_pld_hssi_osc_transfer_en_q, pld_aib_ch2_pld_hssi_osc_transfer_en_q,
      pld_aib_ch3_pld_hssi_osc_transfer_en_q, pld_aib_ch4_pld_hssi_osc_transfer_en_q, pld_aib_ch5_pld_hssi_osc_transfer_en_q,
      pld_aib_ch6_pld_hssi_osc_transfer_en_q, pld_aib_ch7_pld_hssi_osc_transfer_en_q, pld_aib_ch8_pld_hssi_osc_transfer_en_q,
      pld_aib_ch9_pld_hssi_osc_transfer_en_q, pld_aib_ch10_pld_hssi_osc_transfer_en_q, pld_aib_ch11_pld_hssi_osc_transfer_en_q,
      pld_aib_ch12_pld_hssi_osc_transfer_en_q, pld_aib_ch13_pld_hssi_osc_transfer_en_q, pld_aib_ch14_pld_hssi_osc_transfer_en_q,
      pld_aib_ch15_pld_hssi_osc_transfer_en_q, pld_aib_ch16_pld_hssi_osc_transfer_en_q, pld_aib_ch17_pld_hssi_osc_transfer_en_q,
      pld_aib_ch18_pld_hssi_osc_transfer_en_q, pld_aib_ch19_pld_hssi_osc_transfer_en_q, pld_aib_ch20_pld_hssi_osc_transfer_en_q,
      pld_aib_ch21_pld_hssi_osc_transfer_en_q, pld_aib_ch22_pld_hssi_osc_transfer_en_q, pld_aib_ch23_pld_hssi_osc_transfer_en_q;


assign reset_status_n = {p3_reset_status_s,p2_reset_status_s,p1_reset_status_s,p0_reset_status_s};
		
//altera_s10_user_rst_clkgate s10_user_rst_clkgate_0 (
//        .ninit_done (ninit_done)  //  output,  width = 1, ninit_done.ninit_done
//);
logic ninit_done_sync;
altera_std_synchronizer_nocut ninit_done_synchronizer (.clk (coreclkout_hip), .reset_n ( 1'b1), .din (ninit_done ), .dout (ninit_done_sync) );

// synchronize ninit_done through reset synchronizer
generate if (core16_hip_reconfig_hwtcl == 1) begin : g_p0_hip_rcfg_avmm_src_alive_sync
   altera_std_synchronizer_nocut #(
      .depth     (3),
      .rst_value (0)
   ) p0_avmm_ninit_done_sync_inst (
      .clk     (p0_hip_rcfg_avmm_clk),
      .reset_n (~ninit_done),
      .din     (1'b1),
      .dout    (p0_hip_rcfg_avmm_src_alive_o)
   );
end else begin : g_p0_hip_rcfg_avmm_src_alive_inactive
   assign p0_hip_rcfg_avmm_src_alive_o = 1'b0;
end
endgenerate

generate if (core8_hip_reconfig_hwtcl == 1) begin : g_p1_hip_rcfg_avmm_src_alive_sync
   altera_std_synchronizer_nocut #(
      .depth     (3),
      .rst_value (0)
   ) p1_avmm_ninit_done_sync_inst (
      .clk     (p1_hip_rcfg_avmm_clk),
      .reset_n (~ninit_done),
      .din     (1'b1),
      .dout    (p1_hip_rcfg_avmm_src_alive_o)
   );
end else begin : g_p1_hip_rcfg_avmm_src_alive_inactive
   assign p1_hip_rcfg_avmm_src_alive_o = 1'b0;
end
endgenerate

generate if (core4_0_hip_reconfig_hwtcl == 1) begin : g_p2_hip_rcfg_avmm_src_alive_sync
   altera_std_synchronizer_nocut #(
      .depth     (3),
      .rst_value (0)
   ) p2_avmm_ninit_done_sync_inst (
      .clk     (p2_hip_rcfg_avmm_clk),
      .reset_n (~ninit_done),
      .din     (1'b1),
      .dout    (p2_hip_rcfg_avmm_src_alive_o)
   );
end else begin : g_p2_hip_rcfg_avmm_src_alive_inactive
   assign p2_hip_rcfg_avmm_src_alive_o = 1'b0;
end
endgenerate

generate if (core4_1_hip_reconfig_hwtcl == 1) begin : g_p3_hip_rcfg_avmm_src_alive_sync
   altera_std_synchronizer_nocut #(
      .depth     (3),
      .rst_value (0)
   ) p3_avmm_ninit_done_sync_inst (
      .clk     (p3_hip_rcfg_avmm_clk),
      .reset_n (~ninit_done),
      .din     (1'b1),
      .dout    (p3_hip_rcfg_avmm_src_alive_o)
   );
end else begin : g_p3_hip_rcfg_avmm_src_alive_inactive
   assign p3_hip_rcfg_avmm_src_alive_o = 1'b0;
end
endgenerate

generate if (xcvr_reconfig_hwtcl == 1) begin : g_xcvr_avmm_src_alive_sync
   altera_std_synchronizer_nocut #(
      .depth     (3),
      .rst_value (0)
   ) xcvr_avmm_ninit_done_sync_inst (
      .clk     (xcvr_avmm_clk),
      .reset_n (~ninit_done),
      .din     (1'b1),
      .dout    (xcvr_avmm_src_alive_o)
   );
end else begin : g_xcvr_avmm_src_alive_inactive
   assign xcvr_avmm_src_alive_o = 1'b0;
end
endgenerate

generate if (core16_enable_cpl_timeout_hwtcl == 1) begin : g_p0_cplto_avmm_src_alive_sync
   altera_std_synchronizer_nocut #(
      .depth     (3),
      .rst_value (0)
   ) p0_avmm_ninit_done_sync_inst (
      .clk     (p0_cpl_to_avmm_clk),
      .reset_n (~ninit_done),
      .din     (1'b1),
      .dout    (p0_cplto_avmm_src_alive_o)
   );
end else begin : g_p0_cplto_avmm_src_alive_inactive
   assign p0_cplto_avmm_src_alive_o = 1'b0;
end
endgenerate

generate if (core8_enable_cpl_timeout_hwtcl == 1) begin : g_p1_cplto_avmm_src_alive_sync
   altera_std_synchronizer_nocut #(
      .depth     (3),
      .rst_value (0)
   ) p1_avmm_ninit_done_sync_inst (
      .clk     (p1_cpl_to_avmm_clk),
      .reset_n (~ninit_done),
      .din     (1'b1),
      .dout    (p1_cplto_avmm_src_alive_o)
   );
end else begin : g_p1_cplto_avmm_src_alive_inactive
   assign p1_cplto_avmm_src_alive_o = 1'b0;
end
endgenerate

generate if (core4_0_enable_cpl_timeout_hwtcl == 1) begin : g_p2_cplto_avmm_src_alive_sync
   altera_std_synchronizer_nocut #(
      .depth     (3),
      .rst_value (0)
   ) p2_avmm_ninit_done_sync_inst (
      .clk     (p2_cpl_to_avmm_clk),
      .reset_n (~ninit_done),
      .din     (1'b1),
      .dout    (p2_cplto_avmm_src_alive_o)
   );
end else begin : g_p2_cplto_avmm_src_alive_inactive
   assign p2_cplto_avmm_src_alive_o = 1'b0;
end
endgenerate

generate if (core4_1_enable_cpl_timeout_hwtcl == 1) begin : g_p3_cplto_avmm_src_alive_sync
   altera_std_synchronizer_nocut #(
      .depth     (3),
      .rst_value (0)
   ) p3_avmm_ninit_done_sync_inst (
      .clk     (p3_cpl_to_avmm_clk),
      .reset_n (~ninit_done),
      .din     (1'b1),
      .dout    (p3_cplto_avmm_src_alive_o)
   );
end else begin : g_p3_cplto_avmm_src_alive_inactive
   assign p3_cplto_avmm_src_alive_o = 1'b0;
end
endgenerate

always_ff@ (posedge coreclkout_hip or negedge core_pll_lock) begin : proc_src_alive_r
    if (~core_pll_lock) begin
        src_alive_r     <= '0;
        src_alive_r_d[11:0]  <= '0;
    end else if (ninit_done_sync) begin
        src_alive_r     <= '0;
        src_alive_r_d[11:0]  <= '0;
        //src_alive_r_d2[3:0]  <= '0;
    end else begin
        src_alive_r     <= '1;
        src_alive_r_d[11:0]  <= 12'b1111_1111_1111;
        //src_alive_r_d2[3:0]  <= 3'hF;
    end
end

//reg inputs
always_ff @(posedge coreclkout_hip ) begin : proc_reg_input
	if (~src_alive_r[0]) begin
		 p3_user_mode_to_pld_r <= 0;
		 p2_user_mode_to_pld_r <= 0;
		 p1_user_mode_to_pld_r <= 0;
		 p0_user_mode_to_pld_r <= 0;
		 p0_pld_in_use_r       <= 0;
		 p1_pld_in_use_r       <= 0;
		 p2_pld_in_use_r       <= 0;
		 p3_pld_in_use_r       <= 0;
		 p0_pld_link_req_rst_n_r <= 1;
		 p1_pld_link_req_rst_n_r <= 1;
		 p2_pld_link_req_rst_n_r <= 1;
		 p3_pld_link_req_rst_n_r <= 1;
		 p0_pld_core_rst_n_r     <= 1;
		 p1_pld_core_rst_n_r     <= 1;
		 p2_pld_core_rst_n_r     <= 1;
		 p3_pld_core_rst_n_r     <= 1;
		 //UPI
		 upi_user_mode_to_pld_r  <= 0;
		 upi_pld_in_use_r        <= 0;
		 upi_pld_link_req_rst_n_r <= 1;
		 upi_pld_core_rst_n_r     <= 1;
		 upi_pll_locked_r         <= 0;
		 upi_mc_ready_r           <= 0;
		 //
		 core_pll_lock_r          <= 0;
		 core_pll_lock_ir         <= 0;
		 end 
	else begin
		p3_user_mode_to_pld_r <= p3_rst_ports.user_mode_to_pld;
		p2_user_mode_to_pld_r <= p2_rst_ports.user_mode_to_pld;
		p1_user_mode_to_pld_r <= p1_rst_ports.user_mode_to_pld;
		p0_user_mode_to_pld_r <= p0_rst_ports.user_mode_to_pld;
		p0_pld_in_use_r       <= p0_rst_ports.pld_in_use;
		p1_pld_in_use_r       <= p1_rst_ports.pld_in_use;
		p2_pld_in_use_r       <= p2_rst_ports.pld_in_use;
		p3_pld_in_use_r       <= p3_rst_ports.pld_in_use;
		p0_pld_link_req_rst_n_r <= p0_rst_ports.pld_link_req_rst_n;
		p1_pld_link_req_rst_n_r <= p1_rst_ports.pld_link_req_rst_n;
		p2_pld_link_req_rst_n_r <= p2_rst_ports.pld_link_req_rst_n;
		p3_pld_link_req_rst_n_r <= p3_rst_ports.pld_link_req_rst_n;
		p0_pld_core_rst_n_r     <= p0_rst_ports.pld_core_rst_n;
		p1_pld_core_rst_n_r     <= p1_rst_ports.pld_core_rst_n;
		p2_pld_core_rst_n_r     <= p2_rst_ports.pld_core_rst_n;
		p3_pld_core_rst_n_r     <= p3_rst_ports.pld_core_rst_n;
		//UPI
		upi_user_mode_to_pld_r  <= upi_user_mode_to_pld_i;
		upi_pld_in_use_r        <= upi_pld_in_use_i;
		upi_pld_link_req_rst_n_r <= upi_pld_link_req_rst_n_i;
		upi_pld_core_rst_n_r     <= upi_pld_core_rst_n_i; 
		upi_pll_locked_r         <= upi_pll_locked_i;
		upi_mc_ready_r           <= upi_mc_ready_i;
		//
		core_pll_lock_ir          <= core_pll_lock;
		core_pll_lock_r          <= core_pll_lock_ir;

	end
end 

assign is_user_mode                 =   (CORE0_ENABLED?  p0_user_mode_to_pld_r : 1) & (CORE1_ENABLED?  p1_user_mode_to_pld_r : 1) & (CORE2_ENABLED?  p2_user_mode_to_pld_r : 1) & (CORE3_ENABLED?  p3_user_mode_to_pld_r : 1) & (UPI_ENABLED?  upi_user_mode_to_pld_r : 1);
assign is_pld_in_use                =   (CORE0_ENABLED?  p0_pld_in_use_r : 1) & (CORE1_ENABLED?  p1_pld_in_use_r : 1) & (CORE2_ENABLED?  p2_pld_in_use_r : 1) & (CORE3_ENABLED?  p3_pld_in_use_r : 1) & (UPI_ENABLED?  upi_pld_in_use_r : 1);
assign all_link_req_rst_n           =   (CORE0_ENABLED? p0_pld_link_req_rst_n_r: 0) | (CORE1_ENABLED? p1_pld_link_req_rst_n_r: 0) | ( CORE2_ENABLED? p2_pld_link_req_rst_n_r:0) | (CORE3_ENABLED? p3_pld_link_req_rst_n_r:0) | (UPI_ENABLED? upi_pld_link_req_rst_n_r:0);
assign all_link_req_rst_released    =   (CORE0_ENABLED? p0_pld_link_req_rst_n_r: 1) & (CORE1_ENABLED? p1_pld_link_req_rst_n_r: 1) & ( CORE2_ENABLED? p2_pld_link_req_rst_n_r:1) & (CORE3_ENABLED? p3_pld_link_req_rst_n_r:1) & (UPI_ENABLED? upi_pld_link_req_rst_n_r:1);
assign all_pld_core_rst_n           =   (CORE0_ENABLED? p0_pld_core_rst_n_r:0) | (CORE1_ENABLED? p1_pld_core_rst_n_r:0) | (CORE2_ENABLED? p2_pld_core_rst_n_r:0) | (CORE3_ENABLED? p3_pld_core_rst_n_r:0) | (UPI_ENABLED? upi_pld_core_rst_n_r:0);
assign all_pld_core_rst_released    =   (CORE0_ENABLED? p0_pld_core_rst_n_r:1) & (CORE1_ENABLED? p1_pld_core_rst_n_r:1) & (CORE2_ENABLED? p2_pld_core_rst_n_r:1) & (CORE3_ENABLED? p3_pld_core_rst_n_r:1) & (UPI_ENABLED? upi_pld_core_rst_n_r:1);
assign all_app_warm_rst_rdy         =   (CORE0_ENABLED?  p0_app_warm_rst_rdy_r : 1) & (CORE1_ENABLED?  p1_app_warm_rst_rdy_r : 1) & (CORE2_ENABLED?  p2_app_warm_rst_rdy_r : 1) & (CORE3_ENABLED?  p3_app_warm_rst_rdy_r : 1) & (UPI_ENABLED? upi_app_warm_rst_rdy_r : 1);
always_ff @(posedge coreclkout_hip ) begin : proc_reginputs
	  if (~src_alive_r[1]) begin
		 is_user_mode_r    <= 0;
		 is_pld_in_use_r   <= 0;
		 all_link_req_rst_n_r        <= 1;
		 all_link_req_rst_released_r <= 0;
		 all_pld_core_rst_n_r        <= 1;
		 all_pld_core_rst_released_r <= 0;
	  end else begin
		 is_user_mode_r    <= is_user_mode;
		 is_pld_in_use_r   <= is_pld_in_use;
		 all_link_req_rst_n_r        <= all_link_req_rst_n;
		 all_link_req_rst_released_r <= all_link_req_rst_released;
		 all_pld_core_rst_n_r        <= all_pld_core_rst_n;
		 all_pld_core_rst_released_r <= all_pld_core_rst_released;
	  end
end
// Delay added for hot reset (link reset scenario) in rp mode.
// delay counter
logic   p0_warm_rst_wait;
logic   p1_warm_rst_wait;
logic   p2_warm_rst_wait;
logic   p3_warm_rst_wait;
delay_counter #(
.no_delay ((hssi_ctp_sim_mode == "fast_sim_mode") || (hssi_ctp_u_wrpcie_top_u_core16_virtual_rp_ep_mode == "ep"))
)
p0_warm_rst_delay (
	.clk				(coreclkout_hip), 
	.reset_n			(src_alive_r[2]),
	.link_req_rst_n		(p0_pld_link_req_rst_n_r),
	.delay_4ms_500Mhz	(p0_warm_rst_wait)
);
delay_counter #(
.no_delay ((hssi_ctp_sim_mode == "fast_sim_mode") || (hssi_ctp_u_wrpcie_top_u_core8_virtual_rp_ep_mode == "ep"))
)
p1_warm_rst_delay (
	.clk				(coreclkout_hip), 
	.reset_n			(src_alive_r[3]),
	.link_req_rst_n		(p1_pld_link_req_rst_n_r),	
	.delay_4ms_500Mhz	(p1_warm_rst_wait)
);
delay_counter #(
.no_delay ((hssi_ctp_sim_mode == "fast_sim_mode") || (hssi_ctp_u_wrpcie_top_u_core4_0_virtual_rp_ep_mode == "ep"))
)
p2_warm_rst_delay (
	.clk				(coreclkout_hip), 
	.reset_n			(src_alive_r[4]),	
	.link_req_rst_n		(p2_pld_link_req_rst_n_r),	
	.delay_4ms_500Mhz	(p2_warm_rst_wait)
);
delay_counter #(
.no_delay ((hssi_ctp_sim_mode == "fast_sim_mode") || (hssi_ctp_u_wrpcie_top_u_core4_1_virtual_rp_ep_mode == "ep"))
)
p3_warm_rst_delay (
	.clk				(coreclkout_hip), 
	.reset_n			(src_alive_r[5]),	
	.link_req_rst_n		(p3_pld_link_req_rst_n_r),	
	.delay_4ms_500Mhz	(p3_warm_rst_wait)
);
//FSM for initial bring up and warm reset
always_ff @(posedge coreclkout_hip ) begin : proc_init_and_warmrst_fsm
	  if (~src_alive_r[6]) begin
			if (!pld_hssi_osc_transfer_en_2r) begin
			  cur_state     <= INIT_RESET_ENTRY;
		//	end else begin
		//	  cur_state     <= WARM_RST_ENTRY;
			end // end else

	  end  else begin 
		   cur_state <= next_state;
	  end 

end

logic rel_aib_trigger;
assign rel_aib_trigger = UPI_ENABLED ? (pin_perst_n_s & core_pll_lock_r & upi_pll_locked_r & pld_hssi_osc_transfer_en_2r): (pin_perst_n_s & core_pll_lock_r & pld_hssi_osc_transfer_en_2r);
always_comb begin : proc_init_and_warmrst_fsm_comb
    case(cur_state) 
      INIT_RESET_ENTRY: begin
        if (rel_aib_trigger) 
          next_state = RELEASE_AIB_RST;
        else
          next_state = INIT_RESET_ENTRY;
      end
      RELEASE_AIB_RST: begin
        if (!pin_perst_n_s)
          next_state = RESET_AIB;
        else if (n_cycle_count_to_lock_req == N_CYCLE_TO_REQ_LOCK)
          next_state = REQ_LOCK;
        else
          next_state = RELEASE_AIB_RST;
      end
      REQ_LOCK: begin 
        if (!pin_perst_n_s)
          next_state = RESET_AIB;
        else if (pld_hssi_rx_transfer_en_2r & pld_fabric_tx_transfer_en_2r)
          next_state = PLD_RDY;
        else
          next_state = REQ_LOCK;
      end 
    //   PLD_RDY: begin
    //     if (!pin_perst_n_s)
    //       next_state = RESET_AIB;
    //     else if (is_pld_in_use_r)
    //       next_state = PLD_IN_USE;
    //     else
    //       next_state = PLD_RDY;
    //   end
    //   PLD_IN_USE: begin //traffic can happen in this state
    //     if (!pin_perst_n_s)
    //       next_state = WARM_RST_ENTRY;
    //     else 
    //       next_state = PLD_IN_USE;
    //   end // PLD_IN_USE:
      PLD_RDY: begin
        if (!pin_perst_n_s)
           next_state = WARM_RST_ENTRY;
        else
          next_state = PLD_RDY;
      end
      WARM_RST_ENTRY: begin
        if (~all_link_req_rst_n_r)
          next_state = WARM_RST_REQ;
        else
          next_state = WARM_RST_ENTRY;
      end // WARM_RST_ENTRY:
      WARM_RST_REQ: begin
        if (all_app_warm_rst_rdy && n_cycle_count_to_rst_rdy == N_CYCLE_TO_RST_RDY)
          next_state = WARM_RST_RDY;
        else 
          next_state = WARM_RST_REQ;
      end // WARM_RST_REQ:
      WARM_RST_RDY: begin
        if (~all_pld_core_rst_n_r)
          next_state = WARM_RST;
        else if (all_link_req_rst_released_r)
          next_state = RELEASE_WARM_RDY;
        else
          next_state = WARM_RST_RDY;
      end
      WARM_RST: begin
        if (all_link_req_rst_released_r)
          next_state = RELEASE_WARM_RDY;
        else
          next_state = WARM_RST;
      end      
      RELEASE_WARM_RDY: begin
        if (~all_pld_core_rst_n_r) begin
            if (UPI_ENABLED) 
                next_state = RESET_AIB;
            else 
                next_state = RESET_AIB;
        end
        else 
          next_state = RELEASE_WARM_RDY;
      end // RELEASE_WARM_RDY:
      RESET_AIB: begin
          if (UPI_ENABLED)
          begin
          if (all_pld_core_rst_n_r) 
                  next_state = INIT_RESET_ENTRY;
              else 
                  next_state = RESET_AIB;
          end
          else
            if(~pld_hssi_rx_transfer_en_2r & ~pld_fabric_tx_transfer_en_2r)
              next_state = INIT_RESET_ENTRY;
          else 
              next_state = RESET_AIB;
      end
      default: 
          next_state = INIT_RESET_ENTRY;
    endcase // cur_state
end

///FSM for hot reset for 4 cores
always_ff @(posedge coreclkout_hip ) begin : proc_hot_rst_fsm
	  if(~src_alive_r[7]) begin
		 p0_hot_rst_cur_state <= P0_IDLE;
		 p1_hot_rst_cur_state <= P1_IDLE;
		 p2_hot_rst_cur_state <= P2_IDLE;
		 p3_hot_rst_cur_state <= P3_IDLE;
		end 
		else begin
		p0_hot_rst_cur_state <= p0_hot_rst_next_state;
		p1_hot_rst_cur_state <= p1_hot_rst_next_state;
		p2_hot_rst_cur_state <= p2_hot_rst_next_state;
		p3_hot_rst_cur_state <= p3_hot_rst_next_state;
	  end
 
end

always_comb begin : proc_p0_hot_rst_fsm_comb
  case(p0_hot_rst_cur_state) 
    P0_IDLE: begin
      if ((cur_state == PLD_RDY) & p0_pld_in_use_r)
        p0_hot_rst_next_state = P0_IN_USE;
      else
        p0_hot_rst_next_state = P0_IDLE;
    end // P0_IDLE:
    P0_IN_USE: begin
      if (~p0_pld_link_req_rst_n_r & ~in_warm_rst_r & p0_warm_rst_wait)
        p0_hot_rst_next_state = P0_HOT_RST_REQ;
      else
        p0_hot_rst_next_state = P0_IN_USE;
    end // P0_IN_USE:
    P0_HOT_RST_REQ: begin
      if (p0_app_warm_rst_rdy_r && p0_n_cycle_count_to_hot_rst_rdy == N_CYCLE_TO_RST_RDY)
        p0_hot_rst_next_state = P0_HOT_RST_RDY;
      else 
        p0_hot_rst_next_state = P0_HOT_RST_REQ;
    end // P0_HOT_RST_REQ:
    P0_HOT_RST_RDY: begin
      if (~p0_pld_core_rst_n_r)
        p0_hot_rst_next_state = P0_HOT_RST;
      else
        p0_hot_rst_next_state = P0_HOT_RST_RDY;
    end // P0_HOT_RST_RDY:
    P0_HOT_RST: begin
      if (p0_n_cycle_count_to_hot_rstrdy_release == N_CYCLE_TO_RELEASE_RDY)
        p0_hot_rst_next_state = P0_HOT_RDY_RELEASE;
      else
        p0_hot_rst_next_state = P0_HOT_RST;
    end // P0_HOT_RST:
    P0_HOT_RDY_RELEASE: begin
      if (p0_pld_core_rst_n_r)
        p0_hot_rst_next_state = P0_IN_USE;
      else
        p0_hot_rst_next_state = P0_HOT_RDY_RELEASE;
    end // P0_HOT_RDY_RELEASE:
    default: begin
      p0_hot_rst_next_state = P0_IDLE;
    end
  endcase // p0_hot_rst_cur_state
end

// generate
  always_comb begin : proc_p1_hot_rst_fsm_comb
    if (CORE1_ENABLED) begin
      case(p1_hot_rst_cur_state) 
        P1_IDLE: begin
          if ((cur_state == PLD_RDY) & p1_pld_in_use_r)
            p1_hot_rst_next_state = P1_IN_USE;
          else
            p1_hot_rst_next_state = P1_IDLE;
        end // P1_IDLE:
        P1_IN_USE: begin
          if (~p1_pld_link_req_rst_n_r & ~in_warm_rst_r & p1_warm_rst_wait)
            p1_hot_rst_next_state = P1_HOT_RST_REQ;
          else
            p1_hot_rst_next_state = P1_IN_USE;
        end // P1_IN_USE:
        P1_HOT_RST_REQ: begin
          if (p1_app_warm_rst_rdy_r && p1_n_cycle_count_to_hot_rst_rdy == N_CYCLE_TO_RST_RDY)
            p1_hot_rst_next_state = P1_HOT_RST_RDY;
          else 
            p1_hot_rst_next_state = P1_HOT_RST_REQ;
        end // P1_HOT_RST_REQ:
        P1_HOT_RST_RDY: begin
          if (~p1_pld_core_rst_n_r)
            p1_hot_rst_next_state = P1_HOT_RST;
          else
            p1_hot_rst_next_state = P1_HOT_RST_RDY;
        end // P1_HOT_RST_RDY:
        P1_HOT_RST: begin
          if (p1_n_cycle_count_to_hot_rstrdy_release == N_CYCLE_TO_RELEASE_RDY)
            p1_hot_rst_next_state = P1_HOT_RDY_RELEASE;
          else
            p1_hot_rst_next_state = P1_HOT_RST;
        end // P1_HOT_RST:
        P1_HOT_RDY_RELEASE: begin
          if (p1_pld_core_rst_n_r)
            p1_hot_rst_next_state = P1_IN_USE;
          else
            p1_hot_rst_next_state = P1_HOT_RDY_RELEASE;
        end // P1_HOT_RDY_RELEASE:
        default: begin
          p1_hot_rst_next_state = P1_IDLE;
        end
      endcase // p1_hot_rst_cur_state
    end // if (CORE1_ENABLED)
    else begin
      p1_hot_rst_next_state = P1_IDLE;
    end // else
  end // proc_p0_hot_rst_fsm_comb
// endgenerate

// generate
  always_comb begin : proc_p2_hot_rst_fsm_comb
    if (CORE2_ENABLED) begin
      case(p2_hot_rst_cur_state) 
        P2_IDLE: begin
          if ((cur_state == PLD_RDY) & p2_pld_in_use_r)
            p2_hot_rst_next_state = P2_IN_USE;
          else
            p2_hot_rst_next_state = P2_IDLE;
        end // P2_IDLE:
        P2_IN_USE: begin
          if (~p2_pld_link_req_rst_n_r & ~in_warm_rst_r & p2_warm_rst_wait)
            p2_hot_rst_next_state = P2_HOT_RST_REQ;
          else
            p2_hot_rst_next_state = P2_IN_USE;
        end // P2_IN_USE:
        P2_HOT_RST_REQ: begin
          if (p2_app_warm_rst_rdy_r && p2_n_cycle_count_to_hot_rst_rdy == N_CYCLE_TO_RST_RDY)
            p2_hot_rst_next_state = P2_HOT_RST_RDY;
          else 
            p2_hot_rst_next_state = P2_HOT_RST_REQ;
        end // P2_HOT_RST_REQ:
        P2_HOT_RST_RDY: begin
          if (~p2_pld_core_rst_n_r)
            p2_hot_rst_next_state = P2_HOT_RST;
          else
            p2_hot_rst_next_state = P2_HOT_RST_RDY;
        end // P2_HOT_RST_RDY:
        P2_HOT_RST: begin
          if (p2_n_cycle_count_to_hot_rstrdy_release == N_CYCLE_TO_RELEASE_RDY)
            p2_hot_rst_next_state = P2_HOT_RDY_RELEASE;
          else
            p2_hot_rst_next_state = P2_HOT_RST;
        end // P2_HOT_RST:
        P2_HOT_RDY_RELEASE: begin
          if (p2_pld_core_rst_n_r)
            p2_hot_rst_next_state = P2_IN_USE;
          else
            p2_hot_rst_next_state = P2_HOT_RDY_RELEASE;
        end // P2_HOT_RDY_RELEASE:
        default: begin
          p2_hot_rst_next_state = P2_IDLE;
        end
      endcase // p2_hot_rst_cur_state
    end // if (CORE2_ENABLED)
    else begin
      p2_hot_rst_next_state = P2_IDLE;
    end // else
  end // proc_p0_hot_rst_fsm_comb
// endgenerate
// generate
  always_comb begin : proc_p3_hot_rst_fsm_comb
    if (CORE3_ENABLED) begin
      case(p3_hot_rst_cur_state) 
        P3_IDLE: begin
          if ((cur_state == PLD_RDY) & p3_pld_in_use_r)
            p3_hot_rst_next_state = P3_IN_USE;
          else
            p3_hot_rst_next_state = P3_IDLE;
        end // P3_IDLE:
        P3_IN_USE: begin
          if (~p3_pld_link_req_rst_n_r & ~in_warm_rst_r & p3_warm_rst_wait)
            p3_hot_rst_next_state = P3_HOT_RST_REQ;
          else
            p3_hot_rst_next_state = P3_IN_USE;
        end // P3_IN_USE:
        P3_HOT_RST_REQ: begin
          if (p3_app_warm_rst_rdy_r && p3_n_cycle_count_to_hot_rst_rdy == N_CYCLE_TO_RST_RDY)
            p3_hot_rst_next_state = P3_HOT_RST_RDY;
          else 
            p3_hot_rst_next_state = P3_HOT_RST_REQ;
        end // P3_HOT_RST_REQ:
        P3_HOT_RST_RDY: begin
          if (~p3_pld_core_rst_n_r)
            p3_hot_rst_next_state = P3_HOT_RST;
          else
            p3_hot_rst_next_state = P3_HOT_RST_RDY;
        end // P3_HOT_RST_RDY:
        P3_HOT_RST: begin
          if (p3_n_cycle_count_to_hot_rstrdy_release == N_CYCLE_TO_RELEASE_RDY)
            p3_hot_rst_next_state = P3_HOT_RDY_RELEASE;
          else
            p3_hot_rst_next_state = P3_HOT_RST;
        end // P3_HOT_RST:
        P3_HOT_RDY_RELEASE: begin
          if (p3_pld_core_rst_n_r)
            p3_hot_rst_next_state = P3_IN_USE;
          else
            p3_hot_rst_next_state = P3_HOT_RDY_RELEASE;
        end // P3_HOT_RDY_RELEASE:
        default: begin
          p3_hot_rst_next_state = P3_IDLE;
        end
      endcase // p3_hot_rst_cur_state
    end // if (CORE3_ENABLED)
    else begin
      p3_hot_rst_next_state = P3_IDLE;
    end // else
  end // proc_p0_hot_rst_fsm_comb
// endgenerate

//counting in RELEASE_AIB_RST state
always_ff @(posedge coreclkout_hip ) begin : proc_n_cycle_count_to_lock_req
	  if(~src_alive_r[8]) begin 
		 n_cycle_count_to_lock_req <= 0;
	  end 
	  else begin 
			if (cur_state == RELEASE_AIB_RST)
				n_cycle_count_to_lock_req <= n_cycle_count_to_lock_req+1;
			else
				n_cycle_count_to_lock_req <= 0;
			
	  end 

end
//counting in WARM_RST_REQ state
always_ff @(posedge coreclkout_hip ) begin : proc_n_cycle_count_to_rst_rdy
	  if(~src_alive_r[9]) begin 
		 n_cycle_count_to_rst_rdy <= 0;
	  end 
	  else begin
			if (cur_state == WARM_RST_REQ)
			  n_cycle_count_to_rst_rdy <= n_cycle_count_to_rst_rdy + 1;
			else
			  n_cycle_count_to_rst_rdy <= 0;
	  end
  
end
//counting in Px_HOT_RST_REQ state
always_ff @(posedge coreclkout_hip ) begin : proc_n_cycle_count_to_hot_rst_rdy
	  if(~src_alive_r[10]) begin 
		 p0_n_cycle_count_to_hot_rst_rdy <= 0;
		 p1_n_cycle_count_to_hot_rst_rdy <= 0;
		 p2_n_cycle_count_to_hot_rst_rdy <= 0;
		 p3_n_cycle_count_to_hot_rst_rdy <= 0;
	  end
	  else begin
			//P0
			if (p0_hot_rst_cur_state == P0_HOT_RST_REQ)
			  p0_n_cycle_count_to_hot_rst_rdy <= p0_n_cycle_count_to_hot_rst_rdy + 1;
			else
			  p0_n_cycle_count_to_hot_rst_rdy <= 0;
			//P1
			if (p1_hot_rst_cur_state == P1_HOT_RST_REQ)
			  p1_n_cycle_count_to_hot_rst_rdy <= p1_n_cycle_count_to_hot_rst_rdy + 1;
			else
			  p1_n_cycle_count_to_hot_rst_rdy <= 0;
			//P2
			if (p2_hot_rst_cur_state == P2_HOT_RST_REQ)
			  p2_n_cycle_count_to_hot_rst_rdy <= p2_n_cycle_count_to_hot_rst_rdy + 1;
			else
			  p2_n_cycle_count_to_hot_rst_rdy <= 0;
			//P3
			if (p3_hot_rst_cur_state == P3_HOT_RST_REQ)
			  p3_n_cycle_count_to_hot_rst_rdy <= p3_n_cycle_count_to_hot_rst_rdy + 1;
			else
			  p3_n_cycle_count_to_hot_rst_rdy <= 0;
	  end 
 
end
//counting in P0_HOT_RST state:
always_ff @(posedge coreclkout_hip ) begin : proc_n_cycle_count_to_hot_rstrdy_release
	  if(~src_alive_r[11]) begin
		p0_n_cycle_count_to_hot_rstrdy_release <= 0;
		p1_n_cycle_count_to_hot_rstrdy_release <= 0;
		p2_n_cycle_count_to_hot_rstrdy_release <= 0;
		p3_n_cycle_count_to_hot_rstrdy_release <= 0;
	  end 
	  else begin 
			if (p0_hot_rst_cur_state == P0_HOT_RST)
			  p0_n_cycle_count_to_hot_rstrdy_release <= p0_n_cycle_count_to_hot_rstrdy_release + 1;
			else
			  p0_n_cycle_count_to_hot_rstrdy_release <= 0;
			//P1
			if (p1_hot_rst_cur_state == P1_HOT_RST)
			  p1_n_cycle_count_to_hot_rstrdy_release <= p1_n_cycle_count_to_hot_rstrdy_release + 1;
			else
			  p1_n_cycle_count_to_hot_rstrdy_release <= 0;
			//P2
			if (p2_hot_rst_cur_state == P2_HOT_RST)
			  p2_n_cycle_count_to_hot_rstrdy_release <= p2_n_cycle_count_to_hot_rstrdy_release + 1;
			else
			  p2_n_cycle_count_to_hot_rstrdy_release <= 0;
			//P3
			if (p3_hot_rst_cur_state == P3_HOT_RST)
			  p3_n_cycle_count_to_hot_rstrdy_release <= p3_n_cycle_count_to_hot_rstrdy_release + 1;
			else
			  p3_n_cycle_count_to_hot_rstrdy_release <= 0;
	  end 
  
end

//release AIB reset in RELEASE_AIB_RST state for 24 channels:
//remain high until RESET_AIB
assign pld_adapter_tx_pld_rst_n   = (cur_state == RELEASE_AIB_RST) | (pld_adapter_tx_pld_rst_n_r & cur_state != RESET_AIB); 
assign pld_adapter_rx_pld_rst_n   = (cur_state == RELEASE_AIB_RST) | (pld_adapter_rx_pld_rst_n_r & cur_state != RESET_AIB); 
always_ff @(posedge coreclkout_hip ) begin : proc_pld_adapt_pld_rst_n
 
	  if (~src_alive_r[12]) begin 
		pld_adapter_tx_pld_rst_n_r <= 0;
		pld_adapter_rx_pld_rst_n_r <= 0;
	  end 
	  else begin 
		pld_adapter_tx_pld_rst_n_r <= pld_adapter_tx_pld_rst_n;
		pld_adapter_rx_pld_rst_n_r <= pld_adapter_rx_pld_rst_n; 
	  end 
  
end
//request for lock in REQ_LOCK state for 24 channels:
//remain high until RESET_AIB 
assign pld_rx_dll_lock_req = (cur_state == REQ_LOCK) | (pld_rx_dll_lock_req_r & cur_state != RESET_AIB);
assign pld_tx_dll_lock_req = (cur_state == REQ_LOCK) | (pld_tx_dll_lock_req_r & cur_state != RESET_AIB);
always_ff @(posedge coreclkout_hip ) begin : proc_dll_lock_req
	  if (~src_alive_r[13]) begin
		pld_tx_dll_lock_req_r <= 0;
		pld_rx_dll_lock_req_r <= 0;
	  end 
	  else begin 
		pld_tx_dll_lock_req_r <= pld_tx_dll_lock_req;
		pld_rx_dll_lock_req_r <= pld_rx_dll_lock_req;
	  end
 
end

//send pld_ready in PLD_RDY state:
//remain the same until RESET_AIB??? 
assign p0_rst_ports.pld_ready = (cur_state == PLD_RDY) | (p0_pld_ready_r & cur_state != RESET_AIB);
assign p1_rst_ports.pld_ready = (cur_state == PLD_RDY) | (p1_pld_ready_r & cur_state != RESET_AIB);
assign p2_rst_ports.pld_ready = (cur_state == PLD_RDY) | (p2_pld_ready_r & cur_state != RESET_AIB);
assign p3_rst_ports.pld_ready = (cur_state == PLD_RDY) | (p3_pld_ready_r & cur_state != RESET_AIB);
assign upi_pld_ready_o        = ((cur_state == PLD_RDY) | (upi_pld_ready_r & cur_state != RESET_AIB));
always_ff @(posedge coreclkout_hip ) begin : proc_pld_ready
	  if(~src_alive_r[14]) begin
		p0_pld_ready_r <= 0;
		p1_pld_ready_r <= 0;
		p2_pld_ready_r <= 0;
		p3_pld_ready_r <= 0;
		upi_pld_ready_r <= 0;
	  end 
	  else begin 
			p0_pld_ready_r <= p0_rst_ports.pld_ready;
			p1_pld_ready_r <= p1_rst_ports.pld_ready;
			p2_pld_ready_r <= p2_rst_ports.pld_ready;
			p3_pld_ready_r <= p3_rst_ports.pld_ready;
			upi_pld_ready_r<= upi_pld_ready_o; 
	  end 
 
end

//pld_alive signal, asserted in PLD_IN_USE state, remain high until warm reset
//or hot reset
assign p0_pld_alive                 =   (cur_state == PLD_RDY & p0_pld_in_use_r & p0_hot_rst_cur_state[IN_USE_BIT]) | (p0_pld_alive_r & (cur_state != WARM_RST & !p0_hot_rst_cur_state[HOT_RST_BIT]));
assign p1_pld_alive                 =   (cur_state == PLD_RDY & p1_pld_in_use_r & p1_hot_rst_cur_state[IN_USE_BIT]) | (p1_pld_alive_r & (cur_state != WARM_RST & !p1_hot_rst_cur_state[HOT_RST_BIT]));
assign p2_pld_alive                 =   (cur_state == PLD_RDY & p2_pld_in_use_r & p2_hot_rst_cur_state[IN_USE_BIT]) | (p2_pld_alive_r & (cur_state != WARM_RST & !p2_hot_rst_cur_state[HOT_RST_BIT]));
assign p3_pld_alive                 =   (cur_state == PLD_RDY & p3_pld_in_use_r & p3_hot_rst_cur_state[IN_USE_BIT]) | (p3_pld_alive_r & (cur_state != WARM_RST & !p3_hot_rst_cur_state[HOT_RST_BIT]));
assign upi_pld_alive                =   (cur_state == PLD_RDY & upi_pld_in_use_r) | (upi_pld_alive_r & (cur_state != WARM_RST));
always_ff @ (posedge coreclkout_hip ) begin
		if (~src_alive_r[15]) begin 
			p0_pld_alive_r  <=  0;
			p1_pld_alive_r  <=  0;
			p2_pld_alive_r  <=  0;
			p3_pld_alive_r  <=  0;
			upi_pld_alive_r <=  0;
		end 
		else begin 
			p0_pld_alive_r  <=  p0_pld_alive;
			p1_pld_alive_r  <=  p1_pld_alive;
			p2_pld_alive_r  <=  p2_pld_alive;
			p3_pld_alive_r  <=  p3_pld_alive;
			upi_pld_alive_r <=  upi_pld_alive;
		end 
end

//in_warm_rst gets asserted when WARM_RST_RDY
//deasserted when PLD_RDY 
assign in_warm_rst              =       (cur_state == WARM_RST ) | (in_warm_rst_r & (cur_state != PLD_RDY));
always_ff @(posedge coreclkout_hip ) begin
    if (~src_alive_r[16]) begin
        in_warm_rst_r   <=  0;
    end else begin
        in_warm_rst_r   <= in_warm_rst;
    end
end

//send warm_rst_rdy in WARM_RST_RDY and P*_HOT_RST_RDY state
//release warm_rst_rdy in P2_HOT_RDY_RELEASE and RELEASE_WARM_RDY
assign p0_rst_ports.pld_warm_rst_rdy = (cur_state == WARM_RST_RDY | p0_hot_rst_cur_state[HOT_RST_RDY_BIT]) | (p0_pld_warm_rst_rdy_r & (cur_state != RELEASE_WARM_RDY & !p0_hot_rst_cur_state[HOT_RDY_RELEASE_BIT])) ;
assign p1_rst_ports.pld_warm_rst_rdy = (cur_state == WARM_RST_RDY | p1_hot_rst_cur_state[HOT_RST_RDY_BIT]) | (p1_pld_warm_rst_rdy_r & (cur_state != RELEASE_WARM_RDY & !p1_hot_rst_cur_state[HOT_RDY_RELEASE_BIT])) ;
assign p2_rst_ports.pld_warm_rst_rdy = (cur_state == WARM_RST_RDY | p2_hot_rst_cur_state[HOT_RST_RDY_BIT]) | (p2_pld_warm_rst_rdy_r & (cur_state != RELEASE_WARM_RDY & !p2_hot_rst_cur_state[HOT_RDY_RELEASE_BIT])) ;
assign p3_rst_ports.pld_warm_rst_rdy = (cur_state == WARM_RST_RDY | p3_hot_rst_cur_state[HOT_RST_RDY_BIT]) | (p3_pld_warm_rst_rdy_r & (cur_state != RELEASE_WARM_RDY & !p3_hot_rst_cur_state[HOT_RDY_RELEASE_BIT])) ;
assign upi_pld_warm_rst_rdy_o        = (cur_state == WARM_RST_RDY | (upi_pld_warm_rst_rdy_r & cur_state == RELEASE_WARM_RDY ));
always_ff @ (posedge coreclkout_hip ) begin
	  if (~src_alive_r[17]) begin 
		p0_pld_warm_rst_rdy_r <= 0;
		p1_pld_warm_rst_rdy_r <= 0;
		p2_pld_warm_rst_rdy_r <= 0;
		p3_pld_warm_rst_rdy_r <= 0;
		upi_pld_warm_rst_rdy_r<= 0;
	  end 
	  else begin 
		p0_pld_warm_rst_rdy_r <= p0_rst_ports.pld_warm_rst_rdy;
		p1_pld_warm_rst_rdy_r <= p1_rst_ports.pld_warm_rst_rdy;
		p2_pld_warm_rst_rdy_r <= p2_rst_ports.pld_warm_rst_rdy;
		p3_pld_warm_rst_rdy_r <= p3_rst_ports.pld_warm_rst_rdy;
		upi_pld_warm_rst_rdy_r<= upi_pld_warm_rst_rdy_o; 
	  end
 
end // always_ff @ (posedge coreclkout_hip)
//driving 24 MAIB channels
//Duplicated register for each channel
genvar i;
generate
  for (i=0;i<4;i=i+1) begin: channel_rst_ch0_3
    always_ff @(posedge coreclkout_hip ) begin 
     if (~src_alive_r_d[i]) begin 
      pld_adapter_tx_pld_rst_n_r_ch[i] <= 0;
      pld_adapter_rx_pld_rst_n_r_ch[i] <= 0;
      pld_rx_dll_lock_req_r_ch[i] <= 0;
      pld_tx_dll_lock_req_r_ch[i] <= 0;   
      pld_adapter_tx_pld_rst_n_r_ch_reg[i] <= 0;
      pld_adapter_rx_pld_rst_n_r_ch_reg[i] <= 0;
      pld_rx_dll_lock_req_r_ch_reg[i] <= 0;
      pld_tx_dll_lock_req_r_ch_reg[i] <= 0; 
     end
     else begin 
      pld_adapter_tx_pld_rst_n_r_ch_reg[i] <= pld_adapter_tx_pld_rst_n_r;
      pld_adapter_rx_pld_rst_n_r_ch_reg[i] <= pld_adapter_rx_pld_rst_n_r;
      pld_rx_dll_lock_req_r_ch_reg[i] <= pld_rx_dll_lock_req_r;
      pld_tx_dll_lock_req_r_ch_reg[i] <= pld_tx_dll_lock_req_r;
      pld_adapter_tx_pld_rst_n_r_ch[i] <= pld_adapter_tx_pld_rst_n_r_ch_reg[i];
      pld_adapter_rx_pld_rst_n_r_ch[i] <= pld_adapter_rx_pld_rst_n_r_ch_reg[i];
      pld_rx_dll_lock_req_r_ch[i] <= pld_rx_dll_lock_req_r_ch_reg[i];
      pld_tx_dll_lock_req_r_ch[i] <= pld_tx_dll_lock_req_r_ch_reg[i];
     end 
    end
  end
endgenerate

generate
  for (i=1;i<5;i=i+1) begin: channel_rst_ch4_19
    always_ff @(posedge coreclkout_hip ) begin 
     if (~src_alive_r_d[i+3]) begin 
      pld_adapter_tx_pld_rst_n_r_ch[(4*(i+1)-1):(i*4)] <= 0;
      pld_adapter_rx_pld_rst_n_r_ch[(4*(i+1)-1):(i*4)] <= 0;
      pld_rx_dll_lock_req_r_ch[(4*(i+1)-1):(i*4)] <= 0;
      pld_tx_dll_lock_req_r_ch[(4*(i+1)-1):(i*4)] <= 0;   
      pld_adapter_tx_pld_rst_n_r_ch_reg[(4*(i+1)-1):(i*4)] <= 0;
      pld_adapter_rx_pld_rst_n_r_ch_reg[(4*(i+1)-1):(i*4)] <= 0;
      pld_rx_dll_lock_req_r_ch_reg[(4*(i+1)-1):(i*4)] <= 0;
      pld_tx_dll_lock_req_r_ch_reg[(4*(i+1)-1):(i*4)] <= 0; 
     end
     else begin 
      pld_adapter_tx_pld_rst_n_r_ch_reg[(4*(i+1)-1):(i*4)] <= {4{pld_adapter_tx_pld_rst_n_r}};
      pld_adapter_rx_pld_rst_n_r_ch_reg[(4*(i+1)-1):(i*4)] <= {4{pld_adapter_rx_pld_rst_n_r}};
      pld_rx_dll_lock_req_r_ch_reg[(4*(i+1)-1):(i*4)] <= {4{pld_rx_dll_lock_req_r}};
      pld_tx_dll_lock_req_r_ch_reg[(4*(i+1)-1):(i*4)] <= {4{pld_tx_dll_lock_req_r}};
      pld_adapter_tx_pld_rst_n_r_ch[(4*(i+1)-1):(i*4)] <= pld_adapter_tx_pld_rst_n_r_ch_reg[(4*(i+1)-1):(i*4)];
      pld_adapter_rx_pld_rst_n_r_ch[(4*(i+1)-1):(i*4)] <= pld_adapter_rx_pld_rst_n_r_ch_reg[(4*(i+1)-1):(i*4)];
      pld_rx_dll_lock_req_r_ch[(4*(i+1)-1):(i*4)] <= pld_rx_dll_lock_req_r_ch_reg[(4*(i+1)-1):(i*4)];
      pld_tx_dll_lock_req_r_ch[(4*(i+1)-1):(i*4)] <= pld_tx_dll_lock_req_r_ch_reg[(4*(i+1)-1):(i*4)];
     end 
    end
  end
endgenerate

generate
  for (i=8;i<12;i=i+1) begin: channel_rst_ch20_23
    always_ff @(posedge coreclkout_hip ) begin 
     if (~src_alive_r_d[i]) begin 
      pld_adapter_tx_pld_rst_n_r_ch[i+12] <= 0;
      pld_adapter_rx_pld_rst_n_r_ch[i+12] <= 0;
      pld_rx_dll_lock_req_r_ch[i+12] <= 0;
      pld_tx_dll_lock_req_r_ch[i+12] <= 0;   
      pld_adapter_tx_pld_rst_n_r_ch_reg[i+12] <= 0;
      pld_adapter_rx_pld_rst_n_r_ch_reg[i+12] <= 0;
      pld_rx_dll_lock_req_r_ch_reg[i+12] <= 0;
      pld_tx_dll_lock_req_r_ch_reg[i+12] <= 0; 
     end
     else begin 
      pld_adapter_tx_pld_rst_n_r_ch_reg[i+12] <= pld_adapter_tx_pld_rst_n_r;
      pld_adapter_rx_pld_rst_n_r_ch_reg[i+12] <= pld_adapter_rx_pld_rst_n_r;
      pld_rx_dll_lock_req_r_ch_reg[i+12] <= pld_rx_dll_lock_req_r;
      pld_tx_dll_lock_req_r_ch_reg[i+12] <= pld_tx_dll_lock_req_r;
      pld_adapter_tx_pld_rst_n_r_ch[i+12] <= pld_adapter_tx_pld_rst_n_r_ch_reg[i+12];
      pld_adapter_rx_pld_rst_n_r_ch[i+12] <= pld_adapter_rx_pld_rst_n_r_ch_reg[i+12];
      pld_rx_dll_lock_req_r_ch[i+12] <= pld_rx_dll_lock_req_r_ch_reg[i+12];
      pld_tx_dll_lock_req_r_ch[i+12] <= pld_tx_dll_lock_req_r_ch_reg[i+12];
     end 
    end
  end
endgenerate


assign {pld_aib_ch0.pld_adapter_tx_pld_rst_n, pld_aib_ch0.pld_adapter_rx_pld_rst_n, pld_aib_ch0.pld_tx_dll_lock_req, pld_aib_ch0.pld_rx_dll_lock_req} = {pld_adapter_tx_pld_rst_n_r_ch[0], pld_adapter_rx_pld_rst_n_r_ch[0], pld_tx_dll_lock_req_r_ch[0], pld_rx_dll_lock_req_r_ch[0]};
assign {pld_aib_ch1.pld_adapter_tx_pld_rst_n, pld_aib_ch1.pld_adapter_rx_pld_rst_n, pld_aib_ch1.pld_tx_dll_lock_req, pld_aib_ch1.pld_rx_dll_lock_req} = {pld_adapter_tx_pld_rst_n_r_ch[1], pld_adapter_rx_pld_rst_n_r_ch[1], pld_tx_dll_lock_req_r_ch[1], pld_rx_dll_lock_req_r_ch[1]};
assign {pld_aib_ch2.pld_adapter_tx_pld_rst_n, pld_aib_ch2.pld_adapter_rx_pld_rst_n, pld_aib_ch2.pld_tx_dll_lock_req, pld_aib_ch2.pld_rx_dll_lock_req} = {pld_adapter_tx_pld_rst_n_r_ch[2], pld_adapter_rx_pld_rst_n_r_ch[2], pld_tx_dll_lock_req_r_ch[2], pld_rx_dll_lock_req_r_ch[2]};
assign {pld_aib_ch3.pld_adapter_tx_pld_rst_n, pld_aib_ch3.pld_adapter_rx_pld_rst_n, pld_aib_ch3.pld_tx_dll_lock_req, pld_aib_ch3.pld_rx_dll_lock_req} = {pld_adapter_tx_pld_rst_n_r_ch[3], pld_adapter_rx_pld_rst_n_r_ch[3], pld_tx_dll_lock_req_r_ch[3], pld_rx_dll_lock_req_r_ch[3]};
assign {pld_aib_ch4.pld_adapter_tx_pld_rst_n, pld_aib_ch4.pld_adapter_rx_pld_rst_n, pld_aib_ch4.pld_tx_dll_lock_req, pld_aib_ch4.pld_rx_dll_lock_req} = {pld_adapter_tx_pld_rst_n_r_ch[4], pld_adapter_rx_pld_rst_n_r_ch[4], pld_tx_dll_lock_req_r_ch[4], pld_rx_dll_lock_req_r_ch[4]};
assign {pld_aib_ch5.pld_adapter_tx_pld_rst_n, pld_aib_ch5.pld_adapter_rx_pld_rst_n, pld_aib_ch5.pld_tx_dll_lock_req, pld_aib_ch5.pld_rx_dll_lock_req} = {pld_adapter_tx_pld_rst_n_r_ch[5], pld_adapter_rx_pld_rst_n_r_ch[5], pld_tx_dll_lock_req_r_ch[5], pld_rx_dll_lock_req_r_ch[5]};
assign {pld_aib_ch6.pld_adapter_tx_pld_rst_n, pld_aib_ch6.pld_adapter_rx_pld_rst_n, pld_aib_ch6.pld_tx_dll_lock_req, pld_aib_ch6.pld_rx_dll_lock_req} = {pld_adapter_tx_pld_rst_n_r_ch[6], pld_adapter_rx_pld_rst_n_r_ch[6], pld_tx_dll_lock_req_r_ch[6], pld_rx_dll_lock_req_r_ch[6]};
assign {pld_aib_ch7.pld_adapter_tx_pld_rst_n, pld_aib_ch7.pld_adapter_rx_pld_rst_n, pld_aib_ch7.pld_tx_dll_lock_req, pld_aib_ch7.pld_rx_dll_lock_req} = {pld_adapter_tx_pld_rst_n_r_ch[7], pld_adapter_rx_pld_rst_n_r_ch[7], pld_tx_dll_lock_req_r_ch[7], pld_rx_dll_lock_req_r_ch[7]};
assign {pld_aib_ch8.pld_adapter_tx_pld_rst_n, pld_aib_ch8.pld_adapter_rx_pld_rst_n, pld_aib_ch8.pld_tx_dll_lock_req, pld_aib_ch8.pld_rx_dll_lock_req} = {pld_adapter_tx_pld_rst_n_r_ch[8], pld_adapter_rx_pld_rst_n_r_ch[8], pld_tx_dll_lock_req_r_ch[8], pld_rx_dll_lock_req_r_ch[8]};
assign {pld_aib_ch9.pld_adapter_tx_pld_rst_n, pld_aib_ch9.pld_adapter_rx_pld_rst_n, pld_aib_ch9.pld_tx_dll_lock_req, pld_aib_ch9.pld_rx_dll_lock_req} = {pld_adapter_tx_pld_rst_n_r_ch[9], pld_adapter_rx_pld_rst_n_r_ch[9], pld_tx_dll_lock_req_r_ch[9], pld_rx_dll_lock_req_r_ch[9]};
assign {pld_aib_ch10.pld_adapter_tx_pld_rst_n, pld_aib_ch10.pld_adapter_rx_pld_rst_n, pld_aib_ch10.pld_tx_dll_lock_req, pld_aib_ch10.pld_rx_dll_lock_req} = {pld_adapter_tx_pld_rst_n_r_ch[10], pld_adapter_rx_pld_rst_n_r_ch[10], pld_tx_dll_lock_req_r_ch[10], pld_rx_dll_lock_req_r_ch[10]};
assign {pld_aib_ch11.pld_adapter_tx_pld_rst_n, pld_aib_ch11.pld_adapter_rx_pld_rst_n, pld_aib_ch11.pld_tx_dll_lock_req, pld_aib_ch11.pld_rx_dll_lock_req} = {pld_adapter_tx_pld_rst_n_r_ch[11], pld_adapter_rx_pld_rst_n_r_ch[11], pld_tx_dll_lock_req_r_ch[11], pld_rx_dll_lock_req_r_ch[11]};
assign {pld_aib_ch12.pld_adapter_tx_pld_rst_n, pld_aib_ch12.pld_adapter_rx_pld_rst_n, pld_aib_ch12.pld_tx_dll_lock_req, pld_aib_ch12.pld_rx_dll_lock_req} = {pld_adapter_tx_pld_rst_n_r_ch[12], pld_adapter_rx_pld_rst_n_r_ch[12], pld_tx_dll_lock_req_r_ch[12], pld_rx_dll_lock_req_r_ch[12]};
assign {pld_aib_ch13.pld_adapter_tx_pld_rst_n, pld_aib_ch13.pld_adapter_rx_pld_rst_n, pld_aib_ch13.pld_tx_dll_lock_req, pld_aib_ch13.pld_rx_dll_lock_req} = {pld_adapter_tx_pld_rst_n_r_ch[13], pld_adapter_rx_pld_rst_n_r_ch[13], pld_tx_dll_lock_req_r_ch[13], pld_rx_dll_lock_req_r_ch[13]};
assign {pld_aib_ch14.pld_adapter_tx_pld_rst_n, pld_aib_ch14.pld_adapter_rx_pld_rst_n, pld_aib_ch14.pld_tx_dll_lock_req, pld_aib_ch14.pld_rx_dll_lock_req} = {pld_adapter_tx_pld_rst_n_r_ch[14], pld_adapter_rx_pld_rst_n_r_ch[14], pld_tx_dll_lock_req_r_ch[14], pld_rx_dll_lock_req_r_ch[14]};
assign {pld_aib_ch15.pld_adapter_tx_pld_rst_n, pld_aib_ch15.pld_adapter_rx_pld_rst_n, pld_aib_ch15.pld_tx_dll_lock_req, pld_aib_ch15.pld_rx_dll_lock_req} = {pld_adapter_tx_pld_rst_n_r_ch[15], pld_adapter_rx_pld_rst_n_r_ch[15], pld_tx_dll_lock_req_r_ch[15], pld_rx_dll_lock_req_r_ch[15]};
assign {pld_aib_ch16.pld_adapter_tx_pld_rst_n, pld_aib_ch16.pld_adapter_rx_pld_rst_n, pld_aib_ch16.pld_tx_dll_lock_req, pld_aib_ch16.pld_rx_dll_lock_req} = {pld_adapter_tx_pld_rst_n_r_ch[16], pld_adapter_rx_pld_rst_n_r_ch[16], pld_tx_dll_lock_req_r_ch[16], pld_rx_dll_lock_req_r_ch[16]};
assign {pld_aib_ch17.pld_adapter_tx_pld_rst_n, pld_aib_ch17.pld_adapter_rx_pld_rst_n, pld_aib_ch17.pld_tx_dll_lock_req, pld_aib_ch17.pld_rx_dll_lock_req} = {pld_adapter_tx_pld_rst_n_r_ch[17], pld_adapter_rx_pld_rst_n_r_ch[17], pld_tx_dll_lock_req_r_ch[17], pld_rx_dll_lock_req_r_ch[17]};
assign {pld_aib_ch18.pld_adapter_tx_pld_rst_n, pld_aib_ch18.pld_adapter_rx_pld_rst_n, pld_aib_ch18.pld_tx_dll_lock_req, pld_aib_ch18.pld_rx_dll_lock_req} = {pld_adapter_tx_pld_rst_n_r_ch[18], pld_adapter_rx_pld_rst_n_r_ch[18], pld_tx_dll_lock_req_r_ch[18], pld_rx_dll_lock_req_r_ch[18]};
assign {pld_aib_ch19.pld_adapter_tx_pld_rst_n, pld_aib_ch19.pld_adapter_rx_pld_rst_n, pld_aib_ch19.pld_tx_dll_lock_req, pld_aib_ch19.pld_rx_dll_lock_req} = {pld_adapter_tx_pld_rst_n_r_ch[19], pld_adapter_rx_pld_rst_n_r_ch[19], pld_tx_dll_lock_req_r_ch[19], pld_rx_dll_lock_req_r_ch[19]};
assign {pld_aib_ch20.pld_adapter_tx_pld_rst_n, pld_aib_ch20.pld_adapter_rx_pld_rst_n, pld_aib_ch20.pld_tx_dll_lock_req, pld_aib_ch20.pld_rx_dll_lock_req} = {pld_adapter_tx_pld_rst_n_r_ch[20], pld_adapter_rx_pld_rst_n_r_ch[20], pld_tx_dll_lock_req_r_ch[20], pld_rx_dll_lock_req_r_ch[20]};
assign {pld_aib_ch21.pld_adapter_tx_pld_rst_n, pld_aib_ch21.pld_adapter_rx_pld_rst_n, pld_aib_ch21.pld_tx_dll_lock_req, pld_aib_ch21.pld_rx_dll_lock_req} = {pld_adapter_tx_pld_rst_n_r_ch[21], pld_adapter_rx_pld_rst_n_r_ch[21], pld_tx_dll_lock_req_r_ch[21], pld_rx_dll_lock_req_r_ch[21]};
assign {pld_aib_ch22.pld_adapter_tx_pld_rst_n, pld_aib_ch22.pld_adapter_rx_pld_rst_n, pld_aib_ch22.pld_tx_dll_lock_req, pld_aib_ch22.pld_rx_dll_lock_req} = {pld_adapter_tx_pld_rst_n_r_ch[22], pld_adapter_rx_pld_rst_n_r_ch[22], pld_tx_dll_lock_req_r_ch[22], pld_rx_dll_lock_req_r_ch[22]};
assign {pld_aib_ch23.pld_adapter_tx_pld_rst_n, pld_aib_ch23.pld_adapter_rx_pld_rst_n, pld_aib_ch23.pld_tx_dll_lock_req, pld_aib_ch23.pld_rx_dll_lock_req} = {pld_adapter_tx_pld_rst_n_r_ch[23], pld_adapter_rx_pld_rst_n_r_ch[23], pld_tx_dll_lock_req_r_ch[23], pld_rx_dll_lock_req_r_ch[23]};
///AND of 24 AIB channels
//2 cycles, 6*4 

always_ff @(posedge coreclkout_hip) begin
	  if (~src_alive_r[18]) begin 
        pld_aib_ch0_pld_fabric_tx_transfer_en_q  <= '0;
        pld_aib_ch1_pld_fabric_tx_transfer_en_q  <= '0;
        pld_aib_ch2_pld_fabric_tx_transfer_en_q  <= '0;
        pld_aib_ch3_pld_fabric_tx_transfer_en_q  <= '0;
        pld_aib_ch4_pld_fabric_tx_transfer_en_q  <= '0;
        pld_aib_ch5_pld_fabric_tx_transfer_en_q  <= '0;
        pld_aib_ch6_pld_fabric_tx_transfer_en_q  <= '0;
        pld_aib_ch7_pld_fabric_tx_transfer_en_q  <= '0;
        pld_aib_ch8_pld_fabric_tx_transfer_en_q  <= '0;
        pld_aib_ch9_pld_fabric_tx_transfer_en_q  <= '0;
        pld_aib_ch10_pld_fabric_tx_transfer_en_q <= '0;
        pld_aib_ch11_pld_fabric_tx_transfer_en_q <= '0;
        pld_aib_ch12_pld_fabric_tx_transfer_en_q <= '0;
        pld_aib_ch13_pld_fabric_tx_transfer_en_q <= '0;
        pld_aib_ch14_pld_fabric_tx_transfer_en_q <= '0;
        pld_aib_ch15_pld_fabric_tx_transfer_en_q <= '0;
        pld_aib_ch16_pld_fabric_tx_transfer_en_q <= '0;
        pld_aib_ch17_pld_fabric_tx_transfer_en_q <= '0;
        pld_aib_ch18_pld_fabric_tx_transfer_en_q <= '0;
        pld_aib_ch19_pld_fabric_tx_transfer_en_q <= '0;
        pld_aib_ch20_pld_fabric_tx_transfer_en_q <= '0;
        pld_aib_ch21_pld_fabric_tx_transfer_en_q <= '0;
        pld_aib_ch22_pld_fabric_tx_transfer_en_q <= '0;
        pld_aib_ch23_pld_fabric_tx_transfer_en_q <= '0;
        pld_aib_ch0_pld_hssi_rx_transfer_en_q    <= '0;
        pld_aib_ch1_pld_hssi_rx_transfer_en_q    <= '0;
        pld_aib_ch2_pld_hssi_rx_transfer_en_q    <= '0;
        pld_aib_ch3_pld_hssi_rx_transfer_en_q    <= '0;
        pld_aib_ch4_pld_hssi_rx_transfer_en_q    <= '0;
        pld_aib_ch5_pld_hssi_rx_transfer_en_q    <= '0;
        pld_aib_ch6_pld_hssi_rx_transfer_en_q    <= '0;
        pld_aib_ch7_pld_hssi_rx_transfer_en_q    <= '0;
        pld_aib_ch8_pld_hssi_rx_transfer_en_q    <= '0;
        pld_aib_ch9_pld_hssi_rx_transfer_en_q    <= '0;
        pld_aib_ch10_pld_hssi_rx_transfer_en_q   <= '0;
        pld_aib_ch11_pld_hssi_rx_transfer_en_q   <= '0;
        pld_aib_ch12_pld_hssi_rx_transfer_en_q   <= '0;
        pld_aib_ch13_pld_hssi_rx_transfer_en_q   <= '0;
        pld_aib_ch14_pld_hssi_rx_transfer_en_q   <= '0;
        pld_aib_ch15_pld_hssi_rx_transfer_en_q   <= '0;
        pld_aib_ch16_pld_hssi_rx_transfer_en_q   <= '0;
        pld_aib_ch17_pld_hssi_rx_transfer_en_q   <= '0;
        pld_aib_ch18_pld_hssi_rx_transfer_en_q   <= '0;
        pld_aib_ch19_pld_hssi_rx_transfer_en_q   <= '0;
        pld_aib_ch20_pld_hssi_rx_transfer_en_q   <= '0;
        pld_aib_ch21_pld_hssi_rx_transfer_en_q   <= '0;
        pld_aib_ch22_pld_hssi_rx_transfer_en_q   <= '0;
        pld_aib_ch23_pld_hssi_rx_transfer_en_q   <= '0;
        pld_aib_ch0_pld_hssi_osc_transfer_en_q   <= '0;
        pld_aib_ch1_pld_hssi_osc_transfer_en_q   <= '0;
        pld_aib_ch2_pld_hssi_osc_transfer_en_q   <= '0;
        pld_aib_ch3_pld_hssi_osc_transfer_en_q   <= '0;
        pld_aib_ch4_pld_hssi_osc_transfer_en_q   <= '0;
        pld_aib_ch5_pld_hssi_osc_transfer_en_q   <= '0;
        pld_aib_ch6_pld_hssi_osc_transfer_en_q   <= '0;
        pld_aib_ch7_pld_hssi_osc_transfer_en_q   <= '0;
        pld_aib_ch8_pld_hssi_osc_transfer_en_q   <= '0;
        pld_aib_ch9_pld_hssi_osc_transfer_en_q   <= '0;
        pld_aib_ch10_pld_hssi_osc_transfer_en_q  <= '0;
        pld_aib_ch11_pld_hssi_osc_transfer_en_q  <= '0;
        pld_aib_ch12_pld_hssi_osc_transfer_en_q  <= '0;
        pld_aib_ch13_pld_hssi_osc_transfer_en_q  <= '0;
        pld_aib_ch14_pld_hssi_osc_transfer_en_q  <= '0;
        pld_aib_ch15_pld_hssi_osc_transfer_en_q  <= '0;
        pld_aib_ch16_pld_hssi_osc_transfer_en_q  <= '0;
        pld_aib_ch17_pld_hssi_osc_transfer_en_q  <= '0;
        pld_aib_ch18_pld_hssi_osc_transfer_en_q  <= '0;
        pld_aib_ch19_pld_hssi_osc_transfer_en_q  <= '0;
        pld_aib_ch20_pld_hssi_osc_transfer_en_q  <= '0;
        pld_aib_ch21_pld_hssi_osc_transfer_en_q  <= '0;
        pld_aib_ch22_pld_hssi_osc_transfer_en_q  <= '0;
        pld_aib_ch23_pld_hssi_osc_transfer_en_q  <= '0;
	  end 
	  else begin
        pld_aib_ch0_pld_fabric_tx_transfer_en_q  <= pld_aib_ch0.pld_fabric_tx_transfer_en;
		pld_aib_ch1_pld_fabric_tx_transfer_en_q  <= pld_aib_ch1.pld_fabric_tx_transfer_en;
		pld_aib_ch2_pld_fabric_tx_transfer_en_q  <= pld_aib_ch2.pld_fabric_tx_transfer_en;
		pld_aib_ch3_pld_fabric_tx_transfer_en_q  <= pld_aib_ch3.pld_fabric_tx_transfer_en;
		pld_aib_ch4_pld_fabric_tx_transfer_en_q  <= pld_aib_ch4.pld_fabric_tx_transfer_en;
		pld_aib_ch5_pld_fabric_tx_transfer_en_q  <= pld_aib_ch5.pld_fabric_tx_transfer_en;
		pld_aib_ch6_pld_fabric_tx_transfer_en_q  <= pld_aib_ch6.pld_fabric_tx_transfer_en;
		pld_aib_ch7_pld_fabric_tx_transfer_en_q  <= pld_aib_ch7.pld_fabric_tx_transfer_en;
		pld_aib_ch8_pld_fabric_tx_transfer_en_q  <= pld_aib_ch8.pld_fabric_tx_transfer_en;
		pld_aib_ch9_pld_fabric_tx_transfer_en_q  <= pld_aib_ch9.pld_fabric_tx_transfer_en;
		pld_aib_ch10_pld_fabric_tx_transfer_en_q <= pld_aib_ch10.pld_fabric_tx_transfer_en;
		pld_aib_ch11_pld_fabric_tx_transfer_en_q <= pld_aib_ch11.pld_fabric_tx_transfer_en;
		pld_aib_ch12_pld_fabric_tx_transfer_en_q <= pld_aib_ch12.pld_fabric_tx_transfer_en;
		pld_aib_ch13_pld_fabric_tx_transfer_en_q <= pld_aib_ch13.pld_fabric_tx_transfer_en;
		pld_aib_ch14_pld_fabric_tx_transfer_en_q <= pld_aib_ch14.pld_fabric_tx_transfer_en;
		pld_aib_ch15_pld_fabric_tx_transfer_en_q <= pld_aib_ch15.pld_fabric_tx_transfer_en;
		pld_aib_ch16_pld_fabric_tx_transfer_en_q <= pld_aib_ch16.pld_fabric_tx_transfer_en;
		pld_aib_ch17_pld_fabric_tx_transfer_en_q <= pld_aib_ch17.pld_fabric_tx_transfer_en;
		pld_aib_ch18_pld_fabric_tx_transfer_en_q <= pld_aib_ch18.pld_fabric_tx_transfer_en;
		pld_aib_ch19_pld_fabric_tx_transfer_en_q <= pld_aib_ch19.pld_fabric_tx_transfer_en;
		pld_aib_ch20_pld_fabric_tx_transfer_en_q <= pld_aib_ch20.pld_fabric_tx_transfer_en;
		pld_aib_ch21_pld_fabric_tx_transfer_en_q <= pld_aib_ch21.pld_fabric_tx_transfer_en;
		pld_aib_ch22_pld_fabric_tx_transfer_en_q <= pld_aib_ch22.pld_fabric_tx_transfer_en;
		pld_aib_ch23_pld_fabric_tx_transfer_en_q <= pld_aib_ch23.pld_fabric_tx_transfer_en;
		pld_aib_ch0_pld_hssi_rx_transfer_en_q    <= pld_aib_ch0.pld_hssi_rx_transfer_en;
		pld_aib_ch1_pld_hssi_rx_transfer_en_q    <= pld_aib_ch1.pld_hssi_rx_transfer_en;
		pld_aib_ch2_pld_hssi_rx_transfer_en_q    <= pld_aib_ch2.pld_hssi_rx_transfer_en;
		pld_aib_ch3_pld_hssi_rx_transfer_en_q    <= pld_aib_ch3.pld_hssi_rx_transfer_en;
		pld_aib_ch4_pld_hssi_rx_transfer_en_q    <= pld_aib_ch4.pld_hssi_rx_transfer_en;
		pld_aib_ch5_pld_hssi_rx_transfer_en_q    <= pld_aib_ch5.pld_hssi_rx_transfer_en;
		pld_aib_ch6_pld_hssi_rx_transfer_en_q    <= pld_aib_ch6.pld_hssi_rx_transfer_en;
		pld_aib_ch7_pld_hssi_rx_transfer_en_q    <= pld_aib_ch7.pld_hssi_rx_transfer_en;
		pld_aib_ch8_pld_hssi_rx_transfer_en_q    <= pld_aib_ch8.pld_hssi_rx_transfer_en;
		pld_aib_ch9_pld_hssi_rx_transfer_en_q    <= pld_aib_ch9.pld_hssi_rx_transfer_en;
		pld_aib_ch10_pld_hssi_rx_transfer_en_q   <= pld_aib_ch10.pld_hssi_rx_transfer_en;
		pld_aib_ch11_pld_hssi_rx_transfer_en_q   <= pld_aib_ch11.pld_hssi_rx_transfer_en;
		pld_aib_ch12_pld_hssi_rx_transfer_en_q   <= pld_aib_ch12.pld_hssi_rx_transfer_en;
		pld_aib_ch13_pld_hssi_rx_transfer_en_q   <= pld_aib_ch13.pld_hssi_rx_transfer_en;
		pld_aib_ch14_pld_hssi_rx_transfer_en_q   <= pld_aib_ch14.pld_hssi_rx_transfer_en;
		pld_aib_ch15_pld_hssi_rx_transfer_en_q   <= pld_aib_ch15.pld_hssi_rx_transfer_en;
		pld_aib_ch16_pld_hssi_rx_transfer_en_q   <= pld_aib_ch16.pld_hssi_rx_transfer_en;
		pld_aib_ch17_pld_hssi_rx_transfer_en_q   <= pld_aib_ch17.pld_hssi_rx_transfer_en;
		pld_aib_ch18_pld_hssi_rx_transfer_en_q   <= pld_aib_ch18.pld_hssi_rx_transfer_en;
		pld_aib_ch19_pld_hssi_rx_transfer_en_q   <= pld_aib_ch19.pld_hssi_rx_transfer_en;
		pld_aib_ch20_pld_hssi_rx_transfer_en_q   <= pld_aib_ch20.pld_hssi_rx_transfer_en;
		pld_aib_ch21_pld_hssi_rx_transfer_en_q   <= pld_aib_ch21.pld_hssi_rx_transfer_en;
		pld_aib_ch22_pld_hssi_rx_transfer_en_q   <= pld_aib_ch22.pld_hssi_rx_transfer_en;
		pld_aib_ch23_pld_hssi_rx_transfer_en_q   <= pld_aib_ch23.pld_hssi_rx_transfer_en;
		pld_aib_ch0_pld_hssi_osc_transfer_en_q   <= pld_aib_ch0.pld_hssi_osc_transfer_en;
		pld_aib_ch1_pld_hssi_osc_transfer_en_q   <= pld_aib_ch1.pld_hssi_osc_transfer_en;
		pld_aib_ch2_pld_hssi_osc_transfer_en_q   <= pld_aib_ch2.pld_hssi_osc_transfer_en;
		pld_aib_ch3_pld_hssi_osc_transfer_en_q   <= pld_aib_ch3.pld_hssi_osc_transfer_en;
		pld_aib_ch4_pld_hssi_osc_transfer_en_q   <= pld_aib_ch4.pld_hssi_osc_transfer_en;
		pld_aib_ch5_pld_hssi_osc_transfer_en_q   <= pld_aib_ch5.pld_hssi_osc_transfer_en;
		pld_aib_ch6_pld_hssi_osc_transfer_en_q   <= pld_aib_ch6.pld_hssi_osc_transfer_en;
		pld_aib_ch7_pld_hssi_osc_transfer_en_q   <= pld_aib_ch7.pld_hssi_osc_transfer_en;
		pld_aib_ch8_pld_hssi_osc_transfer_en_q   <= pld_aib_ch8.pld_hssi_osc_transfer_en;
		pld_aib_ch9_pld_hssi_osc_transfer_en_q   <= pld_aib_ch9.pld_hssi_osc_transfer_en;
		pld_aib_ch10_pld_hssi_osc_transfer_en_q  <= pld_aib_ch10.pld_hssi_osc_transfer_en;
		pld_aib_ch11_pld_hssi_osc_transfer_en_q  <= pld_aib_ch11.pld_hssi_osc_transfer_en;
		pld_aib_ch12_pld_hssi_osc_transfer_en_q  <= pld_aib_ch12.pld_hssi_osc_transfer_en;
		pld_aib_ch13_pld_hssi_osc_transfer_en_q  <= pld_aib_ch13.pld_hssi_osc_transfer_en;
		pld_aib_ch14_pld_hssi_osc_transfer_en_q  <= pld_aib_ch14.pld_hssi_osc_transfer_en;
		pld_aib_ch15_pld_hssi_osc_transfer_en_q  <= pld_aib_ch15.pld_hssi_osc_transfer_en;
		pld_aib_ch16_pld_hssi_osc_transfer_en_q  <= pld_aib_ch16.pld_hssi_osc_transfer_en;
		pld_aib_ch17_pld_hssi_osc_transfer_en_q  <= pld_aib_ch17.pld_hssi_osc_transfer_en;
		pld_aib_ch18_pld_hssi_osc_transfer_en_q  <= pld_aib_ch18.pld_hssi_osc_transfer_en;
		pld_aib_ch19_pld_hssi_osc_transfer_en_q  <= pld_aib_ch19.pld_hssi_osc_transfer_en;
		pld_aib_ch20_pld_hssi_osc_transfer_en_q  <= pld_aib_ch20.pld_hssi_osc_transfer_en;
		pld_aib_ch21_pld_hssi_osc_transfer_en_q  <= pld_aib_ch21.pld_hssi_osc_transfer_en;
		pld_aib_ch22_pld_hssi_osc_transfer_en_q  <= pld_aib_ch22.pld_hssi_osc_transfer_en;
		pld_aib_ch23_pld_hssi_osc_transfer_en_q  <= pld_aib_ch23.pld_hssi_osc_transfer_en;
      end 
end

always_ff @(posedge coreclkout_hip) begin : proc_aib_transfer_en
	  if (~src_alive_r[19]) begin 
		//first 6-input AND
		pld_fabric_tx_transfer_en_ch_0_5_r    <= 0;
		pld_fabric_tx_transfer_en_ch_6_11_r   <= 0;
		pld_fabric_tx_transfer_en_ch_12_17_r  <= 0;
		pld_fabric_tx_transfer_en_ch_18_23_r  <= 0;
		pld_hssi_rx_transfer_en_ch_0_5_r    <= 0;
		pld_hssi_rx_transfer_en_ch_6_11_r   <= 0;
		pld_hssi_rx_transfer_en_ch_12_17_r  <= 0;
		pld_hssi_rx_transfer_en_ch_18_23_r  <= 0;
		pld_hssi_osc_transfer_en_ch_0_5_r	<= 0;
		pld_hssi_osc_transfer_en_ch_6_11_r  <= 0;
		pld_hssi_osc_transfer_en_ch_12_17_r <= 0;
		pld_hssi_osc_transfer_en_ch_18_23_r <= 0;
		//second cycle 4-input AND
		pld_fabric_tx_transfer_en_2r          <= 0;
		pld_hssi_rx_transfer_en_2r          <= 0;
		pld_hssi_osc_transfer_en_2r         <= 0;
	  end 
	  else begin
 		pld_fabric_tx_transfer_en_ch_0_5_r   <= pld_aib_ch0_pld_fabric_tx_transfer_en_q & pld_aib_ch1_pld_fabric_tx_transfer_en_q & pld_aib_ch2_pld_fabric_tx_transfer_en_q & pld_aib_ch3_pld_fabric_tx_transfer_en_q & pld_aib_ch4_pld_fabric_tx_transfer_en_q & pld_aib_ch5_pld_fabric_tx_transfer_en_q;
		pld_fabric_tx_transfer_en_ch_6_11_r  <= pld_aib_ch6_pld_fabric_tx_transfer_en_q & pld_aib_ch7_pld_fabric_tx_transfer_en_q & pld_aib_ch8_pld_fabric_tx_transfer_en_q & pld_aib_ch9_pld_fabric_tx_transfer_en_q & pld_aib_ch10_pld_fabric_tx_transfer_en_q & pld_aib_ch11_pld_fabric_tx_transfer_en_q;
		pld_fabric_tx_transfer_en_ch_12_17_r <= pld_aib_ch12_pld_fabric_tx_transfer_en_q & pld_aib_ch13_pld_fabric_tx_transfer_en_q & pld_aib_ch14_pld_fabric_tx_transfer_en_q & pld_aib_ch15_pld_fabric_tx_transfer_en_q & pld_aib_ch16_pld_fabric_tx_transfer_en_q & pld_aib_ch17_pld_fabric_tx_transfer_en_q;
		pld_fabric_tx_transfer_en_ch_18_23_r <= pld_aib_ch18_pld_fabric_tx_transfer_en_q & pld_aib_ch19_pld_fabric_tx_transfer_en_q & pld_aib_ch20_pld_fabric_tx_transfer_en_q & pld_aib_ch21_pld_fabric_tx_transfer_en_q & pld_aib_ch22_pld_fabric_tx_transfer_en_q & pld_aib_ch23_pld_fabric_tx_transfer_en_q;
		pld_hssi_rx_transfer_en_ch_0_5_r     <= pld_aib_ch0_pld_hssi_rx_transfer_en_q & pld_aib_ch1_pld_hssi_rx_transfer_en_q & pld_aib_ch2_pld_hssi_rx_transfer_en_q & pld_aib_ch3_pld_hssi_rx_transfer_en_q & pld_aib_ch4_pld_hssi_rx_transfer_en_q & pld_aib_ch5_pld_hssi_rx_transfer_en_q;
		pld_hssi_rx_transfer_en_ch_6_11_r    <= pld_aib_ch6_pld_hssi_rx_transfer_en_q & pld_aib_ch7_pld_hssi_rx_transfer_en_q & pld_aib_ch8_pld_hssi_rx_transfer_en_q & pld_aib_ch9_pld_hssi_rx_transfer_en_q & pld_aib_ch10_pld_hssi_rx_transfer_en_q & pld_aib_ch11_pld_hssi_rx_transfer_en_q;
		pld_hssi_rx_transfer_en_ch_12_17_r   <= pld_aib_ch12_pld_hssi_rx_transfer_en_q & pld_aib_ch13_pld_hssi_rx_transfer_en_q & pld_aib_ch14_pld_hssi_rx_transfer_en_q & pld_aib_ch15_pld_hssi_rx_transfer_en_q & pld_aib_ch16_pld_hssi_rx_transfer_en_q & pld_aib_ch17_pld_hssi_rx_transfer_en_q;
		pld_hssi_rx_transfer_en_ch_18_23_r   <= pld_aib_ch18_pld_hssi_rx_transfer_en_q & pld_aib_ch19_pld_hssi_rx_transfer_en_q & pld_aib_ch20_pld_hssi_rx_transfer_en_q & pld_aib_ch21_pld_hssi_rx_transfer_en_q & pld_aib_ch22_pld_hssi_rx_transfer_en_q & pld_aib_ch23_pld_hssi_rx_transfer_en_q;
		pld_hssi_osc_transfer_en_ch_0_5_r    <= pld_aib_ch0_pld_hssi_osc_transfer_en_q & pld_aib_ch1_pld_hssi_osc_transfer_en_q & pld_aib_ch2_pld_hssi_osc_transfer_en_q & pld_aib_ch3_pld_hssi_osc_transfer_en_q & pld_aib_ch4_pld_hssi_osc_transfer_en_q & pld_aib_ch5_pld_hssi_osc_transfer_en_q;
		pld_hssi_osc_transfer_en_ch_6_11_r   <= pld_aib_ch6_pld_hssi_osc_transfer_en_q & pld_aib_ch7_pld_hssi_osc_transfer_en_q & pld_aib_ch8_pld_hssi_osc_transfer_en_q & pld_aib_ch9_pld_hssi_osc_transfer_en_q & pld_aib_ch10_pld_hssi_osc_transfer_en_q & pld_aib_ch11_pld_hssi_osc_transfer_en_q;
		pld_hssi_osc_transfer_en_ch_12_17_r  <= pld_aib_ch12_pld_hssi_osc_transfer_en_q & pld_aib_ch13_pld_hssi_osc_transfer_en_q & pld_aib_ch14_pld_hssi_osc_transfer_en_q & pld_aib_ch15_pld_hssi_osc_transfer_en_q & pld_aib_ch16_pld_hssi_osc_transfer_en_q & pld_aib_ch17_pld_hssi_osc_transfer_en_q;
		pld_hssi_osc_transfer_en_ch_18_23_r  <= pld_aib_ch18_pld_hssi_osc_transfer_en_q & pld_aib_ch19_pld_hssi_osc_transfer_en_q & pld_aib_ch20_pld_hssi_osc_transfer_en_q & pld_aib_ch21_pld_hssi_osc_transfer_en_q & pld_aib_ch22_pld_hssi_osc_transfer_en_q & pld_aib_ch23_pld_hssi_osc_transfer_en_q;
		
		pld_fabric_tx_transfer_en_2r         <=   pld_fabric_tx_transfer_en_ch_0_5_r & pld_fabric_tx_transfer_en_ch_6_11_r & pld_fabric_tx_transfer_en_ch_12_17_r & pld_fabric_tx_transfer_en_ch_18_23_r;
		pld_hssi_rx_transfer_en_2r         <=   pld_hssi_rx_transfer_en_ch_0_5_r & pld_hssi_rx_transfer_en_ch_6_11_r & pld_hssi_rx_transfer_en_ch_12_17_r & pld_hssi_rx_transfer_en_ch_18_23_r;
		pld_hssi_osc_transfer_en_2r         <=   pld_hssi_osc_transfer_en_ch_0_5_r & pld_hssi_osc_transfer_en_ch_6_11_r & pld_hssi_osc_transfer_en_ch_12_17_r & pld_hssi_osc_transfer_en_ch_18_23_r;
	  end 

end

   altera_std_synchronizer_nocut p0_reset_status_sync (.clk (coreclkout_hip), .reset_n ( src_alive_r[20]), .din (p0_rst_ports.pld_core_rst_n & p0_pld_alive_r), .dout (p0_reset_status_s) );
   altera_std_synchronizer_nocut p1_reset_status_sync (.clk (coreclkout_hip), .reset_n ( src_alive_r[21]), .din (p1_rst_ports.pld_core_rst_n & p1_pld_alive_r), .dout (p1_reset_status_s) );
   altera_std_synchronizer_nocut p2_reset_status_sync (.clk (coreclkout_hip), .reset_n ( src_alive_r[22]), .din (p2_rst_ports.pld_core_rst_n & p2_pld_alive_r), .dout (p2_reset_status_s) );
   altera_std_synchronizer_nocut p3_reset_status_sync (.clk (coreclkout_hip), .reset_n ( src_alive_r[23]), .din (p3_rst_ports.pld_core_rst_n & p3_pld_alive_r), .dout (p3_reset_status_s) );
   altera_std_synchronizer_nocut upi_reset_status_sync (.clk (coreclkout_hip), .reset_n ( src_alive_r[24]), .din (upi_pld_core_rst_n_r & upi_pld_alive_r), .dout (upi_reset_status_s) );
   //delay added to align warm rst req with reset signal
   altera_std_synchronizer_nocut #(.depth(2)) upi_warm_rst_req_delay (.clk (coreclkout_hip), .reset_n ( 1'b1), .din (~upi_pld_link_req_rst_n_r), .dout (upi_pld_link_req_rst_r_sync) );
//Synchronizer to pin_perst_n (Debug: HSD#1409583715)
altera_std_synchronizer_nocut pin_perst_n_sync (.clk (coreclkout_hip), .reset_n ( src_alive_r[25]), .din (pin_perst_n_i), .dout (pin_perst_n_s) );

   reset_tree p0_rst_tree (.coreclkout_hip(coreclkout_hip), .reset_status_s(p0_reset_status_s), .reset_status_tree(p0_reset_tree));
   reset_tree p1_rst_tree (.coreclkout_hip(coreclkout_hip), .reset_status_s(p1_reset_status_s), .reset_status_tree(p1_reset_tree));
   reset_tree p2_rst_tree (.coreclkout_hip(coreclkout_hip), .reset_status_s(p2_reset_status_s), .reset_status_tree(p2_reset_tree));
   reset_tree p3_rst_tree (.coreclkout_hip(coreclkout_hip), .reset_status_s(p3_reset_status_s), .reset_status_tree(p3_reset_tree));
   reset_tree upi_rst_tree (.coreclkout_hip(coreclkout_hip), .reset_status_s(upi_reset_status_s), .reset_status_tree(upi_reset_tree_o));

always_ff @(posedge coreclkout_hip) begin : proc_upi_maib_sync_rst_n_o
	   if (~src_alive_r[26]) begin 
		 upi_maib_sync_rst_n_o <= 0;
	   end 
	   else begin 
		  upi_maib_sync_rst_n_o <= pld_hssi_osc_transfer_en_2r & upi_pll_locked_r;
	   end 
 end 
//app side
always_ff @(posedge coreclkout_hip ) begin : proc_app_warm_rst_rdy_r
	  if (~src_alive_r[27]) begin 
		p0_app_warm_rst_rdy_r <= 0;
		p1_app_warm_rst_rdy_r <= 0;
		p2_app_warm_rst_rdy_r <= 0;
		p3_app_warm_rst_rdy_r <= 0;
		upi_app_warm_rst_rdy_r  <= 0;
	  end 
	  else 
	  begin 
		p0_app_warm_rst_rdy_r <= p0_app_rst_ports.app_pld_warm_rst_rdy;
		p1_app_warm_rst_rdy_r <= p1_app_rst_ports.app_pld_warm_rst_rdy;
		p2_app_warm_rst_rdy_r <= p2_app_rst_ports.app_pld_warm_rst_rdy;
		p3_app_warm_rst_rdy_r <= p3_app_rst_ports.app_pld_warm_rst_rdy;
		upi_app_warm_rst_rdy_r  <= upi_app_warm_rst_rdy_i;
	  end 
 
end
assign p0_app_rst_ports.app_pld_link_req_rst_n = ~p0_pld_link_req_rst_n_r;
assign p1_app_rst_ports.app_pld_link_req_rst_n = ~p1_pld_link_req_rst_n_r;
assign p2_app_rst_ports.app_pld_link_req_rst_n = ~p2_pld_link_req_rst_n_r;
assign p3_app_rst_ports.app_pld_link_req_rst_n = ~p3_pld_link_req_rst_n_r;
assign upi_app_link_req_rst_o                  = upi_pld_link_req_rst_r_sync; // skipping this FF due to replication in whr_interface: upi_pld_link_req_rst_r_delayed;

//*********************************************pld_clrpcs to rst PCS and controller ***********************************
// ******** Config Type A/B/C/D (WHR HAS 1p5 Appendix C – Bifurcated Endpoint support for Independent Warm Resets)
// For Config Type A/B/C export pld_clrpcs 
// For Config Type D implement Firmware handshake to do phy reset
// Clock is always active(clock coming from Tile (port0 refclk)) , If main pin_perst toggle it is a Cold reset (need to reconfigure FPGA). For warm reset clock free running

logic p1_fw_clrpcs_n;
logic p1_clrphy_n_sync, fw_pio_sync;
logic p0_clrpcs_n_sync, p1_clrpcs_n_sync, p2_clrpcs_n_sync, p3_clrpcs_n_sync;
logic p0_clrpcs_n_reg, p1_clrpcs_n_reg, p2_clrpcs_n_reg, p3_clrpcs_n_reg;
logic p1_clrphy_n_reg, p1_fw_clrpcs_n_reg;

// clrpcs emulates warm reset, so initialized to 1
//clrphy emulates pin_perst for port1, so initialized to 0 to keep port1 in reset mode.
initial begin
  p0_clrpcs_n_reg = 1'b1; 
  p1_clrpcs_n_reg = 1'b1;
  p2_clrpcs_n_reg = 1'b1;
  p3_clrpcs_n_reg = 1'b1;

  p1_clrphy_n_reg = 1'b0;
  p1_fw_clrpcs_n_reg  = 1'b0;

end

assign p0_pld_clrpcs_n_o = pld_clrpcs_hwtcl ? p0_clrpcs_n_reg : 1'b1;
assign p1_pld_clrpcs_n_o = pld_clrpcs_hwtcl ? ((!core8_refclk_init_active_hwtcl) ? p1_fw_clrpcs_n_reg : p1_clrpcs_n_reg) :  1'b1;
assign p2_pld_clrpcs_n_o = pld_clrpcs_hwtcl ? p2_clrpcs_n_reg : 1'b1;
assign p3_pld_clrpcs_n_o = pld_clrpcs_hwtcl ? p3_clrpcs_n_reg : 1'b1;

assign fw_pio_o = (!core8_refclk_init_active_hwtcl && pld_clrpcs_hwtcl) ? p1_clrphy_n_reg : 1'b0;

// syncrhronizer rst is async 
altera_std_synchronizer_nocut p0_clrpcs_synchronizer (.clk (coreclkout_hip), .reset_n ( 1'b1), .din (p0_pld_clrpcs_n_i ), .dout (p0_clrpcs_n_sync) );
altera_std_synchronizer_nocut p1_clrpcs_synchronizer (.clk (coreclkout_hip), .reset_n ( 1'b1), .din (p1_pld_clrpcs_n_i ), .dout (p1_clrpcs_n_sync) );
altera_std_synchronizer_nocut p2_clrpcs_synchronizer (.clk (coreclkout_hip), .reset_n ( 1'b1), .din (p2_pld_clrpcs_n_i ), .dout (p2_clrpcs_n_sync) );
altera_std_synchronizer_nocut p3_clrpcs_synchronizer (.clk (coreclkout_hip), .reset_n ( 1'b1), .din (p3_pld_clrpcs_n_i ), .dout (p3_clrpcs_n_sync) );
altera_std_synchronizer_nocut clrphy_synchronizer (.clk (coreclkout_hip), .reset_n ( 1'b1), .din (p1_pld_clrphy_n_i ), .dout (p1_clrphy_n_sync) );
altera_std_synchronizer_nocut fw_pio_synchronizer (.clk (coreclkout_hip), .reset_n ( 1'b1), .din (fw_pio_i), .dout (fw_pio_sync) );


// Register to initialize value
always @(posedge coreclkout_hip) begin
  p0_clrpcs_n_reg <= p0_clrpcs_n_sync;
  p1_clrpcs_n_reg <= p1_clrpcs_n_sync;
  p2_clrpcs_n_reg <= p2_clrpcs_n_sync;
  p3_clrpcs_n_reg <= p3_clrpcs_n_sync;
  p1_clrphy_n_reg <= p1_clrphy_n_sync;
end

always @(posedge coreclkout_hip) begin
	if(~p1_clrphy_n_reg)
		p1_fw_clrpcs_n_reg<= '0;
	else
		p1_fw_clrpcs_n_reg <= fw_pio_sync;
end


//************************************************************************************************************************
endmodule//reset_ctrl

//************************************reset tree ***********************************************

module reset_tree (
input  logic           coreclkout_hip,
input  logic           reset_status_s,
output logic [3:0]     reset_status_tree /*synthesis preserve*/
);

logic reset_status_tree_buf /*synthesis preserve*/;
  always @ (posedge coreclkout_hip) begin
	reset_status_tree_buf <= !reset_status_s;
	reset_status_tree[0] <= reset_status_tree_buf;
    reset_status_tree[1] <= reset_status_tree_buf;
	reset_status_tree[2] <= reset_status_tree_buf;
	reset_status_tree[3] <= reset_status_tree_buf;
    end
endmodule // reset_tree
//**********************************Delay counter for Hot Reset **************************************************
module delay_counter # (
parameter 	no_delay                       =   0
  )

(
	input logic clk, 
	input logic reset_n,
	input logic link_req_rst_n,
	output logic delay_4ms_500Mhz,
	output logic delay_4ms_400Mhz,
	output logic delay_4ms_350Mhz,
	output logic delay_4ms_250Mhz
);
logic [7:0] count;
logic [13:0] by256clk_count;
logic div_by_256, div_by_256_reg, div_by_256_rise, div_by_256_rise_reg;
//Coreclkout Freq          	div_by_256_clk
  // 500Mhz (2ns)           --> 2*0.976Mhz (1/2us)
  // 400Mhz (2.5ns)         --> 2*0.78Mhz (1.28/2us)
  // 350Mhz (2.86ns)        --> 2*0.68Mhz (1.46/2us)
  // 250Mhz (4ns)           --->2*0.488Mhz (1us)
always @ (posedge clk )
begin
	if (!reset_n)
		count <= '0;
	else 
		count <= count + 1'b1;
end
assign div_by_256 = count[7];
always @ (posedge clk)
  if(!reset_n) begin
    div_by_256_reg <= '0;
    div_by_256_rise_reg <= '0;
  end else begin
    div_by_256_reg <= div_by_256;
    div_by_256_rise_reg <= div_by_256_rise;
  end
assign div_by_256_rise = ~div_by_256_reg & div_by_256;
always @(posedge clk)
begin
  if(!reset_n)
		by256clk_count <= '0;
	else if(link_req_rst_n)
		by256clk_count <= '0;
  else if(div_by_256_rise_reg)   // divby_256
		by256clk_count <= by256clk_count + 1'b1;
end
assign delay_4ms_500Mhz = no_delay ? !link_req_rst_n : by256clk_count[13];
assign delay_4ms_400Mhz = no_delay ? !link_req_rst_n : by256clk_count[13];
assign delay_4ms_350Mhz	= no_delay ? !link_req_rst_n : by256clk_count[13]; // 3ms delay for bit 12
assign delay_4ms_250Mhz = no_delay ? !link_req_rst_n : by256clk_count[12];
endmodule //delay_counter


