// (C) 2001-2021 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.




module ecc_gen_top# (
parameter DEVICE_WIDTH = "pcie_x16",
parameter core16_enable_ecc_hwtcl = 0,
parameter core8_enable_ecc_hwtcl = 0,
parameter core4_0_enable_ecc_hwtcl = 0,
parameter core4_1_enable_ecc_hwtcl = 0
) (
/////////////////deskew ////////////////////


input i_clk,
input [3:0] i_rst_n,


//p0 tx_st ports
input	[127:0]	p0_tx_st_hdr_s0_i,
input	[31:0]	p0_tx_st_data_par_s1_i,
input			p0_tx_st_valid_s0_i,
input			p0_tx_st_valid_s1_i,
input			p0_tx_st_sop_s0_i,
input			p0_tx_st_err_s1_i,
input	[255:0]	p0_tx_st_data_s1_i,
input	[127:0]	p0_tx_st_hdr_s1_i,
input	[15:0]	p0_tx_st_hdr_par_s1_i,
input			p0_tx_st_eop_s0_i,
input			p0_tx_st_err_s0_i,
input	[15:0]	p0_tx_st_hdr_par_s0_i,
input			p0_tx_st_eop_s1_i,
input	[3:0]	p0_tx_st_tlp_prfx_par_s1_i,
input	[31:0]	p0_tx_st_tlp_prfx_s0_i,
input	[31:0]	p0_tx_st_data_par_s0_i,
input	[3:0]	p0_tx_st_tlp_prfx_par_s0_i,
input			p0_tx_st_sop_s1_i,
input	[255:0]	p0_tx_st_data_s0_i,
input	[31:0]	p0_tx_st_tlp_prfx_s1_i,

//p1 tx_st ports
input	[127:0]	p1_tx_st_hdr_s0_i,
input	[31:0]	p1_tx_st_tlp_prfx_s0_i,
input			p1_tx_st_eop_s0_i,
input	[15:0]	p1_tx_st_hdr_par_s0_i,
input	[31:0]	p1_tx_st_data_par_s0_i,
input	[3:0]	p1_tx_st_tlp_prfx_par_s0_i,
input			p1_tx_st_sop_s0_i,
input			p1_tx_st_valid_s0_i,
input			p1_tx_st_err_s0_i,
input	[255:0]	p1_tx_st_data_s0_i,

//p2 tx_st ports
input			p2_tx_st_valid_s0_i,
input	[127:0]	p2_tx_st_hdr_s0_i,
input			p2_tx_st_eop_s0_i,
input	[15:0]	p2_tx_st_hdr_par_s0_i,
input	[31:0]	p2_tx_st_tlp_prfx_s0_i,
input	[127:0]	p2_tx_st_data_s0_i,
input	[3:0]	p2_tx_st_tlp_prfx_par_s0_i,
input			p2_tx_st_sop_s0_i,
input			p2_tx_st_err_s0_i,
input	[15:0]	p2_tx_st_data_par_s0_i,


//p3 tx_st ports
input	[15:0]	p3_tx_st_data_par_s0_i,
//output			p3_tx_st_ready_o,
input	[15:0]	p3_tx_st_hdr_par_s0_i,
input	[3:0]	p3_tx_st_tlp_prfx_par_s0_i,
input			p3_tx_st_eop_s0_i,
input	[127:0]	p3_tx_st_data_s0_i,
input	[31:0]	p3_tx_st_tlp_prfx_s0_i,
input			p3_tx_st_valid_s0_i,
input			p3_tx_st_err_s0_i,
input			p3_tx_st_sop_s0_i,
input	[127:0]	p3_tx_st_hdr_s0_i,



input			p2_app_xfer_pending_i,
input	[31:0]	p2_app_err_hdr_i,
input			p2_sys_pre_det_state_i,
input			p2_sys_mrl_sensor_state_i,
input			p2_sys_eml_interlock_engaged_i,
input			p2_sys_aux_pwr_det_i,
input			p0_rx_st_ready_i,
input			p2_app_ready_entr_l23_i,	//not documented
input			p2_apps_pm_xmt_turnoff_i,
input			p2_app_init_rst_i,
input			p2_sys_mrl_sensor_chged_i,
input			p2_sys_pre_det_chged_i,
input			p2_sys_cmd_cpled_int_i,
input	[1:0]	p2_rx_buffer_limit_tdm_idx_i,
input			p2_sys_atten_button_pressed_i,
input			p2_sys_pwr_fault_det_i,
input	[11:0]	p2_rx_buffer_limit_i,
input	[7:0]	p0_pld_gp_status_i,
input			p0_sys_pre_det_chged_i,
input			p0_sys_cmd_cpled_int_i,
input			p0_sys_atten_button_pressed_i,
input			p0_sys_pwr_fault_det_i,
input			p0_sys_mrl_sensor_chged_i,
input			p0_sys_aux_pwr_det_i,
input			p0_sys_pre_det_state_i,
input			p0_sys_mrl_sensor_state_i,
input			p0_sys_eml_interlock_engaged_i,
input			p1_sys_aux_pwr_det_i,
input			p1_sys_pre_det_state_i,
input			p1_sys_mrl_sensor_state_i,
input			p1_sys_eml_interlock_engaged_i,
input			p1_sys_atten_button_pressed_i,
input			p1_sys_pwr_fault_det_i,
input			p1_sys_mrl_sensor_chged_i,
input			p1_sys_pre_det_chged_i,
input			p1_sys_cmd_cpled_int_i,
input	[11:0]	p3_rx_buffer_limit_i,
input	[1:0]	p3_rx_buffer_limit_tdm_idx_i,
input			p3_sys_atten_button_pressed_i,
input			p3_sys_pwr_fault_det_i,
input			p3_sys_mrl_sensor_chged_i,
input			p3_sys_pre_det_chged_i,
input			p3_sys_cmd_cpled_int_i,
input			p3_sys_pre_det_state_i,
input			p3_sys_mrl_sensor_state_i,
input			p3_sys_eml_interlock_engaged_i,
input			p3_sys_aux_pwr_det_i,
input			p3_app_ready_entr_l23_i,
input			p3_apps_pm_xmt_turnoff_i,
input			p3_app_init_rst_i,
input			p3_app_xfer_pending_i,
input			p1_rx_st_ready_i,
input			p2_app_err_valid_i,
input			p2_rx_st_ready_i,
input	[12:0]	p2_app_err_info_i,
input			p3_app_err_valid_i,
input	[31:0]	p3_app_err_hdr_i,
input			p3_rx_st_ready_i,
input	[12:0]	p3_app_err_info_i,


input	[13:0]	p0_tx_dsk_marker_i,	
input	[6:0]	p1_tx_dsk_marker_i,	
input	[4:0]	p2_tx_dsk_marker_i,	
input	[4:0]	p3_tx_dsk_marker_i,	
		
input [7:0]  p0_apps_pm_xmt_pme_i,
input [7:0]	p2_apps_pm_xmt_pme_i,
input [7:0]	p3_apps_pm_xmt_pme_i,

output	[77:0] 			ch0_tx_ecc_data_out, 
output	[77:0] 			ch1_tx_ecc_data_out, 
output	[77:0] 			ch2_tx_ecc_data_out, 
output	[77:0] 			ch3_tx_ecc_data_out, 
output	[77:0] 			ch4_tx_ecc_data_out, 
output	[77:0] 			ch5_tx_ecc_data_out, 
output	[77:0] 			ch6_tx_ecc_data_out, 
output	[77:0] 			ch7_tx_ecc_data_out, 
output	[77:0] 			ch8_tx_ecc_data_out, 
output	[77:0] 			ch9_tx_ecc_data_out, 
output	[77:0] 			ch11_tx_ecc_data_out, 
output	[77:0] 			ch12_tx_ecc_data_out, 
output	[77:0] 			ch13_tx_ecc_data_out, 
output	[77:0] 			ch14_tx_ecc_data_out, 
output	[77:0] 			ch15_tx_ecc_data_out, 
output	[77:0] 			ch16_tx_ecc_data_out, 
output	[77:0] 			ch17_tx_ecc_data_out, 
output	[77:0] 			ch18_tx_ecc_data_out, 
output	[77:0] 			ch19_tx_ecc_data_out, 
output	[77:0] 			ch20_tx_ecc_data_out, 
output	[77:0] 			ch21_tx_ecc_data_out


);
wire [69:0] core_periphery__data_from_core_ch0;
wire [69:0] core_periphery__data_from_core_ch1;
wire [69:0] core_periphery__data_from_core_ch2;
wire [69:0] core_periphery__data_from_core_ch3;
wire [69:0] core_periphery__data_from_core_ch4;
wire [69:0] core_periphery__data_from_core_ch5;
wire [69:0] core_periphery__data_from_core_ch6;
wire [69:0] core_periphery__data_from_core_ch7;
wire [69:0] core_periphery__data_from_core_ch8;
wire [69:0] core_periphery__data_from_core_ch9;
wire [69:0] core_periphery__data_from_core_ch11;
wire [69:0] core_periphery__data_from_core_ch12;
wire [69:0] core_periphery__data_from_core_ch13;
wire [69:0] core_periphery__data_from_core_ch14;
wire [69:0] core_periphery__data_from_core_ch15;
wire [69:0] core_periphery__data_from_core_ch16;
wire [69:0] core_periphery__data_from_core_ch17;
wire [69:0] core_periphery__data_from_core_ch18;
wire [69:0] core_periphery__data_from_core_ch19;
wire [69:0] core_periphery__data_from_core_ch20;
wire [69:0] core_periphery__data_from_core_ch21;


wire [69:0]  ch0_tx_ecc_data_in 	;
wire [69:0]  ch1_tx_ecc_data_in 	;
wire [69:0]  ch2_tx_ecc_data_in 	;
wire [69:0]  ch3_tx_ecc_data_in 	;						
wire [69:0]  ch4_tx_ecc_data_in 	 ;	
wire [69:0]  ch5_tx_ecc_data_in 	 ;	
wire [69:0]  ch6_tx_ecc_data_in 	 ;
wire [69:0]  ch7_tx_ecc_data_in 	 ;
wire [69:0]  ch8_tx_ecc_data_in 	 ;	
wire [69:0]  ch9_tx_ecc_data_in 	 ;
wire [69:0]  ch11_tx_ecc_data_in  ;
wire [69:0]  ch12_tx_ecc_data_in  ;	
wire [69:0]  ch13_tx_ecc_data_in  ;	
wire [69:0]  ch14_tx_ecc_data_in ;
wire [69:0]  ch15_tx_ecc_data_in  ;
wire [69:0]  ch16_tx_ecc_data_in ;
wire [69:0]  ch17_tx_ecc_data_in  ;
wire [69:0]  ch18_tx_ecc_data_in  ;
wire [69:0]  ch19_tx_ecc_data_in  ;
wire [69:0]  ch20_tx_ecc_data_in  ;
wire [69:0]  ch21_tx_ecc_data_in  ;	

reg [69:0]  ch0_tx_ecc_data_in_r 	;
reg [69:0]  ch1_tx_ecc_data_in_r 	;
reg [69:0]  ch2_tx_ecc_data_in_r 	;
reg [69:0]  ch3_tx_ecc_data_in_r 	;						
reg [69:0]  ch4_tx_ecc_data_in_r 	 ;	
reg [69:0]  ch5_tx_ecc_data_in_r 	 ;	
reg [69:0]  ch6_tx_ecc_data_in_r 	 ;
reg [69:0]  ch7_tx_ecc_data_in_r 	 ;
reg [69:0]  ch8_tx_ecc_data_in_r 	 ;	
reg [69:0]  ch9_tx_ecc_data_in_r 	 ;
reg [69:0]  ch11_tx_ecc_data_in_r  ;
reg [69:0]  ch12_tx_ecc_data_in_r  ;	
reg [69:0]  ch13_tx_ecc_data_in_r  ;	
reg [69:0]  ch14_tx_ecc_data_in_r ;
reg [69:0]  ch15_tx_ecc_data_in_r  ;
reg [69:0]  ch16_tx_ecc_data_in_r ;
reg [69:0]  ch17_tx_ecc_data_in_r  ;
reg [69:0]  ch18_tx_ecc_data_in_r  ;
reg [69:0]  ch19_tx_ecc_data_in_r  ;
reg [69:0]  ch20_tx_ecc_data_in_r  ;
reg [69:0]  ch21_tx_ecc_data_in_r  ;	


logic p0_reset;
logic p1_reset;
logic p2_reset;
logic p3_reset;

assign p0_reset = i_rst_n[0];
assign p1_reset = i_rst_n[1];
assign p2_reset = i_rst_n[2];
assign p3_reset = i_rst_n[3];


//x16 mode
  generate if (DEVICE_WIDTH == "pcie_x16")	begin						

localparam AIB_WIDTH = 78;
localparam NUM_CHAN = 14; 
localparam ECC_OUT_WIDTH = 70;
genvar ww;

logic [NUM_CHAN * AIB_WIDTH-1:0] i_rx_ecc_data;
logic [NUM_CHAN * ECC_OUT_WIDTH-1:0] o_rx_ecc_data;
logic [NUM_CHAN-1:0] [AIB_WIDTH-1:0] data_in;
logic [NUM_CHAN-1:0] [ECC_OUT_WIDTH-1:0] data_out;
logic [NUM_CHAN-1:0] o_int_sec;
logic [NUM_CHAN-1:0] o_int_ded;
logic [NUM_CHAN-1:0] o_syndrome;




/* 		 wrlib_ecc_enc_d70_c78 tx_ecc_ch3 (		  
		 .i_data	(core_periphery__data_from_core_ch3),    //ch3_tx_ecc_data_in
		 .o_code	(ch3_tx_ecc0_data_out)  
		 ); */

		assign core_periphery__data_from_core_ch3[63:0] = p0_tx_st_data_s0_i[63:0];
		assign core_periphery__data_from_core_ch3[64] = 0;
		assign core_periphery__data_from_core_ch3[65] = 0;
		assign core_periphery__data_from_core_ch3[66] = 0;
		assign core_periphery__data_from_core_ch3[67] = 0;
		assign core_periphery__data_from_core_ch3[68] = 0;
		assign core_periphery__data_from_core_ch3[69] = p0_tx_dsk_marker_i[0];
		//assign p0_tx_st_data_par_s0_i[7:0] = 8'd0;



/* 		 wrlib_ecc_enc_d70_c78 tx_ecc_ch4 (		  
		 .i_data	(core_periphery__data_from_core_ch4),    //ch4_tx_ecc_data_in
		 .o_code	(ch4_tx_ecc0_data_out)  
		 ); */
		assign core_periphery__data_from_core_ch4[63:0] = p0_tx_st_data_s0_i[127:64];		 
		assign core_periphery__data_from_core_ch4[64] = 0;
		assign core_periphery__data_from_core_ch4[65] = 0;
		assign core_periphery__data_from_core_ch4[66] = 0;
		assign core_periphery__data_from_core_ch4[67] = 0;
		assign core_periphery__data_from_core_ch4[68] = 0;
		assign core_periphery__data_from_core_ch4[69] = p0_tx_dsk_marker_i[1];
		//assign p0_tx_st_data_par_s0_i[15:8] = 8'd0;

		 
/* 		 wrlib_ecc_enc_d70_c78 tx_ecc_ch5 (		  
		 .i_data	(core_periphery__data_from_core_ch5),    //ch5_tx_ecc_data_in
		 .o_code	(ch5_tx_ecc0_data_out)  
		 ); */
		assign core_periphery__data_from_core_ch5[11:0] = 	p2_rx_buffer_limit_i[11:0];
		assign core_periphery__data_from_core_ch5[13:12] = 	p2_rx_buffer_limit_tdm_idx_i[1:0];	 
		assign core_periphery__data_from_core_ch5[14] = 	p2_sys_atten_button_pressed_i;
		assign core_periphery__data_from_core_ch5[15] = 	p2_sys_pwr_fault_det_i;
		assign core_periphery__data_from_core_ch5[16] = 	p2_sys_mrl_sensor_chged_i;
		assign core_periphery__data_from_core_ch5[17] = 	p2_sys_pre_det_chged_i;
		assign core_periphery__data_from_core_ch5[18] = 	p2_sys_cmd_cpled_int_i;
		assign core_periphery__data_from_core_ch5[19] =     p2_sys_pre_det_state_i;
		assign core_periphery__data_from_core_ch5[20] = 	p2_sys_mrl_sensor_state_i;
		assign core_periphery__data_from_core_ch5[21] = 	p2_sys_eml_interlock_engaged_i;
		assign core_periphery__data_from_core_ch5[22] = 	p2_sys_aux_pwr_det_i;
		assign core_periphery__data_from_core_ch5[23] = 	p2_app_ready_entr_l23_i;
		assign core_periphery__data_from_core_ch5[24] = 	p2_apps_pm_xmt_turnoff_i;
		assign core_periphery__data_from_core_ch5[25] = 	p2_app_init_rst_i;
		assign core_periphery__data_from_core_ch5[26] = 	p2_app_xfer_pending_i;
		assign core_periphery__data_from_core_ch5[27] = 	p0_tx_st_sop_s0_i;
		assign core_periphery__data_from_core_ch5[28] = 	p0_tx_st_eop_s0_i;
		assign core_periphery__data_from_core_ch5[29] = 	p0_tx_st_valid_s0_i;
		assign core_periphery__data_from_core_ch5[30] = 	p0_tx_st_err_s0_i;
		assign core_periphery__data_from_core_ch5[31] = 	p0_rx_st_ready_i;
		assign core_periphery__data_from_core_ch5[63:32] = p0_tx_st_tlp_prfx_s0_i[31:0];
		assign core_periphery__data_from_core_ch5[68:64] = p0_pld_gp_status_i[4:0];
		assign core_periphery__data_from_core_ch5[69] = p0_tx_dsk_marker_i[2];
	    //assign p0_tx_st_tlp_prfx_par_s0_i[3:0] = 4'd0;


	
/* 		 wrlib_ecc_enc_d70_c78 tx_ecc_ch6 (		  
		 .i_data	(core_periphery__data_from_core_ch6),    //ch6_tx_ecc_data_in
		 .o_code	(ch6_tx_ecc0_data_out)  
		 ); */
		assign core_periphery__data_from_core_ch6[63:0] = 	 p0_tx_st_hdr_s0_i[63:0];
		assign core_periphery__data_from_core_ch6[66:64] = 	p0_pld_gp_status_i[7:5];
		assign core_periphery__data_from_core_ch6[67] = 	0;
		assign core_periphery__data_from_core_ch6[68] = 0;
		assign core_periphery__data_from_core_ch6[69] = p0_tx_dsk_marker_i[3];
		//assign p0_tx_st_hdr_par_s0_i[7:0] = 8'd0;

		 
/* 		 wrlib_ecc_enc_d70_c78 tx_ecc_ch7 (		  
		 .i_data	(core_periphery__data_from_core_ch7),    //ch7_tx_ecc_data_in
		 .o_code	(ch7_tx_ecc0_data_out)  
		 ); */
		assign core_periphery__data_from_core_ch7[63:0] = 	p0_tx_st_hdr_s0_i[127:64];	 
		assign core_periphery__data_from_core_ch7[64] = 	p0_sys_atten_button_pressed_i;	 
		assign core_periphery__data_from_core_ch7[65] = 	p0_sys_pwr_fault_det_i;	 
		assign core_periphery__data_from_core_ch7[66] = 	p0_sys_mrl_sensor_chged_i;	 
		assign core_periphery__data_from_core_ch7[67] = 	p0_sys_pre_det_chged_i;	 
		assign core_periphery__data_from_core_ch7[68] = 	p0_sys_cmd_cpled_int_i;	 
		assign core_periphery__data_from_core_ch7[69] = 	p0_tx_dsk_marker_i[4];
		//assign p0_tx_st_hdr_par_s0_i[15:8] = 8'd0;

		
/* 		 wrlib_ecc_enc_d70_c78 tx_ecc_ch8 (		  
		 .i_data	(core_periphery__data_from_core_ch8),    //ch8_tx_ecc_data_in
		 .o_code	(ch8_tx_ecc0_data_out)  
		 ); */
		assign core_periphery__data_from_core_ch8[63:0] = 	p0_tx_st_data_s0_i[191:128];
		assign core_periphery__data_from_core_ch8[64] = 	p0_sys_pre_det_state_i;
		assign core_periphery__data_from_core_ch8[65] = 	p0_sys_mrl_sensor_state_i;
		assign core_periphery__data_from_core_ch8[66] = 	p0_sys_eml_interlock_engaged_i;
		assign core_periphery__data_from_core_ch8[67] = 	p0_sys_aux_pwr_det_i;
		assign core_periphery__data_from_core_ch8[68] = 	p0_apps_pm_xmt_pme_i[7];
		assign core_periphery__data_from_core_ch8[69] = 	p0_tx_dsk_marker_i[5];
		//assign p0_tx_st_data_par_s0_i[23:16] = 8'd0;

			
/* 		 wrlib_ecc_enc_d70_c78 tx_ecc_ch9 (		  
		 .i_data	(core_periphery__data_from_core_ch9),    //ch9_tx_ecc_data_in
		 .o_code	(ch9_tx_ecc0_data_out)  
		 ); */
		assign core_periphery__data_from_core_ch9[63:0] = 	p0_tx_st_data_s0_i[255:192];	 
		assign core_periphery__data_from_core_ch9[64] = 	p0_apps_pm_xmt_pme_i[2];
		assign core_periphery__data_from_core_ch9[65] = 	p0_apps_pm_xmt_pme_i[3];
		assign core_periphery__data_from_core_ch9[66] = 	p0_apps_pm_xmt_pme_i[4];
		assign core_periphery__data_from_core_ch9[67] = 	p0_apps_pm_xmt_pme_i[5];
		assign core_periphery__data_from_core_ch9[68] = 	p0_apps_pm_xmt_pme_i[6];	
		assign core_periphery__data_from_core_ch9[69] = 	p0_tx_dsk_marker_i[6];
		//assign p0_tx_st_data_par_s0_i[31:24] = 8'd0;

		 
/* 		 wrlib_ecc_enc_d70_c78 tx_ecc_ch11 (		  
		 .i_data	(core_periphery__data_from_core_ch11),    //ch11_tx_ecc_data_in
		 .o_code	(ch11_tx_ecc0_data_out)  
		 ); */
		assign core_periphery__data_from_core_ch11[27:0] = 28'd0;		 
		assign core_periphery__data_from_core_ch11[28] = p0_tx_st_sop_s1_i;
		assign core_periphery__data_from_core_ch11[29] = p0_tx_st_eop_s1_i;
		assign core_periphery__data_from_core_ch11[30] = p0_tx_st_valid_s1_i;
		assign core_periphery__data_from_core_ch11[31] = p0_tx_st_err_s1_i;
		assign core_periphery__data_from_core_ch11[63:32] = p0_tx_st_tlp_prfx_s1_i[31:0];
		assign core_periphery__data_from_core_ch11[64] = 0;
		assign core_periphery__data_from_core_ch11[65] = 0;
		assign core_periphery__data_from_core_ch11[66] = 0;
		assign core_periphery__data_from_core_ch11[67] = 0;
		assign core_periphery__data_from_core_ch11[68] = 0;
		assign core_periphery__data_from_core_ch11[69] = p0_tx_dsk_marker_i[7];
		//assign p0_tx_st_tlp_prfx_par_s1_i[3:0] = 4'd0;

		 
/* 		 wrlib_ecc_enc_d70_c78 tx_ecc_ch12 (		  
		 .i_data	(core_periphery__data_from_core_ch12),    //ch12_tx_ecc_data_in
		 .o_code	(ch12_tx_ecc0_data_out)  
		 ); */
		assign core_periphery__data_from_core_ch12[63:0] = p0_tx_st_hdr_s1_i[63:0];
		assign core_periphery__data_from_core_ch12[64] = 0;
		assign core_periphery__data_from_core_ch12[65] = 0;
		assign core_periphery__data_from_core_ch12[66] = 0;
		assign core_periphery__data_from_core_ch12[67] = 0;
		assign core_periphery__data_from_core_ch12[68] = 0;
		assign core_periphery__data_from_core_ch12[69] = p0_tx_dsk_marker_i[8];
		//assign p0_tx_st_hdr_par_s1_i[7:0] = 8'd0;
		 
		 
/* 		 wrlib_ecc_enc_d70_c78 tx_ecc_ch13 (		  
		 .i_data	(core_periphery__data_from_core_ch13),    //ch13_tx_ecc_data_in
		 .o_code	(ch13_tx_ecc0_data_out)  
		 ); */
		assign core_periphery__data_from_core_ch13[63:0] = p0_tx_st_hdr_s1_i[127:64];
		assign core_periphery__data_from_core_ch13[64] = 0;
		assign core_periphery__data_from_core_ch13[65] = 0;
		assign core_periphery__data_from_core_ch13[66] = 0;		 
		assign core_periphery__data_from_core_ch13[67] = 0;
		assign core_periphery__data_from_core_ch13[68] = 0;
		assign core_periphery__data_from_core_ch13[69] = p0_tx_dsk_marker_i[9];
		//assign p0_tx_st_hdr_par_s1_i[15:8] = 8'd0;


		 
/* 		 wrlib_ecc_enc_d70_c78 tx_ecc_ch14 (		  
		 .i_data	(core_periphery__data_from_core_ch14),    //ch14_tx_ecc_data_in
		 .o_code	(ch14_tx_ecc0_data_out)  
		 ); */
		assign core_periphery__data_from_core_ch14[63:0] = p0_tx_st_data_s1_i[63:0];
		assign core_periphery__data_from_core_ch14[64] = 0;
		assign core_periphery__data_from_core_ch14[65] = 0;
		assign core_periphery__data_from_core_ch14[66] = 0;		
		assign core_periphery__data_from_core_ch14[67] = 0;
		assign core_periphery__data_from_core_ch14[68] = 0;
		assign core_periphery__data_from_core_ch14[69] = p0_tx_dsk_marker_i[10];
		//assign p0_tx_st_data_par_s1_i[7:0] = 8'd0;
 
		 
/* 		 wrlib_ecc_enc_d70_c78 tx_ecc_ch15 (		  
		 .i_data	(core_periphery__data_from_core_ch15),    //ch15_tx_ecc_data_in
		 .o_code	(ch15_tx_ecc0_data_out)  
		 ); */
		assign core_periphery__data_from_core_ch15[63:0] =  p0_tx_st_data_s1_i[127:64];
		assign core_periphery__data_from_core_ch15[64] =  0;
		assign core_periphery__data_from_core_ch15[65] =  0;
		assign core_periphery__data_from_core_ch15[66] =  0;
		assign core_periphery__data_from_core_ch15[67] =  0;
		assign core_periphery__data_from_core_ch15[68] =  0;
		assign core_periphery__data_from_core_ch15[69] =  p0_tx_dsk_marker_i[11];	 
		//assign p0_tx_st_data_par_s1_i[15:8] = 8'd0;


	
	
/* 		 wrlib_ecc_enc_d70_c78 tx_ecc_ch16 (		  
		 .i_data	(core_periphery__data_from_core_ch16),    //ch16_tx_ecc_data_in
		 .o_code	(ch16_tx_ecc0_data_out)  
		 ); */
		assign core_periphery__data_from_core_ch16[63:0] = p0_tx_st_data_s1_i[191:128];
		assign core_periphery__data_from_core_ch16[64] = 0;
		assign core_periphery__data_from_core_ch16[65] = 0;
		assign core_periphery__data_from_core_ch16[66] = 0;
		assign core_periphery__data_from_core_ch16[67] = 0;		 
		assign core_periphery__data_from_core_ch16[68] = 0;
		assign core_periphery__data_from_core_ch16[69] =  p0_tx_dsk_marker_i[12];
		//assign p0_tx_st_data_par_s1_i[23:16] = 8'd0;


		 
/* 		 wrlib_ecc_enc_d70_c78 tx_ecc_ch17 (		  
		 .i_data	(core_periphery__data_from_core_ch17),    //ch17_tx_ecc_data_in
		 .o_code	(ch17_tx_ecc0_data_out)  
		 ); */
		assign core_periphery__data_from_core_ch17[63:0] = p0_tx_st_data_s1_i[255:192];
		assign core_periphery__data_from_core_ch17[64] = 0;
		assign core_periphery__data_from_core_ch17[65] = 0;
		assign core_periphery__data_from_core_ch17[66] = 0;
		assign core_periphery__data_from_core_ch17[67] = 0;
		assign core_periphery__data_from_core_ch17[68] = 0;
		assign core_periphery__data_from_core_ch17[69] = p0_tx_dsk_marker_i[13];
		//assign p0_tx_st_data_par_s1_i[31:24] = 8'd0;



//adding a register
always @(posedge i_clk)
begin 
	if(p0_reset == 0)
	begin 
	
		ch3_tx_ecc_data_in_r <= 0;
		ch4_tx_ecc_data_in_r <= 0;
		ch5_tx_ecc_data_in_r <= 0;
		ch6_tx_ecc_data_in_r <= 0;
		ch7_tx_ecc_data_in_r <= 0;
		ch8_tx_ecc_data_in_r <= 0;
		ch9_tx_ecc_data_in_r <= 0;
		ch11_tx_ecc_data_in_r <= 0;
		ch12_tx_ecc_data_in_r <= 0;
		ch13_tx_ecc_data_in_r <= 0;
		ch14_tx_ecc_data_in_r <= 0;
		ch15_tx_ecc_data_in_r <= 0;
		ch16_tx_ecc_data_in_r <= 0;
		ch17_tx_ecc_data_in_r <= 0;

	end 
	
	else 
	begin 
		ch3_tx_ecc_data_in_r <= ch3_tx_ecc_data_in;
		ch4_tx_ecc_data_in_r <= ch4_tx_ecc_data_in;
		ch5_tx_ecc_data_in_r <= ch5_tx_ecc_data_in;
		ch6_tx_ecc_data_in_r <= ch6_tx_ecc_data_in;
		ch7_tx_ecc_data_in_r <= ch7_tx_ecc_data_in;
		ch8_tx_ecc_data_in_r <= ch8_tx_ecc_data_in;
		ch9_tx_ecc_data_in_r <= ch9_tx_ecc_data_in;
		ch11_tx_ecc_data_in_r <= ch11_tx_ecc_data_in;
		ch12_tx_ecc_data_in_r <= ch12_tx_ecc_data_in;
		ch13_tx_ecc_data_in_r <= ch13_tx_ecc_data_in;
		ch14_tx_ecc_data_in_r <= ch14_tx_ecc_data_in;
		ch15_tx_ecc_data_in_r <= ch15_tx_ecc_data_in;
		ch16_tx_ecc_data_in_r <= ch16_tx_ecc_data_in;
		ch17_tx_ecc_data_in_r <= ch17_tx_ecc_data_in;

	end 
end 


// Mux to select ECC input
assign  ch3_tx_ecc_data_in 	= (core16_enable_ecc_hwtcl ==1'b0) ? 70'd0 :	core_periphery__data_from_core_ch3 ;						
assign  ch4_tx_ecc_data_in 	= (core16_enable_ecc_hwtcl ==1'b0) ? 70'd0 : 	core_periphery__data_from_core_ch4 ;	
assign  ch5_tx_ecc_data_in 	= (core16_enable_ecc_hwtcl ==1'b0) ? 70'd0 : 	core_periphery__data_from_core_ch5 ;	
assign  ch6_tx_ecc_data_in 	= (core16_enable_ecc_hwtcl ==1'b0) ? 70'd0 : 	core_periphery__data_from_core_ch6  ;
assign  ch7_tx_ecc_data_in 	= (core16_enable_ecc_hwtcl ==1'b0) ? 70'd0 : 	core_periphery__data_from_core_ch7 ;
assign  ch8_tx_ecc_data_in 	= (core16_enable_ecc_hwtcl ==1'b0) ? 70'd0 : 	core_periphery__data_from_core_ch8 ;	
assign  ch9_tx_ecc_data_in 	= (core16_enable_ecc_hwtcl ==1'b0) ? 70'd0 : 	core_periphery__data_from_core_ch9 ;
assign  ch11_tx_ecc_data_in 	= (core16_enable_ecc_hwtcl ==1'b0) ? 70'd0 : 	core_periphery__data_from_core_ch11 ;
assign  ch12_tx_ecc_data_in 	= (core16_enable_ecc_hwtcl ==1'b0) ? 70'd0 : 	core_periphery__data_from_core_ch12  ;	
assign  ch13_tx_ecc_data_in 	= (core16_enable_ecc_hwtcl ==1'b0) ? 70'd0 :    core_periphery__data_from_core_ch13 ;	
assign  ch14_tx_ecc_data_in 	= (core16_enable_ecc_hwtcl ==1'b0) ? 70'd0 :    core_periphery__data_from_core_ch14 ;
assign  ch15_tx_ecc_data_in 	= (core16_enable_ecc_hwtcl ==1'b0) ? 70'd0 :    core_periphery__data_from_core_ch15 ;
assign  ch16_tx_ecc_data_in 	= (core16_enable_ecc_hwtcl ==1'b0) ? 70'd0 :    core_periphery__data_from_core_ch16 ;
assign  ch17_tx_ecc_data_in 	= (core16_enable_ecc_hwtcl ==1'b0) ? 70'd0 :    core_periphery__data_from_core_ch17 ;	





assign i_rx_ecc_data	 =  (	
							{ 
							{ch17_tx_ecc_data_in_r}, 
							{ch16_tx_ecc_data_in_r},
							{ch15_tx_ecc_data_in_r}, 
							{ch14_tx_ecc_data_in_r}, 
							{ch13_tx_ecc_data_in_r},
							{ch12_tx_ecc_data_in_r},  
							{ch11_tx_ecc_data_in_r}, 
							{ch9_tx_ecc_data_in_r},
							{ch8_tx_ecc_data_in_r},
							{ch7_tx_ecc_data_in_r}, 
							{ch6_tx_ecc_data_in_r},
							{ch5_tx_ecc_data_in_r}, 
							{ch4_tx_ecc_data_in_r}, 
							{ch3_tx_ecc_data_in_r} }   
						);


//ecc module instantaition
for(ww=0; ww<NUM_CHAN; ww++) begin:ecc_module_instantiation
				
		assign  data_in[ww] = i_rx_ecc_data[ww*AIB_WIDTH+:AIB_WIDTH]	;	
		
				wrlib_ecc_dec_c78_d70 inst_rx_ecc (

				   .o_int_sec 		(o_int_sec[ww]),
				   .o_int_ded		(o_int_ded[ww]),
				   .o_syndrome		(o_syndrome[ww]),
				   .i_code			(data_in[ww]),
				   .o_data			(data_out[ww])

				);
			
		assign o_rx_ecc_data[ww*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] = data_out[ww];
		
end:ecc_module_instantiation

//Adding mux to accomodate Bypass mode, 0 latency and 1 latency in ECC
							
assign  ch3_tx_ecc_data_out   = (core16_enable_ecc_hwtcl ==1'b0) ? {p0_tx_st_data_par_s0_i[7:0], core_periphery__data_from_core_ch3}           : o_rx_ecc_data[0*ECC_OUT_WIDTH+:ECC_OUT_WIDTH]	; //ch3_tx_ecc_data_in									
assign  ch4_tx_ecc_data_out   = (core16_enable_ecc_hwtcl ==1'b0) ? {p0_tx_st_data_par_s0_i[15:8], core_periphery__data_from_core_ch4}          : o_rx_ecc_data[1*ECC_OUT_WIDTH+:ECC_OUT_WIDTH]	;  //ch4_tx_ecc_data_in									
assign  ch5_tx_ecc_data_out   = (core16_enable_ecc_hwtcl ==1'b0) ? {p0_tx_st_tlp_prfx_par_s0_i, 4'b0000, core_periphery__data_from_core_ch5}   : o_rx_ecc_data[2*ECC_OUT_WIDTH+:ECC_OUT_WIDTH]	; //ch5_tx_ecc_data_in
assign  ch6_tx_ecc_data_out   = (core16_enable_ecc_hwtcl ==1'b0) ? {p0_tx_st_hdr_par_s0_i[7:0],   core_periphery__data_from_core_ch6}          : o_rx_ecc_data[3*ECC_OUT_WIDTH+:ECC_OUT_WIDTH]	;  //ch6_tx_ecc_data_in									
assign  ch7_tx_ecc_data_out   = (core16_enable_ecc_hwtcl ==1'b0) ? {p0_tx_st_hdr_par_s0_i[15:8], core_periphery__data_from_core_ch7}           : o_rx_ecc_data[4*ECC_OUT_WIDTH+:ECC_OUT_WIDTH]	; //ch7_tx_ecc_data_in									
assign  ch8_tx_ecc_data_out   = (core16_enable_ecc_hwtcl ==1'b0) ? {p0_tx_st_data_par_s0_i[23:16], core_periphery__data_from_core_ch8}         : o_rx_ecc_data[5*ECC_OUT_WIDTH+:ECC_OUT_WIDTH]	; //ch8_tx_ecc_data_in																	
assign  ch9_tx_ecc_data_out   = (core16_enable_ecc_hwtcl ==1'b0) ? {p0_tx_st_data_par_s0_i[31:24],  core_periphery__data_from_core_ch9}        : o_rx_ecc_data[6*ECC_OUT_WIDTH+:ECC_OUT_WIDTH]	; //ch9_tx_ecc_data_in									
assign  ch11_tx_ecc_data_out  = (core16_enable_ecc_hwtcl ==1'b0) ? {p0_tx_st_tlp_prfx_par_s1_i, 4'b0000, core_periphery__data_from_core_ch11}  : o_rx_ecc_data[7*ECC_OUT_WIDTH+:ECC_OUT_WIDTH]	; //ch11_tx_ecc_data_in																		
assign  ch12_tx_ecc_data_out  = (core16_enable_ecc_hwtcl ==1'b0) ? {p0_tx_st_hdr_par_s1_i[7:0], core_periphery__data_from_core_ch12}           : o_rx_ecc_data[8*ECC_OUT_WIDTH+:ECC_OUT_WIDTH];  //ch12_tx_ecc_data_in																		
assign  ch13_tx_ecc_data_out  = (core16_enable_ecc_hwtcl ==1'b0) ? {p0_tx_st_hdr_par_s1_i[15:8], core_periphery__data_from_core_ch13}          : o_rx_ecc_data[9*ECC_OUT_WIDTH+:ECC_OUT_WIDTH];  //ch13_tx_ecc_data_in								
assign  ch14_tx_ecc_data_out  = (core16_enable_ecc_hwtcl ==1'b0) ? {p0_tx_st_data_par_s1_i[7:0], core_periphery__data_from_core_ch14}          : o_rx_ecc_data[10*ECC_OUT_WIDTH+:ECC_OUT_WIDTH];  //ch14_tx_ecc_data_in							
assign  ch15_tx_ecc_data_out  = (core16_enable_ecc_hwtcl ==1'b0) ? {p0_tx_st_data_par_s1_i[15:8], core_periphery__data_from_core_ch15}         : o_rx_ecc_data[11*ECC_OUT_WIDTH+:ECC_OUT_WIDTH]	;  //ch15_tx_ecc_data_in							
assign  ch16_tx_ecc_data_out  = (core16_enable_ecc_hwtcl ==1'b0) ? {p0_tx_st_data_par_s1_i[23:16], core_periphery__data_from_core_ch16}        : o_rx_ecc_data[12*ECC_OUT_WIDTH+:ECC_OUT_WIDTH];   //ch16_tx_ecc_data_in									
assign  ch17_tx_ecc_data_out  = (core16_enable_ecc_hwtcl ==1'b0) ? {p0_tx_st_data_par_s1_i[31:24], core_periphery__data_from_core_ch17}        : o_rx_ecc_data[13*ECC_OUT_WIDTH+:ECC_OUT_WIDTH];   //ch17_tx_ecc_data_in


							
		end	
	endgenerate


	
//x8 Mode	
	 generate if (DEVICE_WIDTH == "pcie_x8x8")  begin
		
localparam AIB_WIDTH = 78;
localparam NUM_CHAN = 14; 
localparam ECC_OUT_WIDTH = 70;
genvar ww;

logic [NUM_CHAN * AIB_WIDTH-1:0] i_rx_ecc_data;
logic [NUM_CHAN * ECC_OUT_WIDTH-1:0] o_rx_ecc_data;
logic [NUM_CHAN-1:0] [AIB_WIDTH-1:0] data_in;
logic [NUM_CHAN-1:0] [ECC_OUT_WIDTH-1:0] data_out;
logic [NUM_CHAN-1:0] o_int_sec;
logic [NUM_CHAN-1:0] o_int_ded;
logic [NUM_CHAN-1:0] o_syndrome;

		
/* 		 wrlib_ecc_enc_d70_c78 tx_ecc_ch3 (		  
		 .i_data	(core_periphery__data_from_core_ch3),    //ch3_tx_ecc_data_in
		 .o_code	(ch3_tx_ecc0_data_out)  
		 ); */

		assign core_periphery__data_from_core_ch3[63:0] = p0_tx_st_data_s0_i[63:0];
		assign core_periphery__data_from_core_ch3[64] = 0;
		assign core_periphery__data_from_core_ch3[65] = 0;
		assign core_periphery__data_from_core_ch3[66] = 0;
		assign core_periphery__data_from_core_ch3[67] = 0;
		assign core_periphery__data_from_core_ch3[68] = 0;
		assign core_periphery__data_from_core_ch3[69] = p0_tx_dsk_marker_i[0];
		//assign p0_tx_st_data_par_s0_i[7:0] = 8'd0;



/* 		 wrlib_ecc_enc_d70_c78 tx_ecc_ch4 (		  
		 .i_data	(core_periphery__data_from_core_ch4),    //ch4_tx_ecc_data_in
		 .o_code	(ch4_tx_ecc0_data_out)  
		 ); */
		assign core_periphery__data_from_core_ch4[63] = p0_tx_st_data_s0_i[127:64];		 
		assign core_periphery__data_from_core_ch4[64] = 0;
		assign core_periphery__data_from_core_ch4[65] = 0;
		assign core_periphery__data_from_core_ch4[66] = 0;
		assign core_periphery__data_from_core_ch4[67] = 0;
		assign core_periphery__data_from_core_ch4[68] = 0;
		assign core_periphery__data_from_core_ch4[69] = p0_tx_dsk_marker_i[1];
		//assign p0_tx_st_data_par_s0_i[15:8] = 8'd0; 

		 
/* 		 wrlib_ecc_enc_d70_c78 tx_ecc_ch5 (		  
		 .i_data	(core_periphery__data_from_core_ch5),    //ch5_tx_ecc_data_in
		 .o_code	(ch5_tx_ecc0_data_out)  
		 ); */
		assign core_periphery__data_from_core_ch5[11:0] = 	p2_rx_buffer_limit_i[11:0];
		assign core_periphery__data_from_core_ch5[13:12] = 	p2_rx_buffer_limit_tdm_idx_i[1:0];	 
		assign core_periphery__data_from_core_ch5[14] = 	p2_sys_atten_button_pressed_i;
		assign core_periphery__data_from_core_ch5[15] = 	p2_sys_pwr_fault_det_i;
		assign core_periphery__data_from_core_ch5[16] = 	p2_sys_mrl_sensor_chged_i;
		assign core_periphery__data_from_core_ch5[17] = 	p2_sys_pre_det_chged_i;
		assign core_periphery__data_from_core_ch5[18] = 	p2_sys_cmd_cpled_int_i;
		assign core_periphery__data_from_core_ch5[19] =     p2_sys_pre_det_state_i;
		assign core_periphery__data_from_core_ch5[20] = 	p2_sys_mrl_sensor_state_i;
		assign core_periphery__data_from_core_ch5[21] = 	p2_sys_eml_interlock_engaged_i;
		assign core_periphery__data_from_core_ch5[22] = 	p2_sys_aux_pwr_det_i;
		assign core_periphery__data_from_core_ch5[23] = 	p2_app_ready_entr_l23_i;
		assign core_periphery__data_from_core_ch5[24] = 	p2_apps_pm_xmt_turnoff_i;
		assign core_periphery__data_from_core_ch5[25] = 	p2_app_init_rst_i;
		assign core_periphery__data_from_core_ch5[26] = 	p2_app_xfer_pending_i;
		assign core_periphery__data_from_core_ch5[27] = 	p0_tx_st_sop_s0_i;
		assign core_periphery__data_from_core_ch5[28] = 	p0_tx_st_eop_s0_i;
		assign core_periphery__data_from_core_ch5[29] = 	p0_tx_st_valid_s0_i;
		assign core_periphery__data_from_core_ch5[30] = 	p0_tx_st_err_s0_i;
		assign core_periphery__data_from_core_ch5[31] = 	p0_rx_st_ready_i;
		assign core_periphery__data_from_core_ch5[63:32] = p0_tx_st_tlp_prfx_s0_i[31:0];
		assign core_periphery__data_from_core_ch5[68:64] = p0_pld_gp_status_i[4:0];
		assign core_periphery__data_from_core_ch5[69] = p0_tx_dsk_marker_i[2];
		//assign p0_tx_st_tlp_prfx_par_s0_i = 4'd0;
		 
		 
		 
/* 		 wrlib_ecc_enc_d70_c78 tx_ecc_ch6 (		  
		 .i_data	(core_periphery__data_from_core_ch6),    //ch6_tx_ecc_data_in
		 .o_code	(ch6_tx_ecc0_data_out)  
		 ); */
		assign core_periphery__data_from_core_ch6[63:0] = 	 p0_tx_st_hdr_s0_i[63:0];
		assign core_periphery__data_from_core_ch6[66:64] = 	p0_pld_gp_status_i[7:5];
		assign core_periphery__data_from_core_ch6[67] = 	0;
		assign core_periphery__data_from_core_ch6[68] = 0;
		assign core_periphery__data_from_core_ch6[69] = p0_tx_dsk_marker_i[3];
		//assign p0_tx_st_hdr_par_s0_i[7:0] = 8'd0;

		 
/* 		 wrlib_ecc_enc_d70_c78 tx_ecc_ch7 (		  
		 .i_data	(core_periphery__data_from_core_ch7),    //ch7_tx_ecc_data_in
		 .o_code	(ch7_tx_ecc0_data_out)  
		 ); */
		assign core_periphery__data_from_core_ch7[63:0] = 	p0_tx_st_hdr_s0_i[127:64];	 
		assign core_periphery__data_from_core_ch7[64] = 	p0_sys_atten_button_pressed_i;	 
		assign core_periphery__data_from_core_ch7[65] = 	p0_sys_pwr_fault_det_i;	 
		assign core_periphery__data_from_core_ch7[66] = 	p0_sys_mrl_sensor_chged_i;	 
		assign core_periphery__data_from_core_ch7[67] = 	p0_sys_pre_det_chged_i;	 
		assign core_periphery__data_from_core_ch7[68] = 	p0_sys_cmd_cpled_int_i;	 
		assign core_periphery__data_from_core_ch7[69] = 	p0_tx_dsk_marker_i[4];
		//assign p0_tx_st_hdr_par_s0_i[15:8] = 8'd0;
		 
		 
/* 		 wrlib_ecc_enc_d70_c78 tx_ecc_ch8 (		  
		 .i_data	(core_periphery__data_from_core_ch8),    //ch8_tx_ecc_data_in
		 .o_code	(ch8_tx_ecc0_data_out)  
		 ); */
		assign core_periphery__data_from_core_ch8[63:0] = 	p0_tx_st_data_s0_i[191:128];
		assign core_periphery__data_from_core_ch8[64] = 	p0_sys_pre_det_state_i;
		assign core_periphery__data_from_core_ch8[65] = 	p0_sys_mrl_sensor_state_i;
		assign core_periphery__data_from_core_ch8[66] = 	p0_sys_eml_interlock_engaged_i;
		assign core_periphery__data_from_core_ch8[67] = 	p0_sys_aux_pwr_det_i;
		assign core_periphery__data_from_core_ch8[68] = 	0;
		assign core_periphery__data_from_core_ch8[69] = 	p0_tx_dsk_marker_i[5];
		//assign p0_tx_st_data_par_s0_i[23:16] = 8'd0;

			
/* 		 wrlib_ecc_enc_d70_c78 tx_ecc_ch9 (		  
		 .i_data	(core_periphery__data_from_core_ch9),    //ch9_tx_ecc_data_in
		 .o_code	(ch9_tx_ecc0_data_out)  
		 ); */
		assign core_periphery__data_from_core_ch9[63:0] = 	p0_tx_st_data_s0_i[255:192];	 
		assign core_periphery__data_from_core_ch9[64] = 	0;
		assign core_periphery__data_from_core_ch9[65] = 	0;
		assign core_periphery__data_from_core_ch9[66] = 	0;
		assign core_periphery__data_from_core_ch9[67] = 	0;
		assign core_periphery__data_from_core_ch9[68] = 	0;	
		assign core_periphery__data_from_core_ch9[69] = 	p0_tx_dsk_marker_i[6];
		//assign p0_tx_st_data_par_s0_i[31:24] = 8'd0;

		 
		 
/* 		 wrlib_ecc_enc_d70_c78 tx_ecc_ch12 (		  
		 .i_data	(core_periphery__data_from_core_ch12),    //ch12_tx_ecc_data_in
		 .o_code	(ch12_tx_ecc0_data_out)  
		 ); */
		assign core_periphery__data_from_core_ch12[63:0] = p1_tx_st_data_s0_i[63:0];
		assign core_periphery__data_from_core_ch12[64] = 0;
		assign core_periphery__data_from_core_ch12[65] = 0;
		assign core_periphery__data_from_core_ch12[66] = 0;
		assign core_periphery__data_from_core_ch12[67] = 0;
		assign core_periphery__data_from_core_ch12[68] = 0;
		assign core_periphery__data_from_core_ch12[69] = p1_tx_dsk_marker_i[0];
		//assign p1_tx_st_data_par_s0_i[7:0] = 8'd0;
		 
		 
/* 		 wrlib_ecc_enc_d70_c78 tx_ecc_ch13 (		  
		 .i_data	(core_periphery__data_from_core_ch13),    //ch13_tx_ecc_data_in
		 .o_code	(ch13_tx_ecc0_data_out)  
		 ); */
		assign core_periphery__data_from_core_ch13[63:0] = p1_tx_st_data_s0_i[127:64];
		assign core_periphery__data_from_core_ch13[64] = p1_sys_atten_button_pressed_i;
		assign core_periphery__data_from_core_ch13[65] = p1_sys_pwr_fault_det_i;
		assign core_periphery__data_from_core_ch13[66] = p1_sys_mrl_sensor_chged_i;		 
		assign core_periphery__data_from_core_ch13[67] = p1_sys_pre_det_chged_i;
		assign core_periphery__data_from_core_ch13[68] = p1_sys_cmd_cpled_int_i;
		assign core_periphery__data_from_core_ch13[69] = p1_tx_dsk_marker_i[1];
		//assign p1_tx_st_data_par_s0_i[15:8] = 8'd0;


		 
/* 		 wrlib_ecc_enc_d70_c78 tx_ecc_ch14 (		  
		 .i_data	(core_periphery__data_from_core_ch14),    //ch14_tx_ecc_data_in
		 .o_code	(ch14_tx_ecc0_data_out)  
		 ); */
		assign core_periphery__data_from_core_ch14[63:0] = p1_tx_st_hdr_s0_i[63:0];
		assign core_periphery__data_from_core_ch14[64] = p1_sys_pre_det_state_i;
		assign core_periphery__data_from_core_ch14[65] = p1_sys_mrl_sensor_state_i;
		assign core_periphery__data_from_core_ch14[66] = p1_sys_eml_interlock_engaged_i;		
		assign core_periphery__data_from_core_ch14[67] = p1_sys_aux_pwr_det_i;
		assign core_periphery__data_from_core_ch14[68] = 0;
		assign core_periphery__data_from_core_ch14[69] = p1_tx_dsk_marker_i[2];
		//assign p1_tx_st_hdr_par_s0_i[7:0] = 8'd0;
 
		 
/* 		 wrlib_ecc_enc_d70_c78 tx_ecc_ch15 (		  
		 .i_data	(core_periphery__data_from_core_ch15),    //ch15_tx_ecc_data_in
		 .o_code	(ch15_tx_ecc0_data_out)  
		 ); */
		assign core_periphery__data_from_core_ch15[63:0] =  p1_tx_st_hdr_s0_i[127:64];
		assign core_periphery__data_from_core_ch15[64] =  0;
		assign core_periphery__data_from_core_ch15[65] =  0;
		assign core_periphery__data_from_core_ch15[66] =  0;
		assign core_periphery__data_from_core_ch15[67] =  0;
		assign core_periphery__data_from_core_ch15[68] =  0;
		assign core_periphery__data_from_core_ch15[69] =  p1_tx_dsk_marker_i[3];	 
		//assign p1_tx_st_hdr_par_s0_i[15:8] = 8'd0;


	
	
/* 		 wrlib_ecc_enc_d70_c78 tx_ecc_ch16 (		  
		 .i_data	(core_periphery__data_from_core_ch16),    //ch16_tx_ecc_data_in
		 .o_code	(ch16_tx_ecc0_data_out)  
		 ); */
		assign core_periphery__data_from_core_ch16[11:0] = p3_rx_buffer_limit_i;
		assign core_periphery__data_from_core_ch16[13:12] = p3_rx_buffer_limit_tdm_idx_i;
		assign core_periphery__data_from_core_ch16[14]  = 	p3_sys_atten_button_pressed_i;
		assign core_periphery__data_from_core_ch16[15]  =	p3_sys_pwr_fault_det_i;
		assign core_periphery__data_from_core_ch16[16]  = 	p3_sys_mrl_sensor_chged_i;
		assign core_periphery__data_from_core_ch16[17]  = 	p3_sys_pre_det_chged_i;
		assign core_periphery__data_from_core_ch16[18]  = 	p3_sys_cmd_cpled_int_i;
		assign core_periphery__data_from_core_ch16[19]  = 	p3_sys_pre_det_state_i;
		assign core_periphery__data_from_core_ch16[20]  = 	p3_sys_mrl_sensor_state_i;
		assign core_periphery__data_from_core_ch16[21]  = 	p3_sys_eml_interlock_engaged_i;
		assign core_periphery__data_from_core_ch16[22]  = 	p3_sys_aux_pwr_det_i;
		assign core_periphery__data_from_core_ch16[23]  = 	p3_app_ready_entr_l23_i;
		assign core_periphery__data_from_core_ch16[24]  = 	p3_apps_pm_xmt_turnoff_i;
		assign core_periphery__data_from_core_ch16[25]  = 	p3_app_init_rst_i;
		assign core_periphery__data_from_core_ch16[26]  = 	p3_app_xfer_pending_i;
		assign core_periphery__data_from_core_ch16[31:27] =	0;
		assign core_periphery__data_from_core_ch16[63:32] =	p1_tx_st_tlp_prfx_s0_i[31:0];
		assign core_periphery__data_from_core_ch16[64]   =	p1_tx_st_sop_s0_i;
		assign core_periphery__data_from_core_ch16[65]   =	p1_tx_st_eop_s0_i;
		assign core_periphery__data_from_core_ch16[66]   =	p1_tx_st_valid_s0_i;
		assign core_periphery__data_from_core_ch16[67]   =	p1_tx_st_err_s0_i;
		assign core_periphery__data_from_core_ch16[68]   =	p1_rx_st_ready_i;
		assign core_periphery__data_from_core_ch16[69]   =	p1_tx_dsk_marker_i[4];
		//assign p1_tx_st_tlp_prfx_par_s0_i[3:0] = 4'd0;



		 
/* 		 wrlib_ecc_enc_d70_c78 tx_ecc_ch18 (		  
		 .i_data	(core_periphery__data_from_core_ch18),    //ch17_tx_ecc_data_in
		 .o_code	(ch18_tx_ecc0_data_out)  
		 );
 */
		assign core_periphery__data_from_core_ch18[63:0] =	p1_tx_st_data_s0_i[191:128];
		assign core_periphery__data_from_core_ch18[68:64]= 	5'b0000;
		assign core_periphery__data_from_core_ch18[69]   =	p1_tx_dsk_marker_i[5];
		//assign p1_tx_st_data_par_s0_i[23:16] = 8'd0;




/* 		 wrlib_ecc_enc_d70_c78 tx_ecc_ch19 (		  
		 .i_data	(core_periphery__data_from_core_ch19),    //ch17_tx_ecc_data_in
		 .o_code	(ch19_tx_ecc0_data_out)  
		 );
 */
		assign core_periphery__data_from_core_ch19[63:0] =	p1_tx_st_data_s0_i[255:192];
		assign core_periphery__data_from_core_ch19[68:64]= 	0;
		assign core_periphery__data_from_core_ch19[69]   =	p1_tx_dsk_marker_i[6];
		//assign p1_tx_st_data_par_s0_i[31:24] = 8'd0;
		 



always @(posedge i_clk )
begin 
	if(p0_reset == 0)
	begin 
	
		ch3_tx_ecc_data_in_r <= 0;
		ch4_tx_ecc_data_in_r <= 0;
		ch5_tx_ecc_data_in_r <= 0;
		ch6_tx_ecc_data_in_r <= 0;
		ch7_tx_ecc_data_in_r <= 0;
		ch8_tx_ecc_data_in_r <= 0;
		ch9_tx_ecc_data_in_r <= 0;
		//ch11_tx_ecc_data_in_r <= 0;

	end 
	
	else 
	begin 
		ch3_tx_ecc_data_in_r <= ch3_tx_ecc_data_in;
		ch4_tx_ecc_data_in_r <= ch4_tx_ecc_data_in;
		ch5_tx_ecc_data_in_r <= ch5_tx_ecc_data_in;
		ch6_tx_ecc_data_in_r <= ch6_tx_ecc_data_in;
		ch7_tx_ecc_data_in_r <= ch7_tx_ecc_data_in;
		ch8_tx_ecc_data_in_r <= ch8_tx_ecc_data_in;
		ch9_tx_ecc_data_in_r <= ch9_tx_ecc_data_in;
		//ch11_tx_ecc_data_in_r <= ch11_tx_ecc_data_in;
	end 
end 


always @(posedge i_clk )
begin 
	if(p1_reset == 0)
	begin 
	
		ch12_tx_ecc_data_in_r <= 0;
		ch13_tx_ecc_data_in_r <= 0;
		ch14_tx_ecc_data_in_r <= 0;
		ch15_tx_ecc_data_in_r <= 0;
		ch16_tx_ecc_data_in_r <= 0;
		ch18_tx_ecc_data_in_r <= 0;
		ch19_tx_ecc_data_in_r <= 0;

	end 
	
	else 
	begin 
	
		ch12_tx_ecc_data_in_r <= ch12_tx_ecc_data_in;
		ch13_tx_ecc_data_in_r <= ch13_tx_ecc_data_in;
		ch14_tx_ecc_data_in_r <= ch14_tx_ecc_data_in;
		ch15_tx_ecc_data_in_r <= ch15_tx_ecc_data_in;
		ch16_tx_ecc_data_in_r <= ch16_tx_ecc_data_in;
		ch18_tx_ecc_data_in_r <= ch18_tx_ecc_data_in;
		ch19_tx_ecc_data_in_r <= ch19_tx_ecc_data_in;

	end 
end 


// Mux to select ECC input
assign  ch3_tx_ecc_data_in 	= (core8_enable_ecc_hwtcl ==1'b0) ? 70'd0 :	core_periphery__data_from_core_ch3 ;						
assign  ch4_tx_ecc_data_in 	= (core8_enable_ecc_hwtcl ==1'b0) ? 70'd0 : 	core_periphery__data_from_core_ch4 ;	
assign  ch5_tx_ecc_data_in 	= (core8_enable_ecc_hwtcl ==1'b0) ? 70'd0 : 	core_periphery__data_from_core_ch5 ;	
assign  ch6_tx_ecc_data_in 	= (core8_enable_ecc_hwtcl ==1'b0) ? 70'd0 : 	core_periphery__data_from_core_ch6  ;
assign  ch7_tx_ecc_data_in 	= (core8_enable_ecc_hwtcl ==1'b0) ? 70'd0 : 	core_periphery__data_from_core_ch7 ;
assign  ch8_tx_ecc_data_in 	= (core8_enable_ecc_hwtcl ==1'b0) ? 70'd0 : 	core_periphery__data_from_core_ch8 ;	
assign  ch9_tx_ecc_data_in 	= (core8_enable_ecc_hwtcl ==1'b0) ? 70'd0 : 	core_periphery__data_from_core_ch9 ;
//assign  ch11_tx_ecc_data_in 	= (core8_enable_ecc_hwtcl ==1'b0) ? 70'd0 : 	core_periphery__data_from_core_ch11 ;
assign  ch12_tx_ecc_data_in 	= (core8_enable_ecc_hwtcl ==1'b0) ? 70'd0 : 	core_periphery__data_from_core_ch12  ;	
assign  ch13_tx_ecc_data_in 	= (core8_enable_ecc_hwtcl ==1'b0) ? 70'd0 :    core_periphery__data_from_core_ch13 ;	
assign  ch14_tx_ecc_data_in 	= (core8_enable_ecc_hwtcl ==1'b0) ? 70'd0 :    core_periphery__data_from_core_ch14 ;
assign  ch15_tx_ecc_data_in 	= (core8_enable_ecc_hwtcl ==1'b0) ? 70'd0 :    core_periphery__data_from_core_ch15 ;
assign  ch16_tx_ecc_data_in 	= (core8_enable_ecc_hwtcl ==1'b0) ? 70'd0 :    core_periphery__data_from_core_ch16 ;
assign  ch18_tx_ecc_data_in 	= (core8_enable_ecc_hwtcl ==1'b0) ? 70'd0 :    core_periphery__data_from_core_ch18 ;
assign  ch19_tx_ecc_data_in 	= (core8_enable_ecc_hwtcl ==1'b0) ? 70'd0 :    core_periphery__data_from_core_ch19 ;



assign i_rx_ecc_data	 =  (	
							{ 
							{ch19_tx_ecc_data_in_r}, 
							{ch18_tx_ecc_data_in_r},
							{ch16_tx_ecc_data_in_r}, 
							{ch15_tx_ecc_data_in_r}, 
							{ch14_tx_ecc_data_in_r},
							{ch13_tx_ecc_data_in_r},  
							{ch12_tx_ecc_data_in_r}, 
							{ch9_tx_ecc_data_in_r},
							{ch8_tx_ecc_data_in_r},
							{ch7_tx_ecc_data_in_r}, 
							{ch6_tx_ecc_data_in_r},
							{ch5_tx_ecc_data_in_r}, 
							{ch4_tx_ecc_data_in_r}, 
							{ch3_tx_ecc_data_in_r} }   
						);


//ecc module instantaition
for(ww=0; ww<NUM_CHAN; ww++) begin:ecc_module_instantiation
				
		assign  data_in[ww] = i_rx_ecc_data[ww*AIB_WIDTH+:AIB_WIDTH]	;	
		
				wrlib_ecc_dec_c78_d70 inst_rx_ecc (

				   .o_int_sec 		(o_int_sec[ww]),
				   .o_int_ded		(o_int_ded[ww]),
				   .o_syndrome		(o_syndrome[ww]),
				   .i_code			(data_in[ww]),
				   .o_data			(data_out[ww])

				);
			
		assign o_rx_ecc_data[ww*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] = data_out[ww];
		
end:ecc_module_instantiation

//Adding mux to accomodate Bypass mode, 0 latency and 1 latency in ECC
									
assign  ch3_tx_ecc_data_out   = (core8_enable_ecc_hwtcl ==1'b0) ? {p0_tx_st_data_par_s0_i[7:0],core_periphery__data_from_core_ch3} 		   : o_rx_ecc_data[0*ECC_OUT_WIDTH+:ECC_OUT_WIDTH]	;  //ch3_tx_ecc_data_in							
assign  ch4_tx_ecc_data_out   = (core8_enable_ecc_hwtcl ==1'b0) ? {p0_tx_st_data_par_s0_i[15:8], core_periphery__data_from_core_ch4} 		   : o_rx_ecc_data[1*ECC_OUT_WIDTH+:ECC_OUT_WIDTH]	; //ch4_tx_ecc_data_in								
assign  ch5_tx_ecc_data_out   = (core8_enable_ecc_hwtcl ==1'b0) ? {p0_tx_st_tlp_prfx_par_s0_i, 4'b0000, core_periphery__data_from_core_ch5}   : o_rx_ecc_data[2*ECC_OUT_WIDTH+:ECC_OUT_WIDTH]	; //ch5_tx_ecc_data_in									
assign  ch6_tx_ecc_data_out   = (core8_enable_ecc_hwtcl ==1'b0) ? {p0_tx_st_hdr_par_s0_i[7:0], core_periphery__data_from_core_ch6} 		   : o_rx_ecc_data[3*ECC_OUT_WIDTH+:ECC_OUT_WIDTH]	; //ch6_tx_ecc_data_in									
assign  ch7_tx_ecc_data_out   = (core8_enable_ecc_hwtcl ==1'b0) ? {p0_tx_st_hdr_par_s0_i[15:8], core_periphery__data_from_core_ch7} 	       : o_rx_ecc_data[4*ECC_OUT_WIDTH+:ECC_OUT_WIDTH]	; //ch7_tx_ecc_data_in									
assign  ch8_tx_ecc_data_out   = (core8_enable_ecc_hwtcl ==1'b0) ? {p0_tx_st_data_par_s0_i[23:16], core_periphery__data_from_core_ch8} 		   : o_rx_ecc_data[5*ECC_OUT_WIDTH+:ECC_OUT_WIDTH]	;  //ch8_tx_ecc_data_in									
assign  ch9_tx_ecc_data_out   = (core8_enable_ecc_hwtcl ==1'b0) ? {p0_tx_st_data_par_s0_i[31:24], core_periphery__data_from_core_ch9} 		   : o_rx_ecc_data[6*ECC_OUT_WIDTH+:ECC_OUT_WIDTH]	; //ch9_tx_ecc_data_in									
assign  ch12_tx_ecc_data_out  = (core8_enable_ecc_hwtcl ==1'b0) ? {p1_tx_st_data_par_s0_i[7:0],core_periphery__data_from_core_ch12}            : o_rx_ecc_data[7*ECC_OUT_WIDTH+:ECC_OUT_WIDTH]	; //ch11_tx_ecc_data_in									
assign  ch13_tx_ecc_data_out  = (core8_enable_ecc_hwtcl ==1'b0) ? {p1_tx_st_data_par_s0_i[15:8], core_periphery__data_from_core_ch13}          : o_rx_ecc_data[8*ECC_OUT_WIDTH+:ECC_OUT_WIDTH]	;   //ch12_tx_ecc_data_in									
assign  ch14_tx_ecc_data_out  = (core8_enable_ecc_hwtcl ==1'b0) ? {p1_tx_st_hdr_par_s0_i[7:0], core_periphery__data_from_core_ch14} 		   : o_rx_ecc_data[9*ECC_OUT_WIDTH+:ECC_OUT_WIDTH]	;  //ch13_tx_ecc_data_in								
assign  ch15_tx_ecc_data_out  = (core8_enable_ecc_hwtcl ==1'b0) ? {p1_tx_st_hdr_par_s0_i[15:8], core_periphery__data_from_core_ch15} 	       : o_rx_ecc_data[10*ECC_OUT_WIDTH+:ECC_OUT_WIDTH]	;  //ch14_tx_ecc_data_in									
assign  ch16_tx_ecc_data_out  = (core8_enable_ecc_hwtcl ==1'b0) ? {p1_tx_st_tlp_prfx_par_s0_i, 4'b0000, core_periphery__data_from_core_ch16}   : o_rx_ecc_data[11*ECC_OUT_WIDTH+:ECC_OUT_WIDTH]	;  //ch15_tx_ecc_data_in									
assign  ch18_tx_ecc_data_out  = (core8_enable_ecc_hwtcl ==1'b0) ? {p1_tx_st_data_par_s0_i[23:16], core_periphery__data_from_core_ch18}  	   : o_rx_ecc_data[12*ECC_OUT_WIDTH+:ECC_OUT_WIDTH]	; //ch16_tx_ecc_data_in									
assign  ch19_tx_ecc_data_out  = (core8_enable_ecc_hwtcl ==1'b0) ? {p1_tx_st_data_par_s0_i[31:24], core_periphery__data_from_core_ch19} 		   :  o_rx_ecc_data[13*ECC_OUT_WIDTH+:ECC_OUT_WIDTH]	; //ch17_tx_ecc_data_in

			end
		endgenerate 
	
	
//x4 mode	
	generate if (DEVICE_WIDTH == "pcie_x4x4x4x4")   begin 
	
localparam AIB_WIDTH = 78;
localparam NUM_CHAN = 20; 
localparam ECC_OUT_WIDTH = 70;
genvar ww;

logic [NUM_CHAN * AIB_WIDTH-1:0] i_rx_ecc_data;
logic [NUM_CHAN * ECC_OUT_WIDTH-1:0] o_rx_ecc_data;
logic [NUM_CHAN-1:0] [AIB_WIDTH-1:0] data_in;
logic [NUM_CHAN-1:0] [ECC_OUT_WIDTH-1:0] data_out;
logic [NUM_CHAN-1:0] o_int_sec;
logic [NUM_CHAN-1:0] o_int_ded;
logic [NUM_CHAN-1:0] o_syndrome;

	
/* 		 wrlib_ecc_enc_d70_c78 tx_ecc_ch0 (		  
		 .i_data	(core_periphery__data_from_core_ch0),    //ch3_tx_ecc_data_in
		 .o_code	(ch0_tx_ecc0_data_out)  
		 ); */

		assign core_periphery__data_from_core_ch0[63:0] = p2_tx_st_data_s0_i[63:0];
		assign core_periphery__data_from_core_ch0[64] = 0;
		assign core_periphery__data_from_core_ch0[65] = 0;
		assign core_periphery__data_from_core_ch0[66] = 0;
		assign core_periphery__data_from_core_ch0[67] = 0;
		assign core_periphery__data_from_core_ch0[68] = 0;
		assign core_periphery__data_from_core_ch0[69] = p2_tx_dsk_marker_i[0];
		//assign p2_tx_st_data_par_s0_i[7:0] = 8'd0;



/* 		 wrlib_ecc_enc_d70_c78 tx_ecc_ch1 (		  
		 .i_data	(core_periphery__data_from_core_ch1),    //ch4_tx_ecc_data_in
		 .o_code	(ch1_tx_ecc0_data_out)  
		 ); */
		assign core_periphery__data_from_core_ch1[63] = p2_tx_st_data_s0_i[127:64];		 
		assign core_periphery__data_from_core_ch1[64] = p2_app_err_valid_i;
		assign core_periphery__data_from_core_ch1[68:65] = p2_app_err_hdr_i[3:0];
		assign core_periphery__data_from_core_ch1[69] = p2_tx_dsk_marker_i[1];
		//assign p2_tx_st_data_par_s0_i[15:8] = 8'd0;

		 
/* 		 wrlib_ecc_enc_d70_c78 tx_ecc_ch2 (		  
		 .i_data	(core_periphery__data_from_core_ch2),    //ch5_tx_ecc_data_in
		 .o_code	(ch2_tx_ecc0_data_out)  
		 ); */
		assign core_periphery__data_from_core_ch2[63:0] = 	p2_tx_st_hdr_s0_i[63:0];
		assign core_periphery__data_from_core_ch2[68:64] = 	p2_app_err_hdr_i[8:4];	 
		assign core_periphery__data_from_core_ch2[69] = p2_tx_dsk_marker_i[2];
		//assign p2_tx_st_hdr_par_s0_i[7:0] = 8'd0;

		 
/* 		 wrlib_ecc_enc_d70_c78 tx_ecc_ch3 (		  
		 .i_data	(core_periphery__data_from_core_ch3),    //ch6_tx_ecc_data_in
		 .o_code	(ch3_tx_ecc0_data_out)  
		 ); */
		assign core_periphery__data_from_core_ch3[63:0] = 	 p2_tx_st_hdr_s0_i[127:64];
		assign core_periphery__data_from_core_ch3[68:64] = 	p2_app_err_hdr_i[13:9];
		assign core_periphery__data_from_core_ch3[69] = p2_tx_dsk_marker_i[3];
		//assign p2_tx_st_hdr_par_s0_i[15:8] = 8'd0;

		 
/* 		 wrlib_ecc_enc_d70_c78 tx_ecc_ch4 (		  
		 .i_data	(core_periphery__data_from_core_ch4),    //ch7_tx_ecc_data_in
		 .o_code	(ch4_tx_ecc0_data_out)  
		 ); */
 
		assign core_periphery__data_from_core_ch4[31:0] =	p2_tx_st_tlp_prfx_s0_i;
		assign core_periphery__data_from_core_ch4[32]   =	p2_tx_st_sop_s0_i;
		assign core_periphery__data_from_core_ch4[33]   =	p2_tx_st_eop_s0_i;
		assign core_periphery__data_from_core_ch4[34]   =	p2_tx_st_valid_s0_i;
		assign core_periphery__data_from_core_ch4[35]   =	p2_tx_st_err_s0_i;
		assign core_periphery__data_from_core_ch4[36]   =	p2_rx_st_ready_i;
		assign core_periphery__data_from_core_ch4[54:37] =	p2_app_err_hdr_i[31:14];
		assign core_periphery__data_from_core_ch4[67:55] =	p2_app_err_info_i[12:0];
		assign core_periphery__data_from_core_ch4[68]   =	p2_apps_pm_xmt_pme_i;      //check again
		assign core_periphery__data_from_core_ch4[69]   =	p2_tx_dsk_marker_i[4];
		//assign p2_tx_st_tlp_prfx_par_s0_i[3:0] = 8'd0;

		 
/* 		 wrlib_ecc_enc_d70_c78 tx_ecc_ch5 (		  
		 .i_data	(core_periphery__data_from_core_ch5),    //ch5_tx_ecc_data_in
		 .o_code	(ch5_tx_ecc0_data_out)  
		 ); */
		assign core_periphery__data_from_core_ch5[11:0] = 	p2_rx_buffer_limit_i[11:0];
		assign core_periphery__data_from_core_ch5[13:12] = 	p2_rx_buffer_limit_tdm_idx_i[1:0];	 
		assign core_periphery__data_from_core_ch5[14] = 	p2_sys_atten_button_pressed_i;
		assign core_periphery__data_from_core_ch5[15] = 	p2_sys_pwr_fault_det_i;
		assign core_periphery__data_from_core_ch5[16] = 	p2_sys_mrl_sensor_chged_i;
		assign core_periphery__data_from_core_ch5[17] = 	p2_sys_pre_det_chged_i;
		assign core_periphery__data_from_core_ch5[18] = 	p2_sys_cmd_cpled_int_i;
		assign core_periphery__data_from_core_ch5[19] =     p2_sys_pre_det_state_i;
		assign core_periphery__data_from_core_ch5[20] = 	p2_sys_mrl_sensor_state_i;
		assign core_periphery__data_from_core_ch5[21] = 	p2_sys_eml_interlock_engaged_i;
		assign core_periphery__data_from_core_ch5[22] = 	p2_sys_aux_pwr_det_i;
		assign core_periphery__data_from_core_ch5[23] = 	p2_app_ready_entr_l23_i;
		assign core_periphery__data_from_core_ch5[24] = 	p2_apps_pm_xmt_turnoff_i;
		assign core_periphery__data_from_core_ch5[25] = 	p2_app_init_rst_i;
		assign core_periphery__data_from_core_ch5[26] = 	p2_app_xfer_pending_i;
		assign core_periphery__data_from_core_ch5[27] = 	p0_tx_st_sop_s0_i;
		assign core_periphery__data_from_core_ch5[28] = 	p0_tx_st_eop_s0_i;
		assign core_periphery__data_from_core_ch5[29] = 	p0_tx_st_valid_s0_i;
		assign core_periphery__data_from_core_ch5[30] = 	p0_tx_st_err_s0_i;
		assign core_periphery__data_from_core_ch5[31] = 	p0_rx_st_ready_i;
		assign core_periphery__data_from_core_ch5[63:32] = p0_tx_st_tlp_prfx_s0_i[31:0];
		assign core_periphery__data_from_core_ch5[68:64] = p0_pld_gp_status_i[4:0];
		assign core_periphery__data_from_core_ch5[69] = p0_tx_dsk_marker_i[2];
		//assign p0_tx_st_tlp_prfx_par_s0_i[3:0] = 4'd0;

		
/* 		 wrlib_ecc_enc_d70_c78 tx_ecc_ch6 (		  
		 .i_data	(core_periphery__data_from_core_ch6),    //ch6_tx_ecc_data_in
		 .o_code	(ch6_tx_ecc0_data_out)  
		 ); */
		assign core_periphery__data_from_core_ch6[63:0] = 	 p0_tx_st_hdr_s0_i[63:0];
		assign core_periphery__data_from_core_ch6[66:64] = 	p0_pld_gp_status_i[7:5];
		assign core_periphery__data_from_core_ch6[67] = 	0;
		assign core_periphery__data_from_core_ch6[68] = 0;
		assign core_periphery__data_from_core_ch6[69] = p0_tx_dsk_marker_i[3];
		//assign p0_tx_st_hdr_par_s0_i[7:0] = 8'd0;

		 
/* 		 wrlib_ecc_enc_d70_c78 tx_ecc_ch7 (		  
		 .i_data	(core_periphery__data_from_core_ch7),    //ch7_tx_ecc_data_in
		 .o_code	(ch7_tx_ecc0_data_out)  
		 ); */
		assign core_periphery__data_from_core_ch7[63:0] = 	p0_tx_st_hdr_s0_i[127:64];	 
		assign core_periphery__data_from_core_ch7[64] = 	p0_sys_atten_button_pressed_i;	 
		assign core_periphery__data_from_core_ch7[65] = 	p0_sys_pwr_fault_det_i;	 
		assign core_periphery__data_from_core_ch7[66] = 	p0_sys_mrl_sensor_chged_i;	 
		assign core_periphery__data_from_core_ch7[67] = 	p0_sys_pre_det_chged_i;	 
		assign core_periphery__data_from_core_ch7[68] = 	p0_sys_cmd_cpled_int_i;	 
		assign core_periphery__data_from_core_ch7[69] = 	p0_tx_dsk_marker_i[4];
		//assign p0_tx_st_hdr_par_s0_i[15:8] = 8'd0;
		
		 
/* 		 wrlib_ecc_enc_d70_c78 tx_ecc_ch8 (		  
		 .i_data	(core_periphery__data_from_core_ch8),    //ch8_tx_ecc_data_in
		 .o_code	(ch8_tx_ecc0_data_out)  
		 ); */
		assign core_periphery__data_from_core_ch8[63:0] = 	p0_tx_st_data_s0_i[191:128];
		assign core_periphery__data_from_core_ch8[64] = 	p0_sys_pre_det_state_i;
		assign core_periphery__data_from_core_ch8[65] = 	p0_sys_mrl_sensor_state_i;
		assign core_periphery__data_from_core_ch8[66] = 	p0_sys_eml_interlock_engaged_i;
		assign core_periphery__data_from_core_ch8[67] = 	p0_sys_aux_pwr_det_i;
		assign core_periphery__data_from_core_ch8[68] = 	0;
		assign core_periphery__data_from_core_ch8[69] = 	p0_tx_dsk_marker_i[5];
		//assign p0_tx_st_data_par_s0_i[23:16] = 8'd0;

			
/* 		 wrlib_ecc_enc_d70_c78 tx_ecc_ch9 (		  
		 .i_data	(core_periphery__data_from_core_ch9),    //ch9_tx_ecc_data_in
		 .o_code	(ch9_tx_ecc0_data_out)  
		 ); */
		assign core_periphery__data_from_core_ch9[63:0] = 	p0_tx_st_data_s0_i[255:192];	 
		assign core_periphery__data_from_core_ch9[64] = 	0;
		assign core_periphery__data_from_core_ch9[65] = 	0;
		assign core_periphery__data_from_core_ch9[66] = 	0;
		assign core_periphery__data_from_core_ch9[67] = 	0;
		assign core_periphery__data_from_core_ch9[68] = 	0;	
		assign core_periphery__data_from_core_ch9[69] = 	p0_tx_dsk_marker_i[6];
		//assign p0_tx_st_data_par_s0_i[31:24] = 8'd0;




		 
/* 		 wrlib_ecc_enc_d70_c78 tx_ecc_ch12 (		  
		 .i_data	(core_periphery__data_from_core_ch12),    //ch12_tx_ecc_data_in
		 .o_code	(ch12_tx_ecc0_data_out)  
		 ); */
		assign core_periphery__data_from_core_ch12[63:0] = p1_tx_st_data_s0_i[63:0];
		assign core_periphery__data_from_core_ch12[64] = 0;
		assign core_periphery__data_from_core_ch12[65] = 0;
		assign core_periphery__data_from_core_ch12[66] = 0;
		assign core_periphery__data_from_core_ch12[67] = 0;
		assign core_periphery__data_from_core_ch12[68] = 0;
		assign core_periphery__data_from_core_ch12[69] = p1_tx_dsk_marker_i[0];
		//assign p1_tx_st_data_par_s0_i[7:0] = 8'd0;
		 
		 
/* 		 wrlib_ecc_enc_d70_c78 tx_ecc_ch13 (		  
		 .i_data	(core_periphery__data_from_core_ch13),    //ch13_tx_ecc_data_in
		 .o_code	(ch13_tx_ecc0_data_out)  
		 ); */
		assign core_periphery__data_from_core_ch13[63:0] = p1_tx_st_data_s0_i[127:64];
		assign core_periphery__data_from_core_ch13[64] = p1_sys_atten_button_pressed_i;
		assign core_periphery__data_from_core_ch13[65] = p1_sys_pwr_fault_det_i;
		assign core_periphery__data_from_core_ch13[66] = p1_sys_mrl_sensor_chged_i;		 
		assign core_periphery__data_from_core_ch13[67] = p1_sys_pre_det_chged_i;
		assign core_periphery__data_from_core_ch13[68] = p1_sys_cmd_cpled_int_i;
		assign core_periphery__data_from_core_ch13[69] = p1_tx_dsk_marker_i[1];
		//assign p1_tx_st_data_par_s0_i[15:8] = 8'd0;


		 
/* 		 wrlib_ecc_enc_d70_c78 tx_ecc_ch14 (		  
		 .i_data	(core_periphery__data_from_core_ch14),    //ch14_tx_ecc_data_in
		 .o_code	(ch14_tx_ecc0_data_out)  
		 ); */
		assign core_periphery__data_from_core_ch14[63:0] = p1_tx_st_hdr_s0_i[63:0];
		assign core_periphery__data_from_core_ch14[64] = p1_sys_pre_det_state_i;
		assign core_periphery__data_from_core_ch14[65] = p1_sys_mrl_sensor_state_i;
		assign core_periphery__data_from_core_ch14[66] = p1_sys_eml_interlock_engaged_i;		
		assign core_periphery__data_from_core_ch14[67] = p1_sys_aux_pwr_det_i;
		assign core_periphery__data_from_core_ch14[68] = 0;
		assign core_periphery__data_from_core_ch14[69] = p1_tx_dsk_marker_i[2];
		//assign p1_tx_st_hdr_par_s0_i[7:0] = 8'd0;
 
		 
/* 		 wrlib_ecc_enc_d70_c78 tx_ecc_ch15 (		  
		 .i_data	(core_periphery__data_from_core_ch15),    //ch15_tx_ecc_data_in
		 .o_code	(ch15_tx_ecc0_data_out)  
		 ); */
		assign core_periphery__data_from_core_ch15[63:0] =  p1_tx_st_hdr_s0_i[127:64];
		assign core_periphery__data_from_core_ch15[64] =  0;
		assign core_periphery__data_from_core_ch15[65] =  0;
		assign core_periphery__data_from_core_ch15[66] =  0;
		assign core_periphery__data_from_core_ch15[67] =  0;
		assign core_periphery__data_from_core_ch15[68] =  0;
		assign core_periphery__data_from_core_ch15[69] =  p1_tx_dsk_marker_i[3];	 
		//assign p1_tx_st_hdr_par_s0_i[15:8] = 8'd0;


	
/* 		 wrlib_ecc_enc_d70_c78 tx_ecc_ch16 (		  
		 .i_data	(core_periphery__data_from_core_ch16),    //ch16_tx_ecc_data_in
		 .o_code	(ch16_tx_ecc0_data_out)  
		 ); */
		assign core_periphery__data_from_core_ch16[11:0] = p3_rx_buffer_limit_i;
		assign core_periphery__data_from_core_ch16[13:12] = p3_rx_buffer_limit_tdm_idx_i;
		assign core_periphery__data_from_core_ch16[14]  = 	p3_sys_atten_button_pressed_i;
		assign core_periphery__data_from_core_ch16[15]  =	p3_sys_pwr_fault_det_i;
		assign core_periphery__data_from_core_ch16[16]  = 	p3_sys_mrl_sensor_chged_i;
		assign core_periphery__data_from_core_ch16[17]  = 	p3_sys_pre_det_chged_i;
		assign core_periphery__data_from_core_ch16[18]  = 	p3_sys_cmd_cpled_int_i;
		assign core_periphery__data_from_core_ch16[19]  = 	p3_sys_pre_det_state_i;
		assign core_periphery__data_from_core_ch16[20]  = 	p3_sys_mrl_sensor_state_i;
		assign core_periphery__data_from_core_ch16[21]  = 	p3_sys_eml_interlock_engaged_i;
		assign core_periphery__data_from_core_ch16[22]  = 	p3_sys_aux_pwr_det_i;
		assign core_periphery__data_from_core_ch16[23]  = 	p3_app_ready_entr_l23_i;
		assign core_periphery__data_from_core_ch16[24]  = 	p3_apps_pm_xmt_turnoff_i;
		assign core_periphery__data_from_core_ch16[25]  = 	p3_app_init_rst_i;
		assign core_periphery__data_from_core_ch16[26]  = 	p3_app_xfer_pending_i;
		assign core_periphery__data_from_core_ch16[31:27] =	5'd0;
		assign core_periphery__data_from_core_ch16[63:32] =	p1_tx_st_tlp_prfx_s0_i[31:0];
		assign core_periphery__data_from_core_ch16[64]   =	p1_tx_st_sop_s0_i;
		assign core_periphery__data_from_core_ch16[65]   =	p1_tx_st_eop_s0_i;
		assign core_periphery__data_from_core_ch16[66]   =	p1_tx_st_valid_s0_i;
		assign core_periphery__data_from_core_ch16[67]   =	p1_tx_st_err_s0_i;
		assign core_periphery__data_from_core_ch16[68]   =	p1_rx_st_ready_i;
		assign core_periphery__data_from_core_ch16[69]   =	p1_tx_dsk_marker_i[4];
		//assign p1_tx_st_tlp_prfx_par_s0_i[3:0] = 4'd0;

	 
/* 		 wrlib_ecc_enc_d70_c78 tx_ecc_ch17 (		  
		 .i_data	(core_periphery__data_from_core_ch17),    //ch17_tx_ecc_data_in
		 .o_code	(ch17_tx_ecc0_data_out)  
		 ); */
		assign core_periphery__data_from_core_ch17[63:0] = p3_tx_st_data_s0_i[63:0];
		assign core_periphery__data_from_core_ch17[64] = 0;
		assign core_periphery__data_from_core_ch17[65] = 0;
		assign core_periphery__data_from_core_ch17[66] = 0;
		assign core_periphery__data_from_core_ch17[67] = 0;
		assign core_periphery__data_from_core_ch17[68] = 0;
		assign core_periphery__data_from_core_ch17[69] = p3_tx_dsk_marker_i[0];
		//assign p3_tx_st_data_par_s0_i[7:0] = 8'd0;

		 
/* 		 wrlib_ecc_enc_d70_c78 tx_ecc_ch18 (		  
		 .i_data	(core_periphery__data_from_core_ch18),    //ch17_tx_ecc_data_in
		 .o_code	(ch18_tx_ecc0_data_out)  
		 ); */

		assign core_periphery__data_from_core_ch18[63:0] =	p3_tx_st_data_s0_i[127:64];
		assign core_periphery__data_from_core_ch18[64]  = 	p3_app_err_valid_i;
		assign core_periphery__data_from_core_ch18[68:65] =	p3_app_err_hdr_i[3:0];
		assign core_periphery__data_from_core_ch18[69]   =	p3_tx_dsk_marker_i[1];
		//assign p3_tx_st_data_par_s0_i[15:8] = 8'd0;



/* 		 wrlib_ecc_enc_d70_c78 tx_ecc_ch19 (		  
		 .i_data	(core_periphery__data_from_core_ch19),    //ch17_tx_ecc_data_in
		 .o_code	(ch19_tx_ecc0_data_out)  
		 );
 */
		assign core_periphery__data_from_core_ch19[63:0] =	p3_tx_st_hdr_s0_i[63:0];
		assign core_periphery__data_from_core_ch19[68:64]= 	p3_app_err_hdr_i[8:4];
		assign core_periphery__data_from_core_ch19[69]   =	p3_tx_dsk_marker_i[2];
		//assign p3_tx_st_hdr_par_s0_i[7:0] = 8'd0;
		

/* 		 wrlib_ecc_enc_d70_c78 tx_ecc_ch20 (		  
		 .i_data	(core_periphery__data_from_core_ch20),    //ch17_tx_ecc_data_in
		 .o_code	(ch20_tx_ecc0_data_out)  
		 ); */

		assign core_periphery__data_from_core_ch20[63:0] =	p3_tx_st_hdr_s0_i[127:64];
		assign core_periphery__data_from_core_ch20[68:64]= 	p3_app_err_hdr_i[13:9];
		assign core_periphery__data_from_core_ch20[69]   =	p3_tx_dsk_marker_i[3];
		//assign p3_tx_st_hdr_par_s0_i[15:8] = 8'd0;
		
		
/* 		 wrlib_ecc_enc_d70_c78 tx_ecc_ch21 (		  
		 .i_data	(core_periphery__data_from_core_ch21),    //ch17_tx_ecc_data_in
		 .o_code	(ch21_tx_ecc0_data_out)  
		 ); */
		assign core_periphery__data_from_core_ch21[31:0] =	p3_tx_st_tlp_prfx_s0_i;
		assign core_periphery__data_from_core_ch21[32]   =	p3_tx_st_sop_s0_i;
		assign core_periphery__data_from_core_ch21[33]   =	p3_tx_st_eop_s0_i;
		assign core_periphery__data_from_core_ch21[34]   =	p3_tx_st_valid_s0_i;
		assign core_periphery__data_from_core_ch21[35]   =	p3_tx_st_err_s0_i;
		assign core_periphery__data_from_core_ch21[36]   =	p3_rx_st_ready_i;
		assign core_periphery__data_from_core_ch21[54:37] =	p3_app_err_hdr_i[31:14];
		assign core_periphery__data_from_core_ch21[67:55] =	p3_app_err_info_i[12:0];
		assign core_periphery__data_from_core_ch21[68]   =	p3_apps_pm_xmt_pme_i;         //check again
		assign core_periphery__data_from_core_ch21[69]   =	p3_tx_dsk_marker_i[4];
		//assign p3_tx_st_tlp_prfx_par_s0_i[3:0] = 4'd0;
		

always @(posedge i_clk )
begin 
	if(p2_reset == 0)
	begin 
		ch0_tx_ecc_data_in_r <= 0;
		ch1_tx_ecc_data_in_r <= 0;
		ch2_tx_ecc_data_in_r <= 0;	
		ch3_tx_ecc_data_in_r <= 0;
		ch4_tx_ecc_data_in_r <= 0;


	end 
	
	else 
	begin 
		ch0_tx_ecc_data_in_r <= ch0_tx_ecc_data_in;
		ch1_tx_ecc_data_in_r <= ch1_tx_ecc_data_in;
		ch2_tx_ecc_data_in_r <= ch2_tx_ecc_data_in;
		ch3_tx_ecc_data_in_r <= ch3_tx_ecc_data_in;
		ch4_tx_ecc_data_in_r <= ch4_tx_ecc_data_in;

	end 
end 

always @(posedge i_clk )
begin 
	if(p0_reset == 0)
	begin 

		ch5_tx_ecc_data_in_r <= 0;
		ch6_tx_ecc_data_in_r <= 0;
		ch7_tx_ecc_data_in_r <= 0;
		ch8_tx_ecc_data_in_r <= 0;
		ch9_tx_ecc_data_in_r <= 0;

	end 
	
	else 
	begin 

		ch5_tx_ecc_data_in_r <= ch5_tx_ecc_data_in;
		ch6_tx_ecc_data_in_r <= ch6_tx_ecc_data_in;
		ch7_tx_ecc_data_in_r <= ch7_tx_ecc_data_in;
		ch8_tx_ecc_data_in_r <= ch8_tx_ecc_data_in;
		ch9_tx_ecc_data_in_r <= ch9_tx_ecc_data_in;

	end 
end 

always @(posedge i_clk )
begin 
	if(p1_reset == 0)
	begin 

		//ch11_tx_ecc_data_in_r <= 0;
		ch12_tx_ecc_data_in_r <= 0;
		ch13_tx_ecc_data_in_r <= 0;
		ch14_tx_ecc_data_in_r <= 0;
		ch15_tx_ecc_data_in_r <= 0;
		ch16_tx_ecc_data_in_r <= 0;

	end 
	
	else 
	begin 

		ch12_tx_ecc_data_in_r <= ch12_tx_ecc_data_in;
		ch13_tx_ecc_data_in_r <= ch13_tx_ecc_data_in;
		ch14_tx_ecc_data_in_r <= ch14_tx_ecc_data_in;
		ch15_tx_ecc_data_in_r <= ch15_tx_ecc_data_in;
		ch16_tx_ecc_data_in_r <= ch16_tx_ecc_data_in;

	end 
end 

always @(posedge i_clk )
begin 
	if(p3_reset == 0)
	begin 
	
		ch17_tx_ecc_data_in_r <= 0;
		ch18_tx_ecc_data_in_r <= 0;
		ch19_tx_ecc_data_in_r <= 0;
		ch20_tx_ecc_data_in_r <= 0;
		ch21_tx_ecc_data_in_r <= 0;

	end 
	
	else 
	begin 
	
		ch17_tx_ecc_data_in_r <= ch17_tx_ecc_data_in;
		ch18_tx_ecc_data_in_r <= ch18_tx_ecc_data_in;
		ch19_tx_ecc_data_in_r <= ch19_tx_ecc_data_in;
		ch20_tx_ecc_data_in_r <= ch20_tx_ecc_data_in;
		ch21_tx_ecc_data_in_r <= ch21_tx_ecc_data_in;
		
	end 
end 


// Mux to select ECC input
assign  ch0_tx_ecc_data_in 	= (core4_0_enable_ecc_hwtcl ==1'b0) ? 70'd0 :	core_periphery__data_from_core_ch0 ;						
assign  ch1_tx_ecc_data_in 	= (core4_0_enable_ecc_hwtcl ==1'b0) ? 70'd0 :	core_periphery__data_from_core_ch1 ;						
assign  ch2_tx_ecc_data_in 	= (core4_0_enable_ecc_hwtcl ==1'b0) ? 70'd0 :	core_periphery__data_from_core_ch2 ;						
assign  ch3_tx_ecc_data_in 	= (core4_0_enable_ecc_hwtcl ==1'b0) ? 70'd0 :	core_periphery__data_from_core_ch3 ;						
assign  ch4_tx_ecc_data_in 	= (core4_0_enable_ecc_hwtcl ==1'b0) ? 70'd0 : 	core_periphery__data_from_core_ch4 ;	
assign  ch5_tx_ecc_data_in 	= (core4_0_enable_ecc_hwtcl ==1'b0) ? 70'd0 : 	core_periphery__data_from_core_ch5 ;	
assign  ch6_tx_ecc_data_in 	= (core4_0_enable_ecc_hwtcl ==1'b0) ? 70'd0 : 	core_periphery__data_from_core_ch6  ;
assign  ch7_tx_ecc_data_in 	= (core4_0_enable_ecc_hwtcl ==1'b0) ? 70'd0 : 	core_periphery__data_from_core_ch7 ;
assign  ch8_tx_ecc_data_in 	= (core4_0_enable_ecc_hwtcl ==1'b0) ? 70'd0 : 	core_periphery__data_from_core_ch8 ;	
assign  ch9_tx_ecc_data_in 	= (core4_0_enable_ecc_hwtcl ==1'b0) ? 70'd0 : 	core_periphery__data_from_core_ch9 ;
//assign  ch11_tx_ecc_data_in 	= (core4_0_enable_ecc_hwtcl ==1'b0) ? 70'd0 : 	core_periphery__data_from_core_ch11 ;
assign  ch12_tx_ecc_data_in 	= (core4_0_enable_ecc_hwtcl ==1'b0) ? 70'd0 : 	core_periphery__data_from_core_ch12  ;	
assign  ch13_tx_ecc_data_in 	= (core4_0_enable_ecc_hwtcl ==1'b0) ? 70'd0 :    core_periphery__data_from_core_ch13 ;	
assign  ch14_tx_ecc_data_in 	= (core4_0_enable_ecc_hwtcl ==1'b0) ? 70'd0 :    core_periphery__data_from_core_ch14 ;
assign  ch15_tx_ecc_data_in 	= (core4_0_enable_ecc_hwtcl ==1'b0) ? 70'd0 :    core_periphery__data_from_core_ch15 ;
assign  ch16_tx_ecc_data_in 	= (core4_0_enable_ecc_hwtcl ==1'b0) ? 70'd0 :    core_periphery__data_from_core_ch16 ;
assign  ch17_tx_ecc_data_in 	= (core4_0_enable_ecc_hwtcl ==1'b0) ? 70'd0 :    core_periphery__data_from_core_ch17 ;
assign  ch18_tx_ecc_data_in 	= (core4_0_enable_ecc_hwtcl ==1'b0) ? 70'd0 :    core_periphery__data_from_core_ch18 ;
assign  ch19_tx_ecc_data_in 	= (core4_0_enable_ecc_hwtcl ==1'b0) ? 70'd0 :    core_periphery__data_from_core_ch19 ;
assign  ch20_tx_ecc_data_in 	= (core4_0_enable_ecc_hwtcl ==1'b0) ? 70'd0 :    core_periphery__data_from_core_ch20 ;
assign  ch21_tx_ecc_data_in 	= (core4_0_enable_ecc_hwtcl ==1'b0) ? 70'd0 :    core_periphery__data_from_core_ch21 ;






assign i_rx_ecc_data	 =  (	
							{ 
							{ch21_tx_ecc_data_in_r},
							{ch20_tx_ecc_data_in_r},
							{ch19_tx_ecc_data_in_r},
							{ch18_tx_ecc_data_in_r}, 
							{ch17_tx_ecc_data_in_r},
							{ch16_tx_ecc_data_in_r}, 
							{ch15_tx_ecc_data_in_r}, 
							{ch14_tx_ecc_data_in_r},
							{ch13_tx_ecc_data_in_r},  
							{ch12_tx_ecc_data_in_r}, 
							{ch9_tx_ecc_data_in_r},
							{ch8_tx_ecc_data_in_r},
							{ch7_tx_ecc_data_in_r}, 
							{ch6_tx_ecc_data_in_r},
							{ch5_tx_ecc_data_in_r}, 
							{ch4_tx_ecc_data_in_r}, 
							{ch3_tx_ecc_data_in_r},
							{ch2_tx_ecc_data_in_r},
							{ch1_tx_ecc_data_in_r},
							{ch0_tx_ecc_data_in_r}}   
						);


//ecc module instantaition
for(ww=0; ww<NUM_CHAN; ww++) begin:ecc_module_instantiation
				
		assign  data_in[ww] = i_rx_ecc_data[ww*AIB_WIDTH+:AIB_WIDTH]	;	
		
				wrlib_ecc_dec_c78_d70 inst_rx_ecc (

				   .o_int_sec 		(o_int_sec[ww]),
				   .o_int_ded		(o_int_ded[ww]),
				   .o_syndrome		(o_syndrome[ww]),
				   .i_code			(data_in[ww]),
				   .o_data			(data_out[ww])

				);
			
		assign o_rx_ecc_data[ww*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] = data_out[ww];
		
end:ecc_module_instantiation

//Adding mux to accomodate Bypass mode, 0 latency and 1 latency in ECC
									
assign  ch0_tx_ecc_data_out    = (core4_0_enable_ecc_hwtcl ==1'b0) ? {p2_tx_st_data_par_s0_i[7:0], core_periphery__data_from_core_ch0} 		    : 	o_rx_ecc_data[0*ECC_OUT_WIDTH+:ECC_OUT_WIDTH]	    ;  //ch0_tx_ecc_data_in							
assign  ch1_tx_ecc_data_out    = (core4_0_enable_ecc_hwtcl ==1'b0) ? {p2_tx_st_data_par_s0_i[15:8], core_periphery__data_from_core_ch1} 		: 	o_rx_ecc_data[1*ECC_OUT_WIDTH+:ECC_OUT_WIDTH]	    ;  //ch1_tx_ecc_data_in								
assign  ch2_tx_ecc_data_out    = (core4_0_enable_ecc_hwtcl ==1'b0) ? {p2_tx_st_hdr_par_s0_i[7:0], core_periphery__data_from_core_ch2}   		: 	o_rx_ecc_data[2*ECC_OUT_WIDTH+:ECC_OUT_WIDTH]	    ;  //ch2_tx_ecc_data_in									
assign  ch3_tx_ecc_data_out    = (core4_0_enable_ecc_hwtcl ==1'b0) ? {p2_tx_st_hdr_par_s0_i[15:8], core_periphery__data_from_core_ch3} 		    : 	o_rx_ecc_data[3*ECC_OUT_WIDTH+:ECC_OUT_WIDTH]	    ;  //ch3_tx_ecc_data_in									
assign  ch4_tx_ecc_data_out    = (core4_0_enable_ecc_hwtcl ==1'b0) ? {4'b0000, p2_tx_st_tlp_prfx_par_s0_i, core_periphery__data_from_core_ch4} 	: 	o_rx_ecc_data[4*ECC_OUT_WIDTH+:ECC_OUT_WIDTH]	    ;  //ch4_tx_ecc_data_in									
assign  ch5_tx_ecc_data_out    = (core4_0_enable_ecc_hwtcl ==1'b0) ? {p0_tx_st_tlp_prfx_par_s0_i, 4'b0000, core_periphery__data_from_core_ch5} 	: 	o_rx_ecc_data[5*ECC_OUT_WIDTH+:ECC_OUT_WIDTH]	    ;  //ch5_tx_ecc_data_in									
assign  ch6_tx_ecc_data_out    = (core4_0_enable_ecc_hwtcl ==1'b0) ? {p0_tx_st_hdr_par_s0_i[7:0], core_periphery__data_from_core_ch6} 		    : 	o_rx_ecc_data[6*ECC_OUT_WIDTH+:ECC_OUT_WIDTH]	    ; //ch6_tx_ecc_data_in									
assign  ch7_tx_ecc_data_out    = (core4_0_enable_ecc_hwtcl ==1'b0) ? {p0_tx_st_hdr_par_s0_i[15:8], core_periphery__data_from_core_ch7}          : 	o_rx_ecc_data[7*ECC_OUT_WIDTH+:ECC_OUT_WIDTH]	    ; //ch7_tx_ecc_data_in									
assign  ch8_tx_ecc_data_out    = (core4_0_enable_ecc_hwtcl ==1'b0) ? {p0_tx_st_data_par_s0_i[23:16], core_periphery__data_from_core_ch8}        : 	o_rx_ecc_data[8*ECC_OUT_WIDTH+:ECC_OUT_WIDTH]	    ;   //ch8_tx_ecc_data_in									
assign  ch9_tx_ecc_data_out    = (core4_0_enable_ecc_hwtcl ==1'b0) ? {p0_tx_st_data_par_s0_i[31:24], core_periphery__data_from_core_ch9} 		: 	o_rx_ecc_data[9*ECC_OUT_WIDTH+:ECC_OUT_WIDTH]	    ;  //ch9_tx_ecc_data_in								
assign  ch12_tx_ecc_data_out   = (core4_0_enable_ecc_hwtcl ==1'b0) ? {p1_tx_st_data_par_s0_i[7:0], core_periphery__data_from_core_ch12} 	    : 	o_rx_ecc_data[10*ECC_OUT_WIDTH+:ECC_OUT_WIDTH]	;  //ch12_tx_ecc_data_in									
assign  ch13_tx_ecc_data_out   = (core4_0_enable_ecc_hwtcl ==1'b0) ? {p1_tx_st_data_par_s0_i[15:8], core_periphery__data_from_core_ch13}   		: 	o_rx_ecc_data[11*ECC_OUT_WIDTH+:ECC_OUT_WIDTH]	;  //ch13_tx_ecc_data_in									
assign  ch14_tx_ecc_data_out   = (core4_0_enable_ecc_hwtcl ==1'b0) ? {p1_tx_st_hdr_par_s0_i[7:0], core_periphery__data_from_core_ch14}  	   	: 	o_rx_ecc_data[12*ECC_OUT_WIDTH+:ECC_OUT_WIDTH]	; //ch14_tx_ecc_data_in									
assign  ch15_tx_ecc_data_out   = (core4_0_enable_ecc_hwtcl ==1'b0) ? {p1_tx_st_hdr_par_s0_i[15:8], core_periphery__data_from_core_ch15} 		:   o_rx_ecc_data[13*ECC_OUT_WIDTH+:ECC_OUT_WIDTH]	; //ch15_tx_ecc_data_in
assign  ch16_tx_ecc_data_out   = (core4_0_enable_ecc_hwtcl ==1'b0) ? {p1_tx_st_tlp_prfx_par_s0_i, 4'b0000, core_periphery__data_from_core_ch16} :   o_rx_ecc_data[14*ECC_OUT_WIDTH+:ECC_OUT_WIDTH]	; //ch16_tx_ecc_data_in
assign  ch17_tx_ecc_data_out   = (core4_0_enable_ecc_hwtcl ==1'b0) ? {p3_tx_st_data_par_s0_i[7:0], core_periphery__data_from_core_ch17} 		:   o_rx_ecc_data[15*ECC_OUT_WIDTH+:ECC_OUT_WIDTH]	; //ch17_tx_ecc_data_in
assign  ch18_tx_ecc_data_out   = (core4_0_enable_ecc_hwtcl ==1'b0) ? {p3_tx_st_data_par_s0_i[15:8], core_periphery__data_from_core_ch18} 		:   o_rx_ecc_data[16*ECC_OUT_WIDTH+:ECC_OUT_WIDTH]	; //ch18_tx_ecc_data_in
assign  ch19_tx_ecc_data_out   = (core4_0_enable_ecc_hwtcl ==1'b0) ? {p3_tx_st_hdr_par_s0_i[7:0], core_periphery__data_from_core_ch19} 		    :   o_rx_ecc_data[17*ECC_OUT_WIDTH+:ECC_OUT_WIDTH]	; //ch19_tx_ecc_data_in
assign  ch20_tx_ecc_data_out   = (core4_0_enable_ecc_hwtcl ==1'b0) ? {p3_tx_st_hdr_par_s0_i[15:8], core_periphery__data_from_core_ch20} 		:   o_rx_ecc_data[18*ECC_OUT_WIDTH+:ECC_OUT_WIDTH]	; //ch20_tx_ecc_data_in
assign  ch21_tx_ecc_data_out   = (core4_0_enable_ecc_hwtcl ==1'b0) ? {4'b0000, p3_tx_st_tlp_prfx_par_s0_i, core_periphery__data_from_core_ch21} :   o_rx_ecc_data[19*ECC_OUT_WIDTH+:ECC_OUT_WIDTH]	; //ch21_tx_ecc_data_in
		
	end
	endgenerate  
	
	
endmodule
