// (C) 2001-2020 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


//`define ENABLE_DDR4A
//`define ENABLE_DDR4B
//`define ENABLE_DDR4C
//`define ENABLE_DDR4D
//`define ENABLE_PCIE
`define ENABLE_QSFPDDA
//`define ENABLE_QSFPDDB
//`define ENABLE_QSFPRSV_REFCLK
//`define ENABLE_DDR4_DUAL_RANK

//`define USE_CH_4567 // ch 0/1/2/3 is used if not defied



`timescale 1 ps / 1 ps
module alt_ehipc3_fm_hw
   #(
`ifdef ENABLE_DDR4_DUAL_RANK
      parameter RANK = 1
`else
      parameter RANK = 0
`endif
   )
   (

      ///////// CLOCK /////////
      input              CLK_100_B2A,
      input              CLK_50_B2C,
      input              CLK_50_B3A,
      input              CLK_50_B3C,
      input              UFL_CLKIN_p,
      input              CLK_30M72, //reserved for future use

      ///////// Buttons /////////
      input              CPU_RESET_n,
      input    [ 1: 0]   BUTTON, //BUTTON is Low-Active

      ///////// Swtiches /////////
      input    [ 1: 0]   SW,

      ///////// LED /////////
      output   [ 3: 0]   LED_BRACKET, //LED is Low-Active
      output   [ 3: 0]   LED, //LED is Low-Active

`ifdef ENABLE_QSFPRSV_REFCLK
      ///////// QSFPRSV_REFCLK /////////
      input              QSFPDDRSV_REFCLK_p,
`endif /*ENABLE_QSFPRSV_REFCLK*/

`ifdef ENABLE_DDR4A
      ///////// DDR4A /////////
      input              DDR4A_REFCLK_p,
      output   [16: 0]   DDR4A_A,
      output   [ 1: 0]   DDR4A_BA,
      output   [ 1: 0]   DDR4A_BG,
      output   [RANK: 0] DDR4A_CK,
      output   [RANK: 0] DDR4A_CK_n,
      output   [RANK: 0] DDR4A_CKE,
      inout    [ 8: 0]   DDR4A_DQS,
      inout    [ 8: 0]   DDR4A_DQS_n,
      inout    [71: 0]   DDR4A_DQ,
      inout    [ 8: 0]   DDR4A_DBI_n,
      output   [RANK: 0] DDR4A_CS_n,
      output             DDR4A_RESET_n,
      output   [RANK: 0] DDR4A_ODT,
      output             DDR4A_PAR,
      input              DDR4A_ALERT_n,
      output             DDR4A_ACT_n,
      input              DDR4A_EVENT_n,
      inout              DDR4A_SCL,
      inout              DDR4A_SDA,
      input              DDR4A_RZQ,
`endif /*ENABLE_DDR4A*/

`ifdef ENABLE_DDR4B
      ///////// DDR4B /////////
      input              DDR4B_REFCLK_p,
      output   [16: 0]   DDR4B_A,
      output   [ 1: 0]   DDR4B_BA,
      output   [ 1: 0]   DDR4B_BG,
      output   [RANK: 0] DDR4B_CK,
      output   [RANK: 0] DDR4B_CK_n,
      output   [RANK: 0] DDR4B_CKE,
      inout    [ 8: 0]   DDR4B_DQS,
      inout    [ 8: 0]   DDR4B_DQS_n,
      inout    [71: 0]   DDR4B_DQ,
      inout    [ 8: 0]   DDR4B_DBI_n,
      output   [RANK: 0] DDR4B_CS_n,
      output             DDR4B_RESET_n,
      output   [RANK: 0] DDR4B_ODT,
      output             DDR4B_PAR,
      input              DDR4B_ALERT_n,
      output             DDR4B_ACT_n,
      input              DDR4B_EVENT_n,
      inout              DDR4B_SCL,
      inout              DDR4B_SDA,
      input              DDR4B_RZQ,
`endif /*ENABLE_DDR4B*/

`ifdef ENABLE_DDR4C
      ///////// DDR4C /////////
      input              DDR4C_REFCLK_p,
      output   [16: 0]   DDR4C_A,
      output   [ 1: 0]   DDR4C_BA,
      output   [ 1: 0]   DDR4C_BG,
      output   [RANK: 0] DDR4C_CK,
      output   [RANK: 0] DDR4C_CK_n,
      output   [RANK: 0] DDR4C_CKE,
      inout    [ 8: 0]   DDR4C_DQS,
      inout    [ 8: 0]   DDR4C_DQS_n,
      inout    [71: 0]   DDR4C_DQ,
      inout    [ 8: 0]   DDR4C_DBI_n,
      output   [RANK: 0] DDR4C_CS_n,
      output             DDR4C_RESET_n,
      output   [RANK: 0] DDR4C_ODT,
      output             DDR4C_PAR,
      input              DDR4C_ALERT_n,
      output             DDR4C_ACT_n,
      input              DDR4C_EVENT_n,
      inout              DDR4C_SCL,
      inout              DDR4C_SDA,
      input              DDR4C_RZQ,
`endif /*ENABLE_DDR4C*/

`ifdef ENABLE_DDR4D
      ///////// DDR4D /////////
      input              DDR4D_REFCLK_p,
      output   [16: 0]   DDR4D_A,
      output   [ 1: 0]   DDR4D_BA,
      output   [ 1: 0]   DDR4D_BG,
      output   [RANK: 0] DDR4D_CK,
      output   [RANK: 0] DDR4D_CK_n,
      output   [RANK: 0] DDR4D_CKE,
      inout    [ 8: 0]   DDR4D_DQS,
      inout    [ 8: 0]   DDR4D_DQS_n,
      inout    [71: 0]   DDR4D_DQ,
      inout    [ 8: 0]   DDR4D_DBI_n,
      output   [RANK: 0] DDR4D_CS_n,
      output             DDR4D_RESET_n,
      output   [RANK: 0] DDR4D_ODT,
      output             DDR4D_PAR,
      input              DDR4D_ALERT_n,
      output             DDR4D_ACT_n,
      input              DDR4D_EVENT_n,
      inout              DDR4D_SCL,
      inout              DDR4D_SDA,
      input              DDR4D_RZQ,
`endif /*ENABLE_DDR4D*/

      ///////// SI5340A /////////
      inout              SI5340A_I2C_SCL,
      inout              SI5340A_I2C_SDA,
      input              SI5340A_LOL,
      input              SI5340A_LOS_XAXB,
      output             SI5340A_OE_n,
      output             SI5340A_RST_n,

      ///////// GPIO /////////
      input    [ 1: 0]   GPIO_CLK,
      inout    [ 3: 0]   GPIO_p,

`ifdef ENABLE_PCIE
      ///////// PCIE /////////
      inout              PCIE_SMBCLK,
      inout              PCIE_SMBDAT,
      output   [15: 0]   PCIE_TX_p,
      output   [15: 0]   PCIE_TX_n,
      input    [15: 0]   PCIE_RX_p,
      input    [15: 0]   PCIE_RX_n,
      input    [ 1: 0]   PCIE_REFCLK_p,
      input              PCIE_PERST_n,
`endif /*ENABLE_PCIE*/


`ifdef ENABLE_QSFPDDA
      ///////// QSFPDDA /////////
`ifdef USE_CH_4567		
      output   [ 7: 4]   QSFPDDA_TX_p,
      //output   [ 7: 4]   QSFPDDA_TX_n,
      input    [ 7: 4]   QSFPDDA_RX_p,
      //input    [ 7: 4]   QSFPDDA_RX_n,
`else
      output   [ 3: 0]   QSFPDDA_TX_p,
      //output   [ 3: 0]   QSFPDDA_TX_n,
      input    [ 3: 0]   QSFPDDA_RX_p,
      //input    [ 3: 0]   QSFPDDA_RX_n,
`endif /*LOW_QSFPDD*/		
      input              QSFPDDA_REFCLK_p,
      output             QSFPDDA_INITMODE,
      input              QSFPDDA_INTERRUPT_n,
      input              QSFPDDA_MOD_PRS_n,
      output             QSFPDDA_MOD_SEL_n,
      output             QSFPDDA_RST_n,
      inout              QSFPDDA_SCL,
      inout              QSFPDDA_SDA,
`else
      input              QSFPDDA_REFCLK_p,
`endif /*ENABLE_QSFPDDA*/

`ifdef ENABLE_QSFPDDB
      ///////// QSFPDDB /////////
`ifdef USE_CH_4567		
      output   [ 7: 4]   QSFPDDB_TX_p,
      //output   [ 7: 4]   QSFPDDB_TX_n,
      input    [ 7: 4]   QSFPDDB_RX_p,
      //input    [ 7: 4]   QSFPDDB_RX_n,
`else		
      output   [ 3: 0]   QSFPDDB_TX_p,
      //output   [ 3: 0]   QSFPDDB_TX_n,
      input    [ 3: 0]   QSFPDDB_RX_p,
      //input    [ 3: 0]   QSFPDDB_RX_n,
`endif /*LOW_QSFPDD*/			
      input              QSFPDDB_REFCLK_p,
      output             QSFPDDB_INITMODE,
      input              QSFPDDB_INTERRUPT_n,
      input              QSFPDDB_MOD_PRS_n,
      output             QSFPDDB_MOD_SEL_n,
      output             QSFPDDB_RST_n,
      inout              QSFPDDB_SCL,
      inout              QSFPDDB_SDA,
`endif /*ENABLE_QSFPDDB*/

      ///////// AG /////////
      output             AG_UART_TX,
      input              AG_UART_RX,
      input              AG_UART_CTS,
      output             AG_UART_RTS,

      ///////// EXP /////////
      input              EXP_EN,

      ///////// INFO /////////
      output             INFO_SPI_SCLK,
      input              INFO_SPI_MISO,
      output             INFO_SPI_MOSI,
      output             INFO_SPI_CS_n,

      ///////// QSPI /////////
      output             QSPI_CLK,
      inout    [ 3: 0]   QSPI_DATA,
      output             QSPI_NCSO 


);



/*
module alt_ehipc3_fm_hw (
    input clk100,
    //input cpu_resetn,

    // QSFP
    output wire  qsfp_lowpwr,   // LPMode
    output wire  qsfp_rstn,     // ResetL

    // 25G IO
    input wire i_clk_ref,
    input wire [3:0] i_rx_serial,
    output wire [3:0] o_tx_serial,
    output wire [9:0]             user_io,
    output wire [3:0]             user_led,
    input  wire                   refclk_bti0
); */



//////////////////////////////////////
// pin assignment

wire 			clk100;

wire 			qsfp_lowpwr;
wire 			qsfp_rstn;
wire        qsfp_mod_sel_n;

wire 			i_clk_ref;
wire [3:0]  o_tx_serial;
wire [3:0]  i_rx_serial;
wire 			tx_serial_data;
wire [3:0]  user_led;

assign clk100 = CLK_100_B2A;
assign LED = user_led;

`ifdef ENABLE_QSFPDDA
	assign i_clk_ref = QSFPDDA_REFCLK_p;
	assign QSFPDDA_RST_n = qsfp_rstn;
	assign QSFPDDA_INITMODE = qsfp_lowpwr;
	assign QSFPDDA_MOD_SEL_n = qsfp_mod_sel_n;
	assign QSFPDDA_TX_p = {o_tx_serial[3],o_tx_serial[1],o_tx_serial[2],o_tx_serial[0]};   // swap xcvr channel
	assign {i_rx_serial[3],i_rx_serial[1],i_rx_serial[2],i_rx_serial[0]} = QSFPDDA_RX_p;   // swap xcvr channel
`endif // ENABLE_QSFP28A  

`ifdef ENABLE_QSFPDDB
	assign i_clk_ref = QSFPDDB_REFCLK_p;
	assign QSFPDDB_RST_n = qsfp_rstn;
	assign QSFPDDB_INITMODE = qsfp_lowpwr;
	assign QSFPDDB_MOD_SEL_n = qsfp_mod_sel_n;
	assign QSFPDDB_TX_p = {o_tx_serial[3],o_tx_serial[1],o_tx_serial[2],o_tx_serial[0]};   // swap xcvr channel
	assign {i_rx_serial[3],i_rx_serial[1],i_rx_serial[2],i_rx_serial[0]} = QSFPDDB_RX_p;   // swap xcvr channel
`endif // ENABLE_QSFP28B  



//=======================================================
//  Enable SI5340A. use default setting
//=======================================================
wire por_reset;

power_on_reset power_on_reset_inst(
	.clk(CLK_50_B2C),
	.reset(por_reset)
);


assign SI5340A_RST_n = 1'b1;
assign SI5340A_OE_n = 1'b0;


//////////////////////////////////////

    assign qsfp_rstn   = CPU_RESET_n;//1'b1;
    assign qsfp_lowpwr = SW[0];//1'b0; // 1(SW UP): low power, 0(SW DOWN): not low power
    assign qsfp_mod_sel_n = SW[1]; // 0: enable i2c
    assign user_led    = {SW, ~CPU_RESET_n, CPU_RESET_n};//4'b0;


    localparam DEVICE_FAMILY = "Agilex";
    localparam WORDS = 8;
    localparam WIDTH = 64;
    localparam SOP_ON_LANE0 = 1'b1;
    localparam SIM_NO_TEMP_SENSE = 1'b0;


    /////////////////////////
    // dev_clr sync-reset
    /////////////////////////
    //clk100=i_reconfig_clk
    //wire user_mode_sync;
    wire arst, iopll_locked, clk100;
    //alt_aeuex_user_mode_det dev_clr( .ref_clk(clk100), .user_mode_sync(user_mode_sync));

    wire source_reset;




 //Instantiate S10 IP reset:

      wire ninit_done ;
      reset_ip reset (
	.ninit_done (ninit_done)
	  );

      // Reset delay will start counting after ninit_done, and will keep
      // arst asserted until it finishes
      wire rd1_ready;
      alt_reset_delay rd1 (
          .clk(clk100),
          .ready_in(~ninit_done),
          .ready_out(rd1_ready)
      );
      defparam rd1.CNTR_BITS = 16;
	  
	  
// ARST conditional upon ninit_done from S10 IP reset. Ninit_done is active low. ninit_done=0 => s10 is good to go	  
    //assign arst = ~user_mode_sync | ~iopll_locked | source_reset | ninit_done ;
    
    assign arst = ~rd1_ready | ~iopll_locked | source_reset ;

    wire [20:0] i_eth_reconfig_addr;
    wire [10:0] i_rsfec_reconfig_addr;
    wire [31:0] o_eth_reconfig_readdata;
    wire [7:0] o_rsfec_reconfig_readdata;
    wire        i_eth_reconfig_read, i_eth_reconfig_write,o_eth_reconfig_readdata_valid;
    wire        i_rsfec_reconfig_read, i_rsfec_reconfig_write,o_rsfec_reconfig_readdata_valid;


    wire [31:0] i_eth_reconfig_writedata;
    wire [7:0] i_rsfec_reconfig_writedata;
    wire [31:0] i_xcvr_reconfig_writedata;

    wire        i_reconfig_clk = clk100;
    wire        o_clk_pll_div64;

    wire [15:0] khz_clk_rx_rs;
    wire [15:0] khz_clk_tx_rs;
    wire [15:0]   khz_rx_clk_i;
    wire [15:0]   khz_tx_clk_i;
    wire clk_rx_rs;
    wire clk_tx_rs;

    // input domain (from user logic toward pins)
    wire                   clk_din = o_clk_pll_div64;
    wire [WORDS*WIDTH-1:0] din;               // payload to send, left to right
    wire       [WORDS-1:0] din_start;         // start pos, first of every 8 bytes
    wire     [WORDS*8-1:0] din_end_pos;       // end position, any byte
    wire                   din_ack;           // payload is accepted

    // output domain (from pins toward user logic)
    wire                   clk_dout = o_clk_pll_div64;

    wire    [WORDS*64-1:0] dout_d;            // 5 word out stream, left to right
    wire       [WORDS-1:0] dout_first_data;
    wire     [WORDS*8-1:0] dout_last_data;
    wire                   dout_valid;

    wire    [5:0]   i_tx_empty;
    wire    [511:0]    i_tx_data;
    wire                       i_tx_endofpacket;
    wire                       o_tx_ready;
    wire                       i_tx_startofpacket;
    wire                       i_tx_valid;
    wire    [511:0]    o_rx_data;
    wire    [5:0]   o_rx_empty;
    wire                       o_rx_endofpacket;
    wire                       o_rx_startofpacket;
    wire                       o_rx_valid;
    wire    [5:0]   o_rx_error;

    //--- functions
        `include "common/alt_aeuex_wide_l8if_functions.iv"
    assign i_tx_data          = din;
    //assign i_tx_valid         = 1'b1;
    assign din_ack            = o_tx_ready;
    assign dout_d             = o_rx_data;
    assign dout_valid         = o_rx_valid;
    assign dout_first_data    = {o_rx_startofpacket, {WORDS-1{1'b0}}};
    assign dout_last_data     = o_rx_endofpacket ? alt_aeuex_wide_decode6to64(o_rx_empty) : 64'h0;


/*
    alt_ehipc3_fm_sys_pll u0 (
        .rst        (~cpu_resetn),  // reset.reset
        .refclk     (clk50),        // refclk.clk
        .locked     (iopll_locked), // locked.export
        .outclk_0   (clk100)        // outclk0.clk
    );
*/
    assign iopll_locked = 1'b1;

    wire                 status_read;
    wire                 status_write;
    wire                 status_waitrequest;
    wire                 status_readdata_valid;
    wire     [31:0]      status_readdata;
    wire     [31:0]      status_writedata;
    wire     [23:0]      status_addr;

    wire                 status_read_r = status_read;
    wire                 status_write_r = status_write;
    wire     [31:0]      status_writedata_r = status_writedata;
    wire     [23:0]      status_addr_r = status_addr;
    wire                select_waitrequest;
    wire [3:0]   o_xcvr_reconfig_waitrequest;
    wire         o_eth_reconfig_waitrequest;
    wire         o_rsfec_reconfig_waitrequest;
    wire [31:0]  o_xcvr_reconfig_readdata;

    wire [31:0] status_readdata_pc;
    wire status_readdata_valid_pc;


    assign select_waitrequest = ((status_addr_r >= 24'h1_00000) && (status_addr_r <= 24'h1_FFFFF)) ? o_xcvr_reconfig_waitrequest[0] :
        ((status_addr_r >= 24'h2_00000) && (status_addr_r <= 24'h2_FFFFF)) ? o_xcvr_reconfig_waitrequest[1] :
        ((status_addr_r >= 24'h3_00000) && (status_addr_r <= 24'h3_FFFFF)) ? o_xcvr_reconfig_waitrequest[2] :
        ((status_addr_r >= 24'h4_00000) && (status_addr_r <= 24'h4_FFFFF)) ? o_xcvr_reconfig_waitrequest[3] :
        ((status_addr_r >= 24'h0_10000) && (status_addr_r <= 24'h0_107FF)) ? o_rsfec_reconfig_waitrequest :
        ((status_addr_r >= 24'h0_00000) && (status_addr_r <= 24'h0_00FFF)) ? o_eth_reconfig_waitrequest :
        1'b0;

    assign status_waitrequest = select_waitrequest;

//Decoding for avmm address map registers
    wire [3:0]   xcvr_reconfig_readdata_valid;
    wire [3:0]   i_xcvr_reconfig_read;
    wire [3:0]   i_xcvr_reconfig_write;
    wire [75:0]  i_xcvr_reconfig_address;

    assign status_readdata_valid = status_readdata_valid_pc | o_eth_reconfig_readdata_valid | o_rsfec_reconfig_readdata_valid | (|xcvr_reconfig_readdata_valid[3:0]);

//Reconfig Decoding XCVR 0
    wire    xcvr0_cs    = ((status_addr_r >= 24'h1_00000) && (status_addr_r <= 24'h1_FFFFF));
    wire    xcvr0_read = status_read_r && xcvr0_cs;
    wire    xcvr0_write = status_write_r && xcvr0_cs;
    assign i_xcvr_reconfig_address[18:0]   = (xcvr0_read || xcvr0_write) ? status_addr_r[18:0] : 18'b0;
    assign xcvr_reconfig_readdata_valid[0] = xcvr0_read && !o_xcvr_reconfig_waitrequest[0];
//Reconfig Decoding XCVR 1
    wire    xcvr1_cs    = ((status_addr_r >= 24'h2_00000) && (status_addr_r <= 24'h2_FFFFF));
    wire    xcvr1_read = status_read_r && xcvr1_cs;
    wire    xcvr1_write = status_write_r && xcvr1_cs;
    assign i_xcvr_reconfig_address[37:19]  = (xcvr1_read || xcvr1_write) ? status_addr_r[18:0] : 18'b0;
    assign xcvr_reconfig_readdata_valid[1] = xcvr1_read  && !o_xcvr_reconfig_waitrequest[1];

    //Reconfig Decoding XCVR 2
    wire    xcvr2_cs    = ((status_addr_r >= 24'h3_00000) && (status_addr_r <= 24'h3_FFFFF));
    wire    xcvr2_read = status_read_r && xcvr2_cs;
    wire    xcvr2_write = status_write_r && xcvr2_cs;
    assign i_xcvr_reconfig_address[56:38]  = (xcvr2_read || xcvr2_write) ? status_addr_r[18:0] : 18'b0;
    assign xcvr_reconfig_readdata_valid[2] = xcvr2_read  && !o_xcvr_reconfig_waitrequest[2];
    //Reconfig Decoding XCVR 3
    wire    xcvr3_cs    = ((status_addr_r >= 24'h4_00000) && (status_addr_r <= 24'h4_FFFFF));
    wire    xcvr3_read = status_read_r && xcvr3_cs;
    wire    xcvr3_write = status_write_r && xcvr3_cs;
    assign i_xcvr_reconfig_address[75:57]  = (xcvr3_read ||xcvr3_write) ? status_addr_r[18:0] : 18'b0;
    assign xcvr_reconfig_readdata_valid[3] = xcvr3_read && !o_xcvr_reconfig_waitrequest[3];

    //Reconfig Decoding Eth
    wire    eth_cs    = ((status_addr_r >= 24'h0_00000) && (status_addr_r <= 24'h0_00FFF));
    wire    eth_read = status_read_r && eth_cs;
    wire    eth_write = status_write_r && eth_cs;
    assign i_eth_reconfig_addr = (eth_read|| eth_write) ? status_addr_r[20:0] : 21'b0;

    //Reconfig Decoding RSFEC
    wire    rsfec_cs    = ((status_addr_r >= 24'h0_10000) && (status_addr_r <= 24'h0_107FF));
    wire    rsfec_read = status_read_r && rsfec_cs;
    wire    rsfec_write = status_write_r && rsfec_cs;
    assign i_rsfec_reconfig_addr           = (rsfec_read|| rsfec_write) ? status_addr_r[10:0] : 11'b0;
    assign o_rsfec_reconfig_readdata_valid = rsfec_read && !o_rsfec_reconfig_waitrequest;
    assign i_eth_reconfig_writedata   = status_writedata_r;
    assign i_rsfec_reconfig_writedata = status_writedata_r[7:0];
    assign i_xcvr_reconfig_writedata  = {4{status_writedata_r[7:0]}};

    wire [39:0] o_rxstatus_data;
    wire [7:0] o_rx_pfc;
    wire [7:0] i_tx_pfc;
    wire i_stats_snapshot;
    assign i_stats_snapshot       = 1'b0;
    assign i_xcvr_reconfig_read   = {xcvr3_read,xcvr2_read,xcvr1_read,xcvr0_read};
    assign i_xcvr_reconfig_write  = {xcvr3_write,xcvr2_write,xcvr1_write,xcvr0_write};
    assign i_eth_reconfig_read    = eth_read;
    assign i_eth_reconfig_write   = eth_write;
    assign i_rsfec_reconfig_read  = rsfec_read;
    assign i_rsfec_reconfig_write = rsfec_write;

    assign status_readdata =
        status_readdata_valid_pc        ?  status_readdata_pc[31:0] :
        o_eth_reconfig_readdata_valid   ?  o_eth_reconfig_readdata  :
        o_rsfec_reconfig_readdata_valid ?  {24'b0, o_rsfec_reconfig_readdata}  :
        xcvr_reconfig_readdata_valid[0] ?  {24'b0, o_xcvr_reconfig_readdata[7:0]} :
        xcvr_reconfig_readdata_valid[1] ?  {24'b0, o_xcvr_reconfig_readdata[15:8]} :
        xcvr_reconfig_readdata_valid[2] ?  {24'b0, o_xcvr_reconfig_readdata[23:16]} :
        xcvr_reconfig_readdata_valid[3] ?  {24'b0, o_xcvr_reconfig_readdata[31:24]} : 32'hdead_c0de;

/*** to merge all avmm interface to one source  -- end ***/





    ex_100G av_top (


                .i_stats_snapshot(i_stats_snapshot),

                .o_cdr_lock(o_cdr_lock),

                .o_tx_pll_locked(o_tx_pll_locked),

                .i_eth_reconfig_addr(i_eth_reconfig_addr),

                .i_eth_reconfig_read(i_eth_reconfig_read),

                .i_eth_reconfig_write(i_eth_reconfig_write),

                .o_eth_reconfig_readdata(o_eth_reconfig_readdata),

                .o_eth_reconfig_readdata_valid(o_eth_reconfig_readdata_valid),

                .i_eth_reconfig_writedata(i_eth_reconfig_writedata),

                .o_eth_reconfig_waitrequest(o_eth_reconfig_waitrequest),

                .i_rsfec_reconfig_addr(i_rsfec_reconfig_addr),

                .i_rsfec_reconfig_read(i_rsfec_reconfig_read),

                .i_rsfec_reconfig_write(i_rsfec_reconfig_write),

                .o_rsfec_reconfig_readdata(o_rsfec_reconfig_readdata),

                .i_rsfec_reconfig_writedata(i_rsfec_reconfig_writedata),

                .o_rsfec_reconfig_waitrequest(o_rsfec_reconfig_waitrequest),

                .o_tx_lanes_stable(o_tx_lanes_stable),

                .o_rx_pcs_ready(o_rx_pcs_ready),

                .o_ehip_ready(o_ehip_ready),

                .o_rx_block_lock(o_rx_block_lock),

                .o_rx_am_lock(o_rx_am_lock),

                .o_rx_hi_ber(o_rx_hi_ber),

                .o_local_fault_status(o_local_fault_status),

                .o_remote_fault_status(o_remote_fault_status),

                .i_clk_ref(i_clk_ref),

                .i_clk_tx(o_clk_pll_div64),

                .i_clk_rx(o_clk_pll_div64),

                .o_clk_pll_div64(o_clk_pll_div64),

                .o_clk_pll_div66(o_clk_pll_div66),

                .o_clk_rec_div64(o_clk_rec_div64),

                .o_clk_rec_div66(o_clk_rec_div66),

                .i_csr_rst_n(~arst),

                .i_tx_rst_n(1'b1),

                .i_rx_rst_n(1'b1),

                .o_tx_serial(o_tx_serial),

                .i_rx_serial(i_rx_serial),

                .o_tx_serial_n(o_tx_serial_n),

                .i_rx_serial_n(i_rx_serial_n),

                .i_reconfig_clk(i_reconfig_clk),

                .i_reconfig_reset(arst),

                .i_xcvr_reconfig_address(i_xcvr_reconfig_address),

                .i_xcvr_reconfig_read(i_xcvr_reconfig_read),

                .i_xcvr_reconfig_write(i_xcvr_reconfig_write),

                .o_xcvr_reconfig_readdata(o_xcvr_reconfig_readdata),

                .i_xcvr_reconfig_writedata(i_xcvr_reconfig_writedata),

                .o_xcvr_reconfig_waitrequest(o_xcvr_reconfig_waitrequest),

                .o_tx_ready(o_tx_ready),

                .i_tx_valid(i_tx_valid),

                .i_tx_data(i_tx_data),

                .i_tx_error(i_tx_error),

                .i_tx_startofpacket(i_tx_startofpacket),

                .i_tx_endofpacket(i_tx_endofpacket),

                .i_tx_empty(i_tx_empty),

                .i_tx_skip_crc(i_tx_skip_crc),

                .o_rx_valid(o_rx_valid),

                .o_rx_data(o_rx_data),

                .o_rx_startofpacket(o_rx_startofpacket),

                .o_rx_endofpacket(o_rx_endofpacket),

                .o_rx_empty(o_rx_empty),

                .o_rx_error(o_rx_error),

                .o_rxstatus_data(o_rxstatus_data),

                .o_rxstatus_valid(o_rxstatus_valid),

                .i_tx_pfc(i_tx_pfc),

                .o_rx_pfc(o_rx_pfc),

                .i_tx_pause(i_tx_pause),

                .o_rx_pause(o_rx_pause)
    );



    // _____________________________________________________________
    // generate and check some simple data transfers
    // _____________________________________________________________
    alt_e100s10_packet_client pc (
        .i_arst                         (arst),

        // TX to Ethernet
        .i_clk_tx                       (clk_din),
        .i_tx_ready                     (o_tx_ready),
        .o_tx_valid                     (i_tx_valid),
        .o_tx_data                      (din),
        .o_tx_sop                       (i_tx_startofpacket),
        .o_tx_eop                       (i_tx_endofpacket),
        .o_tx_empty                     (i_tx_empty),
        // RX from Ethernet
        .i_clk_rx                       (clk_dout),
        .i_rx_sop                       (o_rx_startofpacket),
        .i_rx_eop                       (o_rx_endofpacket),
        .i_rx_empty                     (o_rx_empty),
        .i_rx_data                  	(o_rx_data),
        .i_rx_valid                 	(o_rx_valid),
        // status register bus
        .i_clk_status                   (i_reconfig_clk),
        .i_status_addr                  (status_addr[15:0]),
        .i_status_read              	(status_read & ~|status_addr[19:16]),
        .i_status_write             	(status_write & ~|status_addr[19:16]),
        .i_status_writedata             (status_writedata),
        .o_status_readdata              (status_readdata_pc),
        .o_status_readdata_valid        (status_readdata_valid_pc)
    );
    
    
    defparam pc.WORDS = WORDS;
    defparam pc.WIDTH = WIDTH;
    


    // _______________________________________________________________________________________________________________
    // jtag_avalon
    // _______________________________________________________________________________________________________________
    wire [31:0] av_addr;
    assign status_addr = av_addr[25:2];
    wire [3:0] byteenable;

    alt_ehipc3_fm_jtag_avalon jtag_master (
        .clk_clk                (i_reconfig_clk),

        .clk_reset_reset        (arst),
        .master_address         (av_addr),
        .master_readdata        (status_readdata),
        .master_read            (status_read),
        .master_write           (status_write),
        .master_writedata       (status_writedata),
        .master_waitrequest     (status_waitrequest),
        .master_readdatavalid   (status_readdata_valid),
        .master_byteenable      (byteenable),
        .master_reset_reset     ()
    );
    // ___________________________________________________________

    // Sources and probes instance

    reg [5:0] clk100_cnt           = 6'b0;
    reg       o_rx_startofpacketD  = 0;
    reg       o_rx_endofpacketD    = 0;
    reg        i_rx_endofpacketD   = 0;
    reg        i_tx_startofpacketD = 0;
    reg        i_tx_endofpacketD   = 0;
    reg        o_rx_errorD         = 0;











    wire [7:0] system_status;
    assign system_status[0] = arst;

    assign system_status[1] = 0;
    assign system_status[2] = 0;
    assign system_status[3] = 0;

    assign system_status[4] = 0;
    assign system_status[5] = 0;
    assign system_status[6] = 0;
//      assign system_status[7] = tx_pll_locked_01;

//    assign user_io[0]       = 0;
//    assign user_io[1]       = 0;
//    assign user_io[2]       = 0;
//    assign user_io[3]       = 0;
//    assign user_io[4]       = 0;
//    assign user_io[5]       = 0;
//    assign user_io[6]       = 0;
//    assign user_io[7]       = 0;
//    assign user_io[8]       = 0;
//    assign user_io[9]       = 0;


    probe8 prb (
        .source  (source_reset),
        .probe   (system_status)
    );
endmodule

