module seriallite4_dup (
		output wire         tx_avs_ready,                //                      tx_avs.ready
		input  wire [255:0] tx_avs_data,                 //                            .data
		input  wire [7:0]   tx_avs_channel,              //                            .channel
		input  wire         tx_avs_valid,                //                            .valid
		input  wire         tx_avs_startofpacket,        //                            .startofpacket
		input  wire         tx_avs_endofpacket,          //                            .endofpacket
		input  wire [4:0]   tx_avs_empty,                //                tx_avs_empty.export
		input  wire [3:0]   tx_num_valid_bytes_eob,      //      tx_num_valid_bytes_eob.export
		input  wire         tx_is_usr_cmd,               //               tx_is_usr_cmd.export
		output wire         tx_link_up,                  //                  tx_link_up.export
		input  wire         tx_link_reinit,              //              tx_link_reinit.export
		output wire [4:0]   tx_error,                    //                    tx_error.export
		input  wire         rx_avs_ready,                //                      rx_avs.ready
		output wire [255:0] rx_avs_data,                 //                            .data
		output wire [7:0]   rx_avs_channel,              //                            .channel
		output wire         rx_avs_valid,                //                            .valid
		output wire         rx_avs_startofpacket,        //                            .startofpacket
		output wire         rx_avs_endofpacket,          //                            .endofpacket
		output wire [4:0]   rx_avs_empty,                //                rx_avs_empty.export
		output wire [3:0]   rx_num_valid_bytes_eob,      //      rx_num_valid_bytes_eob.export
		output wire         rx_is_usr_cmd,               //               rx_is_usr_cmd.export
		output wire [10:0]  rx_error,                    //                    rx_error.export
		output wire         rx_link_up,                  //                  rx_link_up.export
		input  wire         rx_link_reinit,              //              rx_link_reinit.export
		output wire [3:0]   tx_serial_data_n,            //            tx_serial_data_n.tx_serial_data_n
		output wire [3:0]   phy_tx_lanes_stable,         //         phy_tx_lanes_stable.phy_tx_lanes_stable
		output wire [3:0]   tx_pll_locked,               //               tx_pll_locked.tx_pll_locked
		output wire [3:0]   phy_ehip_ready,              //              phy_ehip_ready.phy_ehip_ready
		output wire [3:0]   tx_serial_data,              //              tx_serial_data.tx_serial_data
		input  wire         xcvr_ref_clk,                //                xcvr_ref_clk.clk
		input  wire         reconfig_clk,                //                reconfig_clk.clk
		input  wire [3:0]   xcvr_reconfig_read,          //          xcvr_reconfig_read.xcvr_reconfig_read
		input  wire [3:0]   xcvr_reconfig_write,         //         xcvr_reconfig_write.xcvr_reconfig_write
		input  wire [75:0]  xcvr_reconfig_address,       //       xcvr_reconfig_address.xcvr_reconfig_address
		output wire [31:0]  xcvr_reconfig_readdata,      //      xcvr_reconfig_readdata.xcvr_reconfig_readdata
		output wire [3:0]   xcvr_reconfig_waitrequest,   //   xcvr_reconfig_waitrequest.xcvr_reconfig_waitrequest
		input  wire [31:0]  xcvr_reconfig_writedata,     //     xcvr_reconfig_writedata.xcvr_reconfig_writedata
		input  wire         rsfec_reconfig_read,         //         rsfec_reconfig_read.rsfec_reconfig_read
		input  wire         rsfec_reconfig_write,        //        rsfec_reconfig_write.rsfec_reconfig_write
		input  wire [10:0]  rsfec_reconfig_address,      //      rsfec_reconfig_address.rsfec_reconfig_address
		output wire [7:0]   rsfec_reconfig_readdata,     //     rsfec_reconfig_readdata.rsfec_reconfig_readdata
		output wire [0:0]   rsfec_reconfig_waitrequest,  //  rsfec_reconfig_waitrequest.rsfec_reconfig_waitrequest
		input  wire [7:0]   rsfec_reconfig_writedata,    //    rsfec_reconfig_writedata.rsfec_reconfig_writedata
		input  wire [0:0]   phy_reconfig_read,           //           phy_reconfig_read.phy_reconfig_read
		input  wire [0:0]   phy_reconfig_write,          //          phy_reconfig_write.phy_reconfig_write
		input  wire [20:0]  phy_reconfig_address,        //        phy_reconfig_address.phy_reconfig_address
		output wire [31:0]  phy_reconfig_readdata,       //       phy_reconfig_readdata.phy_reconfig_readdata
		output wire [0:0]   phy_reconfig_waitrequest,    //    phy_reconfig_waitrequest.phy_reconfig_waitrequest
		input  wire [31:0]  phy_reconfig_writedata,      //      phy_reconfig_writedata.phy_reconfig_writedata
		output wire [0:0]   phy_reconfig_readdata_valid, // phy_reconfig_readdata_valid.phy_reconfig_readdata_valid
		input  wire [3:0]   rx_serial_data_n,            //            rx_serial_data_n.rx_serial_data_n
		input  wire [3:0]   rx_serial_data,              //              rx_serial_data.rx_serial_data
		output wire [3:0]   rx_cdr_lock,                 //                 rx_cdr_lock.rx_cdr_lock
		output wire [3:0]   phy_rx_block_lock,           //           phy_rx_block_lock.phy_rx_block_lock
		output wire [3:0]   phy_rx_pcs_ready,            //            phy_rx_pcs_ready.phy_rx_pcs_ready
		output wire [3:0]   phy_rx_hi_ber,               //               phy_rx_hi_ber.phy_rx_hi_ber
		input  wire         reconfig_reset0,             //             reconfig_reset0.i_reconfig_reset,           XCVR reconfig reset
		input  wire         tx_pcs_fec_phy_reset_n,      //      tx_pcs_fec_phy_reset_n.i_tx_rst_n
		input  wire         rx_pcs_fec_phy_reset_n,      //      rx_pcs_fec_phy_reset_n.i_rx_rst_n
		output wire         rx_core_clkout,              //              rx_core_clkout.clk
		input  wire         rx_core_rst_n,               //               rx_core_rst_n.reset
		output wire         tx_core_clkout,              //              tx_core_clkout.clk
		input  wire         tx_core_rst_n                //               tx_core_rst_n.reset
	);
endmodule

