
namespace eval seriallite4_dup {
  proc get_design_libraries {} {
    set libraries [dict create]
    dict set libraries altera_common_sv_packages        1
    dict set libraries seriallite4_tx_mac_full_131      1
    dict set libraries seriallite4_rx_mac_131           1
    dict set libraries seriallite4_phy_adapter_pam4_131 1
    dict set libraries xcvrnphy_fme_310                 1
    dict set libraries alt_ehipc3_fm_2020               1
    dict set libraries seriallite4_phy_top_131          1
    dict set libraries seriallite4_131                  1
    dict set libraries seriallite4_dup                  1
    return $libraries
  }
  
  proc get_memory_files {QSYS_SIMDIR} {
    set memory_files [list]
    lappend memory_files "[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_310/sim/serdes.firmware.rom"]"
    return $memory_files
  }
  
  proc get_common_design_files {USER_DEFINED_COMPILE_OPTIONS USER_DEFINED_VERILOG_COMPILE_OPTIONS USER_DEFINED_VHDL_COMPILE_OPTIONS QSYS_SIMDIR} {
    set design_files [dict create]
    dict set design_files "altera_common_sv_packages::altera_xcvr_native_s10_functions_h" "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_310/sim/altera_xcvr_native_s10_functions_h.sv"]\"  -work altera_common_sv_packages"
    return $design_files
  }
  
  proc get_design_files {USER_DEFINED_COMPILE_OPTIONS USER_DEFINED_VERILOG_COMPILE_OPTIONS USER_DEFINED_VHDL_COMPILE_OPTIONS QSYS_SIMDIR} {
    set design_files [list]
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../seriallite4_tx_mac_full_131/sim/mentor/sl4_tx_cw_insrt.sv"]\" -L altera_common_sv_packages -work seriallite4_tx_mac_full_131"                       
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../seriallite4_tx_mac_full_131/sim/mentor/sl4_tx_mii_enc.sv"]\" -L altera_common_sv_packages -work seriallite4_tx_mac_full_131"                        
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../seriallite4_tx_mac_full_131/sim/mentor/sl4_tx_soft_bond.sv"]\" -L altera_common_sv_packages -work seriallite4_tx_mac_full_131"                      
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../seriallite4_tx_mac_full_131/sim/mentor/sl4_tx_sync_gb_fec_cntr.sv"]\" -L altera_common_sv_packages -work seriallite4_tx_mac_full_131"               
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../seriallite4_tx_mac_full_131/sim/mentor/sl4_tx_usrif.v"]\"  -work seriallite4_tx_mac_full_131"                                                           
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../seriallite4_tx_mac_full_131/sim/mentor/sl4_tx_usrif_ctrl.v"]\"  -work seriallite4_tx_mac_full_131"                                                      
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../seriallite4_tx_mac_full_131/sim/mentor/sl4_tx_crc32.sv"]\" -L altera_common_sv_packages -work seriallite4_tx_mac_full_131"                          
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../seriallite4_tx_mac_full_131/sim/mentor/sl4_crc32_dat64_dat_only_reg.v"]\"  -work seriallite4_tx_mac_full_131"                                           
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../seriallite4_tx_mac_full_131/sim/mentor/sl4_crc32_dat64_zer.v"]\"  -work seriallite4_tx_mac_full_131"                                                    
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../seriallite4_tx_mac_full_131/sim/mentor/sl4_tx_crc.sv"]\" -L altera_common_sv_packages -work seriallite4_tx_mac_full_131"                            
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../seriallite4_tx_mac_full_131/sim/mentor/sl4_tx_crc_buffer.sv"]\" -L altera_common_sv_packages -work seriallite4_tx_mac_full_131"                     
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../seriallite4_tx_mac_full_131/sim/mentor/seriallite4_tx_mac_full.sv"]\" -L altera_common_sv_packages -work seriallite4_tx_mac_full_131"               
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../seriallite4_tx_mac_full_131/sim/sl4_synchronizer.sv"]\" -L altera_common_sv_packages -work seriallite4_tx_mac_full_131"                             
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../seriallite4_tx_mac_full_131/sim/altera_std_synchronizer_nocut.v"]\"  -work seriallite4_tx_mac_full_131"                                                 
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../seriallite4_rx_mac_131/sim/mentor/seriallite4_rx_mac.sv"]\" -L altera_common_sv_packages -work seriallite4_rx_mac_131"                              
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../seriallite4_rx_mac_131/sim/mentor/sl4_rx_crc.sv"]\" -L altera_common_sv_packages -work seriallite4_rx_mac_131"                                      
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../seriallite4_rx_mac_131/sim/mentor/sl4_rx_crc32.sv"]\" -L altera_common_sv_packages -work seriallite4_rx_mac_131"                                    
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../seriallite4_rx_mac_131/sim/mentor/sl4_rx_crc_buffer.sv"]\" -L altera_common_sv_packages -work seriallite4_rx_mac_131"                               
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../seriallite4_rx_mac_131/sim/mentor/sl4_rx_cw_removal.v"]\"  -work seriallite4_rx_mac_131"                                                                
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../seriallite4_rx_mac_131/sim/mentor/sl4_rx_deskew.sv"]\" -L altera_common_sv_packages -work seriallite4_rx_mac_131"                                   
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../seriallite4_rx_mac_131/sim/mentor/sl4_rx_phy_decoder.v"]\"  -work seriallite4_rx_mac_131"                                                               
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../seriallite4_phy_adapter_pam4_131/sim/mentor/seriallite4_phy_adapter_pam4.sv"]\" -L altera_common_sv_packages -work seriallite4_phy_adapter_pam4_131"
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_310/sim/alt_xcvr_arbiter.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_310"                                                   
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_310/sim/mentor/alt_xcvr_arbiter.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_310"                                            
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_310/sim/altera_std_synchronizer_nocut.v"]\"  -work xcvrnphy_fme_310"                                                                       
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_310/sim/alt_xcvr_resync_std.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_310"                                                
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_310/sim/s10_avmm_h_etile.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_310"                                                   
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_310/sim/alt_xcvr_native_avmm_csr_etile.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_310"                                     
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_310/sim/alt_xcvr_native_rcfg_arb.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_310"                                           
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_310/sim/alt_xcvr_native_rx_reset_seq_etile.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_310"                                 
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_310/sim/alt_xcvr_native_tx_reset_seq_etile.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_310"                                 
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_310/sim/alt_xcvr_reset_counter_s10_etile.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_310"                                   
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_310/sim/altera_xcvr_reset_control_etile.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_310"                                    
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_310/sim/altera_xcvr_reset_top_etile.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_310"                                        
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_310/sim/altera_xcvr_ical_int_table.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_310"                                         
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_310/sim/altera_xcvr_ical_top_etile.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_310"                                         
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_310/sim/altera_xcvr_ical_etile.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_310"                                             
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_310/sim/altera_xcvr_pma_spico_reset_etile.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_310"                                  
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_310/sim/altera_xcvr_native_dskw_pam4.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_310"                                       
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_310/sim/alt_xcvr_resync_etile.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_310"                                              
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_310/sim/altera_std_synchronizer_nocut_etile.v"]\"  -work xcvrnphy_fme_310"                                                                 
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_310/sim/seriallite4_dup_xcvrnphy_fme_310_jgoac3q.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_310"                           
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_310/sim/alt_xcvr_native_rcfg_opt_logic_jgoac3q.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_310"                             
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/seriallite4_dup_alt_ehipc3_fm_xcvrnphy_fme_2020_lv2sskq.v"]\"  -work alt_ehipc3_fm_2020"                                         
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/seriallite4_dup_alt_ehipc3_fm_2020_ye25boy.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                     
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_package.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                          
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_dr_package.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                          
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_dp_mux.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                           
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_clock_mon.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                        
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_ml_soft.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                          
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_ehip_sync_fifo_rk.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_kpfec_cadence_gen.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_rcfg_arb.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                            
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/checker_fifo.v"]\"  -work alt_ehipc3_fm_2020"                                                                                    
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/reset_timer.v"]\"  -work alt_ehipc3_fm_2020"                                                                                     
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/test_harness.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                                   
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/xgmii_sink.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                                     
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/xgmii_src.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                                      
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/pcs_scfifo_mlab.v"]\"  -work alt_ehipc3_fm_2020"                                                                                 
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_100g_4w_aligner.v"]\"  -work alt_ehipc3_fm_2020"                                                                   
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_100g_adapter_data_aligner.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                        
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_100g_adapter_data_aligner_async.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                  
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_100g_adapter_rptr_addgen.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                         
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_100g_adapter_rx.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                  
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_100g_adapter_rx_async.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                            
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_100g_adapter_tx.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                  
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_100g_adapter_tx_async.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                            
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_100g_adapter_wptr_addgen.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                         
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_100g_avalon_to_if.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_100g_block_buffer.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_100g_fifo_coupler.v"]\"  -work alt_ehipc3_fm_2020"                                                                 
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_100g_gb_4to8.v"]\"  -work alt_ehipc3_fm_2020"                                                                      
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_100g_gearbox.v"]\"  -work alt_ehipc3_fm_2020"                                                                      
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_100g_if_to_avst.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                  
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_100g_rx_aligner.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                  
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_accumulators.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                     
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_altera_std_synchronizer_nocut.v"]\"  -work alt_ehipc3_fm_2020"                                                     
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_block_gearbox.v"]\"  -work alt_ehipc3_fm_2020"                                                                     
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_data_sync.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                        
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_dcfifo_mlab.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                      
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_delay_reg.v"]\"  -work alt_ehipc3_fm_2020"                                                                         
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_dropped_frame_count.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                              
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_if_filter5.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                       
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_mlab.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                             
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_pointer_synchronizer.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                             
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_preamble_filter2.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                 
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_reset_synchronizer.v"]\"  -work alt_ehipc3_fm_2020"                                                                
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_scfifo_mlab.v"]\"  -work alt_ehipc3_fm_2020"                                                                       
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_adapter_rx.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                    
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_adapter_rx_async.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                              
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_adapter_tx.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                    
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_adapter_tx_async.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                              
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_avalon_to_if.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                  
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_if_to_avalon.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                  
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_word_aligner.v"]\"  -work alt_ehipc3_fm_2020"                                                                      
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_word_shifter.v"]\"  -work alt_ehipc3_fm_2020"                                                                      
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/intc_mlab6_a1r1w1_fm.v"]\"  -work alt_ehipc3_fm_2020"                                                                            
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/intc_mlab_fm.v"]\"  -work alt_ehipc3_fm_2020"                                                                                    
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/intc_sync6_m_fm.v"]\"  -work alt_ehipc3_fm_2020"                                                                                 
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_mac_enable_avmm.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                  
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_pause.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                         
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sm_recover.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                       
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_rx_deskew.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                        
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_tx_deskew.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                        
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_word_delay_mlab.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                  
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_alias_csr.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                        
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_avmm_32to8.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                       
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_csr.v"]\"  -work alt_ehipc3_fm_2020"                                                                               
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_avmm_32to8.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                    
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_clock_crosser.v"]\"  -work alt_ehipc3_fm_2020"                                                                     
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_ml_ptp.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                           
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_ml_ptp_avmm_csr_bank.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                             
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_ml_ptp_ckt_cal.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                   
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_ml_ptp_convert_commands.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                          
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_ml_ptp_opcode_writer.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                             
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_ml_ptp_ref_ts_capture.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                            
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_ml_ptp_rx_tam_capture.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                            
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_ml_ptp_ts_converter.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                              
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_ml_ptp_tx_tam_capture.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                            
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_ptp_rx_ts_adj_detect.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                             
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_clock_crosser.v"]\"  -work alt_ehipc3_fm_2020"                                                                  
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_ptp.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                           
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_ptp_avmm_csr_bank.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                             
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_ptp_avmm_csr_bank_sn.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                          
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_ptp_avmm_csr_bank_sn_dbg.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                      
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_ptp_calc_tam.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                  
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_ptp_calc_tam_sn.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                               
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_ptp_ckt_cal.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                   
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_ptp_compute_ts.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_ptp_compute_ts_sn.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                             
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_ptp_convert_commands.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                          
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_ptp_opcode_writer.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                             
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_ptp_ref_ts_capture.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                            
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_ptp_ref_ts_capture_sn.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                         
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_ptp_rx_deskew.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                 
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_ptp_rx_tam_capture.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                            
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_ptp_rx_tam_capture_sn.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                         
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_ptp_sn.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                        
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_ptp_sn_dbg.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                    
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_ptp_sn_latency.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_ptp_sn_roll_over.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                              
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_ptp_sn_sclk.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                   
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_ptp_sn_tam.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                    
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_ptp_sn_wire_delay.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                             
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_ptp_sn_xd_1shot.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                               
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_ptp_sticky_register.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                           
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_ptp_sub_nano.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                  
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_ptp_tam_adj_detect.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                            
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_ptp_tam_capture_count.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                         
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_ptp_tam_capture_count_sn.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                      
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_ptp_ts_converter.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                              
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_ptp_ts_converter_sn.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                           
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_ptp_tx_tam_capture.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                            
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_ptp_tx_tam_capture_sn.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                         
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_xcvr_resync_norand_std.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                           
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_and3t0.v"]\"  -work alt_ehipc3_fm_2020"                                                                            
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_and3t1.v"]\"  -work alt_ehipc3_fm_2020"                                                                            
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_and4t0.v"]\"  -work alt_ehipc3_fm_2020"                                                                            
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_and4t1.v"]\"  -work alt_ehipc3_fm_2020"                                                                            
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_cnt6.v"]\"  -work alt_ehipc3_fm_2020"                                                                              
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_eqc15h7cfbt2.v"]\"  -work alt_ehipc3_fm_2020"                                                                      
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_eqc19h4e1fbt2.v"]\"  -work alt_ehipc3_fm_2020"                                                                     
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_eqc4h9t1.v"]\"  -work alt_ehipc3_fm_2020"                                                                          
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_eqc5h07t1.v"]\"  -work alt_ehipc3_fm_2020"                                                                         
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_eqc5h0ft1.v"]\"  -work alt_ehipc3_fm_2020"                                                                         
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_eqc5h18t1.v"]\"  -work alt_ehipc3_fm_2020"                                                                         
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_eqc5h1bt1.v"]\"  -work alt_ehipc3_fm_2020"                                                                         
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_eqc5h1ft1.v"]\"  -work alt_ehipc3_fm_2020"                                                                         
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_fmon8.v"]\"  -work alt_ehipc3_fm_2020"                                                                             
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_lut6.v"]\"  -work alt_ehipc3_fm_2020"                                                                              
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_metronome32000.v"]\"  -work alt_ehipc3_fm_2020"                                                                    
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_metronome320000.v"]\"  -work alt_ehipc3_fm_2020"                                                                   
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_mux2w1t0s0.v"]\"  -work alt_ehipc3_fm_2020"                                                                        
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_mux2w1t0s1.v"]\"  -work alt_ehipc3_fm_2020"                                                                        
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_mux2w1t0s2.v"]\"  -work alt_ehipc3_fm_2020"                                                                        
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_mux2w1t1s2.v"]\"  -work alt_ehipc3_fm_2020"                                                                        
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_mux4w1t0s0.v"]\"  -work alt_ehipc3_fm_2020"                                                                        
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_mux4w1t0s1.v"]\"  -work alt_ehipc3_fm_2020"                                                                        
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_mux4w1t1s1.v"]\"  -work alt_ehipc3_fm_2020"                                                                        
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_mux8w1t2s1.v"]\"  -work alt_ehipc3_fm_2020"                                                                        
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_ripple16.v"]\"  -work alt_ehipc3_fm_2020"                                                                          
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_addc2h0t1.v"]\"  -work alt_ehipc3_fm_2020"                                                                      
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_and2t0.v"]\"  -work alt_ehipc3_fm_2020"                                                                         
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_and2t1.v"]\"  -work alt_ehipc3_fm_2020"                                                                         
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_and3t0.v"]\"  -work alt_ehipc3_fm_2020"                                                                         
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_and4t0.v"]\"  -work alt_ehipc3_fm_2020"                                                                         
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_and4t1.v"]\"  -work alt_ehipc3_fm_2020"                                                                         
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_and8t2.v"]\"  -work alt_ehipc3_fm_2020"                                                                         
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_cnt2c.v"]\"  -work alt_ehipc3_fm_2020"                                                                          
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_delay1w2.v"]\"  -work alt_ehipc3_fm_2020"                                                                       
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_delay2w2.v"]\"  -work alt_ehipc3_fm_2020"                                                                       
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_delay3w1.v"]\"  -work alt_ehipc3_fm_2020"                                                                       
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_delay3w64c.v"]\"  -work alt_ehipc3_fm_2020"                                                                     
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_delay4w1.v"]\"  -work alt_ehipc3_fm_2020"                                                                       
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_delay5w1.v"]\"  -work alt_ehipc3_fm_2020"                                                                       
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_delay6w1.v"]\"  -work alt_ehipc3_fm_2020"                                                                       
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_descram64.v"]\"  -work alt_ehipc3_fm_2020"                                                                      
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_eq2t0.v"]\"  -work alt_ehipc3_fm_2020"                                                                          
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_eq2t1.v"]\"  -work alt_ehipc3_fm_2020"                                                                          
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_eq3t0.v"]\"  -work alt_ehipc3_fm_2020"                                                                          
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_eq3t1.v"]\"  -work alt_ehipc3_fm_2020"                                                                          
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_eq4t1.v"]\"  -work alt_ehipc3_fm_2020"                                                                          
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_eq8t1.v"]\"  -work alt_ehipc3_fm_2020"                                                                          
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_eq9t1.v"]\"  -work alt_ehipc3_fm_2020"                                                                          
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_eqc4hft1.v"]\"  -work alt_ehipc3_fm_2020"                                                                       
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_eqc5h1bt1.v"]\"  -work alt_ehipc3_fm_2020"                                                                      
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_eqc5h1dt1.v"]\"  -work alt_ehipc3_fm_2020"                                                                      
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_eqc9h1fbt2.v"]\"  -work alt_ehipc3_fm_2020"                                                                     
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_eqc9h1fdt2.v"]\"  -work alt_ehipc3_fm_2020"                                                                     
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_etag.v"]\"  -work alt_ehipc3_fm_2020"                                                                           
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_ethdec.v"]\"  -work alt_ehipc3_fm_2020"                                                                         
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_ethenc.v"]\"  -work alt_ehipc3_fm_2020"                                                                         
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_lut6.v"]\"  -work alt_ehipc3_fm_2020"                                                                           
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_mlab.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                          
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_mlab64a2r1w1.v"]\"  -work alt_ehipc3_fm_2020"                                                                   
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_mx16r.v"]\"  -work alt_ehipc3_fm_2020"                                                                          
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_mx4r.v"]\"  -work alt_ehipc3_fm_2020"                                                                           
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_or2t0.v"]\"  -work alt_ehipc3_fm_2020"                                                                          
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_or2t1.v"]\"  -work alt_ehipc3_fm_2020"                                                                          
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_or4t0.v"]\"  -work alt_ehipc3_fm_2020"                                                                          
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_or4t1.v"]\"  -work alt_ehipc3_fm_2020"                                                                          
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_or_r.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                          
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_scram64.v"]\"  -work alt_ehipc3_fm_2020"                                                                        
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_subc2h0t1.v"]\"  -work alt_ehipc3_fm_2020"                                                                      
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_xor1t0.v"]\"  -work alt_ehipc3_fm_2020"                                                                         
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_xor1t1.v"]\"  -work alt_ehipc3_fm_2020"                                                                         
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_xor2t0.v"]\"  -work alt_ehipc3_fm_2020"                                                                         
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_xor2t1.v"]\"  -work alt_ehipc3_fm_2020"                                                                         
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_xor3t0.v"]\"  -work alt_ehipc3_fm_2020"                                                                         
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_xor3t1.v"]\"  -work alt_ehipc3_fm_2020"                                                                         
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_xor4t0.v"]\"  -work alt_ehipc3_fm_2020"                                                                         
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_status_sync.v"]\"  -work alt_ehipc3_fm_2020"                                                                       
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sync1r1.v"]\"  -work alt_ehipc3_fm_2020"                                                                           
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_ehip_rst.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                         
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_reset_controller.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                 
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_rx_ch_rst.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                        
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_tx_ch_rst.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                        
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_sl_soft.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                          
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2020/sim/alt_ehipc3_fm_hard_ye25boy.sv"]\" -L altera_common_sv_packages -work alt_ehipc3_fm_2020"                                     
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../seriallite4_phy_top_131/sim/seriallite4_dup_seriallite4_phy_top_131_xdcmjui.v"]\"  -work seriallite4_phy_top_131"                                       
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../seriallite4_131/sim/seriallite4_dup_seriallite4_131_6vfr2ty.v"]\"  -work seriallite4_131"                                                               
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/seriallite4_dup.v"]\"  -work seriallite4_dup"                                                                                                              
    return $design_files
  }
  
  proc get_elab_options {SIMULATOR_TOOL_BITNESS} {
    set ELAB_OPTIONS ""
    if ![ string match "bit_64" $SIMULATOR_TOOL_BITNESS ] {
    } else {
    }
    return $ELAB_OPTIONS
  }
  
  
  proc get_sim_options {SIMULATOR_TOOL_BITNESS} {
    set SIM_OPTIONS ""
    if ![ string match "bit_64" $SIMULATOR_TOOL_BITNESS ] {
    } else {
    }
    return $SIM_OPTIONS
  }
  
  
  proc get_env_variables {SIMULATOR_TOOL_BITNESS} {
    set ENV_VARIABLES [dict create]
    set LD_LIBRARY_PATH [dict create]
    dict set ENV_VARIABLES "LD_LIBRARY_PATH" $LD_LIBRARY_PATH
    if ![ string match "bit_64" $SIMULATOR_TOOL_BITNESS ] {
    } else {
    }
    return $ENV_VARIABLES
  }
  
  
  proc normalize_path {FILEPATH} {
      if {[catch { package require fileutil } err]} { 
          return $FILEPATH 
      } 
      set path [fileutil::lexnormalize [file join [pwd] $FILEPATH]]  
      if {[file pathtype $FILEPATH] eq "relative"} { 
          set path [fileutil::relative [pwd] $path] 
      } 
      return $path 
  } 
}
