# (C) 2001-2020 Intel Corporation. All rights reserved.
# Your use of Intel Corporation's design tools, logic functions and other 
# software and tools, and its AMPP partner logic functions, and any output 
# files from any of the foregoing (including device programming or simulation 
# files), and any associated documentation or information are expressly subject 
# to the terms and conditions of the Intel Program License Subscription 
# Agreement, Intel FPGA IP License Agreement, or other applicable 
# license agreement, including, without limitation, that your use is for the 
# sole purpose of programming logic devices manufactured by Intel and sold by 
# Intel or its authorized distributors.  Please refer to the applicable 
# agreement for further details.


# (C) 2001-2019 Intel Corporation. All rights reserved.
# Your use of Intel Corporation's design tools, logic functions and other 
# software and tools, and its AMPP partner logic functions, and any output 
# files from any of the foregoing (including device programming or simulation 
# files), and any associated documentation or information are expressly subject 
# to the terms and conditions of the Intel Program License Subscription 
# Agreement, Intel FPGA IP License Agreement, or other applicable 
# license agreement, including, without limitation, that your use is for the 
# sole purpose of programming logic devices manufactured by Intel and sold by 
# Intel or its authorized distributors.  Please refer to the applicable 
# agreement for further details.


# (C) 2001-2019 Intel Corporation. All rights reserved.
# Your use of Intel Corporation's design tools, logic functions and other 
# software and tools, and its AMPP partner logic functions, and any output 
# files from any of the foregoing (including device programming or simulation 
# files), and any associated documentation or information are expressly subject 
# to the terms and conditions of the Intel Program License Subscription 
# Agreement, Intel FPGA IP License Agreement, or other applicable 
# license agreement, including, without limitation, that your use is for the 
# sole purpose of programming logic devices manufactured by Intel and sold by 
# Intel or its authorized distributors.  Please refer to the applicable 
# agreement for further details.


# (C) 2001-2018 Intel Corporation. All rights reserved.
# Your use of Intel Corporation's design tools, logic functions and other 
# software and tools, and its AMPP partner logic functions, and any output 
# files from any of the foregoing (including device programming or simulation 
# files), and any associated documentation or information are expressly subject 
# to the terms and conditions of the Intel Program License Subscription 
# Agreement, Intel FPGA IP License Agreement, or other applicable 
# license agreement, including, without limitation, that your use is for the 
# sole purpose of programming logic devices manufactured by Intel and sold by 
# Intel or its authorized distributors.  Please refer to the applicable 
# agreement for further details.



#**************************************************************
# Time Information
#**************************************************************

set_time_format -unit ns -decimal_places 3



#**************************************************************
# Create Clock
#**************************************************************

# Reference clock to transceivers - Generate through create_base_clocks
create_clock -period "156.25 MHz" -name pll_ref_clk [get_ports QSFPDDB_REFCLK_p]

# Management clock driving the Interlaken PHY IP management module.
create_clock -period "100 MHz" -name mgmt_clk [get_ports CLK_100_B2A]

# Clocks generated by the PLL.
derive_clock_uncertainty

#**************************************************************
# Timing exceptions
#**************************************************************
#Clock group
set_clock_groups -asynchronous -group [get_clocks {mgmt_clk}] -group [get_clocks ALTERA_INSERTED_INTOSC_FOR_TRS|divided_osc_clk]
set_clock_groups -asynchronous -group [get_clocks {mgmt_clk}] -group [get_clocks {u0|seriallite4_io_pll_outclk0}]
set_clock_groups -asynchronous -group [get_clocks {mgmt_clk}] -group [get_clocks {u0|seriallite4_io_pll_refclk}]

#PAM4
set_clock_groups -asynchronous -group [get_clocks ALTERA_INSERTED_INTOSC_FOR_TRS|divided_osc_clk]  -group [get_clocks {*|inst_sl4_phy|inst_ehip_xcvr0|alt_ehipc3_fm_hard_inst|E100GX4_FEC.altera_xcvr_native_inst|xcvr_native_s10_etile_0_example_design_4ln_ptp|tx_clkout|ch0}]
set_clock_groups -asynchronous -group [get_clocks {u0|seriallite4_io_pll_outclk0}]  -group [get_clocks {*|inst_sl4_phy|inst_ehip_xcvr0|alt_ehipc3_fm_hard_inst|E100GX4_FEC.altera_xcvr_native_inst|xcvr_native_s10_etile_0_example_design_4ln_ptp|tx_clkout|ch0}]


# False path to synchronizers in top-level, traffic_gen, traffic_check & demo_mgmt
set_false_path -to [get_cells -compatibility {traffic_gen*dp_sync_stage_1|o[0]}]

set_false_path -from {slave_mode_sync|dreg[1]} -to {seriallite_iv_streaming_inst|seriallite4_dup|inst_rx_mac|data_error}
set_false_path -to {demo_mgmt|src_fatal_errors_csr[*]}
set_false_path -to {demo_mgmt|src_correctable_errors_csr[*]}


# user clk reset synchronizer to core clk async reset
set_min_delay -from [get_registers tx_dcfifo_ecc|dcfifo_ecc|raddr_g_completed*] -to [get_registers tx_dcfifo_ecc|dcfifo_ecc|sync_sr1*sr1|din_s1] -100
set_min_delay -from [get_registers tx_dcfifo_ecc|dcfifo_ecc|waddr_g_completed*] -to [get_registers tx_dcfifo_ecc|dcfifo_ecc|sync_sr0*sr0|din_s1] -100
set_max_delay -from [get_registers tx_dcfifo_ecc|dcfifo_ecc|raddr_g_completed*] -to [get_registers tx_dcfifo_ecc|dcfifo_ecc|sync_sr1*sr1|din_s1] 100
set_max_delay -from [get_registers tx_dcfifo_ecc|dcfifo_ecc|waddr_g_completed*] -to [get_registers tx_dcfifo_ecc|dcfifo_ecc|sync_sr0*sr0|din_s1] 100
set_net_delay -from [get_registers tx_dcfifo_ecc|dcfifo_ecc|raddr_g_completed*] -to [get_registers tx_dcfifo_ecc|dcfifo_ecc|sync_sr1*sr1|din_s1] -max 2
set_net_delay -from [get_registers tx_dcfifo_ecc|dcfifo_ecc|waddr_g_completed*] -to [get_registers tx_dcfifo_ecc|dcfifo_ecc|sync_sr0*sr0|din_s1] -max 2
set_max_skew -from [get_registers tx_dcfifo_ecc|dcfifo_ecc|raddr_g_completed*] -to [get_registers tx_dcfifo_ecc|dcfifo_ecc|sync_sr1*sr1|din_s1] -get_skew_value_from_clock_period src_clock_period -skew_value_multiplier 0.8
set_max_skew -from [get_registers tx_dcfifo_ecc|dcfifo_ecc|waddr_g_completed*] -to [get_registers tx_dcfifo_ecc|dcfifo_ecc|sync_sr0*sr0|din_s1] -get_skew_value_from_clock_period src_clock_period -skew_value_multiplier 0.8

#false path from ISSP nodes
# set_false_path -from {demo_control|measure_time_pio|pio_1|data_out*} -to {clk_cycle_period.*}
set_max_delay -from [get_registers demo_control|issp|in_system_sources_probes_0|issp_impl|altsource_probe_body_inst|wider_source_gen.wider_source_inst|cdc_gen.src_cdc_gen.src_cdc|stp_status_bits_out_reg_tck[1]] -to [get_registers sync_issp_rx_core_rst|din_s1] 100
set_min_delay -from [get_registers demo_control|issp|in_system_sources_probes_0|issp_impl|altsource_probe_body_inst|wider_source_gen.wider_source_inst|cdc_gen.src_cdc_gen.src_cdc|stp_status_bits_out_reg_tck[1]] -to [get_registers sync_issp_rx_core_rst|din_s1] -100

set_max_delay -from [get_registers demo_control|issp|in_system_sources_probes_0|issp_impl|altsource_probe_body_inst|wider_source_gen.wider_source_inst|cdc_gen.src_cdc_gen.src_cdc|stp_status_bits_out_reg_tck[2]] -to [get_registers sync_issp_tx_core_rst|din_s1] 100
set_min_delay -from [get_registers demo_control|issp|in_system_sources_probes_0|issp_impl|altsource_probe_body_inst|wider_source_gen.wider_source_inst|cdc_gen.src_cdc_gen.src_cdc|stp_status_bits_out_reg_tck[2]] -to [get_registers sync_issp_tx_core_rst|din_s1] -100

set_max_delay -from [get_registers demo_control|issp|in_system_sources_probes_0|issp_impl|altsource_probe_body_inst|wider_source_gen.wider_source_inst|cdc_gen.src_cdc_gen.src_cdc|stp_status_bits_out_reg_tck[3]] -to [get_registers sync_issp_fec_phy_rst|din_s1] 100
set_min_delay -from [get_registers demo_control|issp|in_system_sources_probes_0|issp_impl|altsource_probe_body_inst|wider_source_gen.wider_source_inst|cdc_gen.src_cdc_gen.src_cdc|stp_status_bits_out_reg_tck[3]] -to [get_registers sync_issp_fec_phy_rst|din_s1] -100

set_max_delay -from [get_registers demo_control|issp|in_system_sources_probes_0|issp_impl|altsource_probe_body_inst|wider_source_gen.wider_source_inst|cdc_gen.src_cdc_gen.src_cdc|stp_status_bits_out_reg_tck[4]] -to [get_registers sync_issp_n4|din_s1] 100
set_min_delay -from [get_registers demo_control|issp|in_system_sources_probes_0|issp_impl|altsource_probe_body_inst|wider_source_gen.wider_source_inst|cdc_gen.src_cdc_gen.src_cdc|stp_status_bits_out_reg_tck[4]] -to [get_registers sync_issp_n4|din_s1] -100

set_max_delay -from [get_registers demo_control|issp|in_system_sources_probes_0|issp_impl|altsource_probe_body_inst|wider_source_gen.wider_source_inst|cdc_gen.src_cdc_gen.src_cdc|stp_status_bits_out_reg_tck[5]] -to [get_registers sync_issp_n5|din_s1] 100
set_min_delay -from [get_registers demo_control|issp|in_system_sources_probes_0|issp_impl|altsource_probe_body_inst|wider_source_gen.wider_source_inst|cdc_gen.src_cdc_gen.src_cdc|stp_status_bits_out_reg_tck[5]] -to [get_registers sync_issp_n5|din_s1] -100
set_max_delay -from [get_registers demo_control|issp|in_system_sources_probes_0|issp_impl|altsource_probe_body_inst|wider_source_gen.wider_source_inst|cdc_gen.src_cdc_gen.src_cdc|stp_status_bits_out_reg_tck[7]] -to [get_registers sync_issp_n7|din_s1] 100
set_min_delay -from [get_registers demo_control|issp|in_system_sources_probes_0|issp_impl|altsource_probe_body_inst|wider_source_gen.wider_source_inst|cdc_gen.src_cdc_gen.src_cdc|stp_status_bits_out_reg_tck[7]] -to [get_registers sync_issp_n7|din_s1] -100

set_max_delay -from [get_registers demo_control|issp|in_system_sources_probes_0|issp_impl|altsource_probe_body_inst|wider_source_gen.wider_source_inst|cdc_gen.src_cdc_gen.src_cdc|stp_status_bits_out_reg_tck[8]] -to [get_registers sync_issp_n8|din_s1] 100
set_min_delay -from [get_registers demo_control|issp|in_system_sources_probes_0|issp_impl|altsource_probe_body_inst|wider_source_gen.wider_source_inst|cdc_gen.src_cdc_gen.src_cdc|stp_status_bits_out_reg_tck[8]] -to [get_registers sync_issp_n8|din_s1] -100

#PIO false path
set_false_path -from {demo_mgmt|demo_ctrl_stat_csr[5]}
set_false_path -from {payload*} -to {demo_control|measure_payload_pio_*|readdata*}
set_false_path -from {start_time_cnt*} -to {demo_control|rx_coreclk_cnt_pio|pio_4|readdata*}
set_false_path -from {seriallite_iv_streaming_inst|seriallite4_dup|inst_rx_mac|rx_deskew_inst|rx_lanes_aligned} -to {demo_control|system_status_pio|pio_0|readdata*}
set_false_path -from {seriallite_iv_streaming_inst|seriallite4_dup|inst_tx_mac|tx_soft_bond_inst|phy_ehip_ready_inst|u|dreg[0]} -to {demo_control|system_status_pio|pio_0|readdata*}
set_false_path -from { demo_control|measure_time_pio|pio_1|data_out*} -to {stop_count}
#delay from mgmt clk to fast coreclk domain
set alt_ehipc3_reset_controller_inst alt_ehipc3_fm_reset_controller_inst
set_max_delay -from [get_registers seriallite_iv_streaming_inst|seriallite4_dup|inst_sl4_phy|inst_ehip_xcvr*|RST_CTRL_100G.$alt_ehipc3_reset_controller_inst|ehip_ready_out] -to [get_registers sync_tx_ehip_ready|din_s1] 100
set_min_delay -from [get_registers seriallite_iv_streaming_inst|seriallite4_dup|inst_sl4_phy|inst_ehip_xcvr*|RST_CTRL_100G.$alt_ehipc3_reset_controller_inst|ehip_ready_out] -to [get_registers sync_tx_ehip_ready|din_s1] -100

set_max_delay -from [get_registers seriallite_iv_streaming_inst|seriallite4_dup|inst_sl4_phy|inst_ehip_xcvr*|RST_CTRL_100G.$alt_ehipc3_reset_controller_inst|rx_eth_ready] -to [get_registers sync_rx_pcs_ready|din_s1] 100
set_min_delay -from [get_registers seriallite_iv_streaming_inst|seriallite4_dup|inst_sl4_phy|inst_ehip_xcvr*|RST_CTRL_100G.$alt_ehipc3_reset_controller_inst|rx_eth_ready] -to [get_registers sync_rx_pcs_ready|din_s1] -100

set_false_path -from {sync_issp_fec_phy_rst|dreg[1]} -to [get_registers seriallite_iv_streaming_inst|seriallite4_dup|inst_sl4_phy|inst_ehip_xcvr*|RST_CTRL_100G.$alt_ehipc3_reset_controller_inst|status_tx_reset_synchronizers|resync_chains[0].synchronizer_nocut|din_s1]
set_false_path -from {sync_issp_fec_phy_rst|dreg[1]} -to [get_registers seriallite_iv_streaming_inst|seriallite4_dup|inst_sl4_phy|inst_ehip_xcvr*|RST_CTRL_100G.$alt_ehipc3_reset_controller_inst|status_rx_reset_synchronizers|resync_chains[0].synchronizer_nocut|din_s1]

set_max_delay -from [get_registers seriallite_iv_streaming_inst|seriallite4_dup|inst_sl4_phy|inst_ehip_xcvr*|DESKEW.PCSDIRECT.rx_pcs64_dsk_inst|o_deskew_done] -to [get_registers seriallite_iv_streaming_inst|seriallite4_dup|inst_sl4_phy|inst_ehip_xcvr*|RST_CTRL_100G.$alt_ehipc3_reset_controller_inst|ready_synchronizers|resync_chains[3].synchronizer_nocut|din_s1] 100
set_min_delay -from [get_registers seriallite_iv_streaming_inst|seriallite4_dup|inst_sl4_phy|inst_ehip_xcvr*|DESKEW.PCSDIRECT.rx_pcs64_dsk_inst|o_deskew_done] -to [get_registers seriallite_iv_streaming_inst|seriallite4_dup|inst_sl4_phy|inst_ehip_xcvr*|RST_CTRL_100G.$alt_ehipc3_reset_controller_inst|ready_synchronizers|resync_chains[3].synchronizer_nocut|din_s1] -100


#false path to first stage of reset synchronizer
set_false_path -from {*seriallite4_io_pll*} -to {iopll_locked_user_clk_sync|din_s1}
#------------------------------------end--------------------------------------------

  set waive_min_pulse_grp1 [get_registers -no_case "dcfifo_rx_data|seriallite4_dcfifo|dcfifo_component|auto_generated|fifo_altera_syncram|altera_syncram_impl1|*ram_block*"]
  
  set waive_min_pulse_grp2 [get_registers -no_case "tx_dcfifo_ecc|dcfifo_ecc|rlp*|altsyncram_component|auto_generated|altera_syncram_impl1|*ram_block*"]
  
  foreach_in_collection reg $waive_min_pulse_grp1 {
    disable_min_pulse_width $reg
  }
  
  foreach_in_collection reg $waive_min_pulse_grp2 {
    disable_min_pulse_width $reg
  }



